/*
*	$id:ckForm.js (c)A.Ida 2017/3/10 15:37:31
*	フォーム内のTEXTタイプのINPUTの内容チェックを行う
*	JavaScrypt内でINCLUDEして使う
*	INPUT:
*		cForm - documentのFormオブジェクト
*		pary - 各TEXTで行うチェック内容の論理和の配列
*			1 : 必須入力
*			2 : 半角数値文字のみであるか
*			4 : 桁数がnaryの値と同値であるか
*			8 : ヘッドゼロ処理（naryに満たない場合に不足桁数分ヘッドゼロする。チェックではなく変換処理の指定）
*			16: 半角英数のみ
*		nary - 桁数の配列
*		name - paramというnameのHIDDEN型オブジェクトのValueに代入する値。複数のbuttonで呼び出す場合の判別用
*	RETURN :
*		チェックで問題なければsubmit()してtrue
*		問題があれば問題のelementの色を変えてフォーカスセットしてfalse
*/
function ckForm(cForm, pary, nary, name)
{
	var max = cForm.elements.length;
	var i=0;
	for (var j=0;j < max;j++) {
		if(cForm.elements[j].type){
			if (cForm.elements[j].type != "text") {
				if (cForm.elements[j].type != "password") {
					if (cForm.elements[j].type != "textarea") {
						if (cForm.elements[j].type != "file") {
							continue;
						}
					}
				}
			}
		}else{
			continue;
		}
		
		var flg = false;
		cForm.elements[j].style.backgroundColor  = "#FFFFFF";
		var v = cForm.elements[j].value
		if (pary[i] & 1) {
		// 必須項目 
			if (v == "") {
	  			alert("必須入力です");
				break;
			}
		}
		if (pary[i] & 2) {
		// 数値
			if (v != "" ){
				if (isNaN(parseInt(v))) {
					alert("半角数字文字でなければなりません");
					break;
				}
			}
		}
		if (pary[i] & 4) {
		// 桁数
			if (v.length != nary[i]) {
				alert("桁数が不足しています");
				break;
			}
		}
		if (pary[i] & 8) {
		// ヘッドゼロ
			if (v.length < nary[i]) {
				for (k=v.length;k<nary[i];k++) {
					v = "0" + v;
				}
				cForm.elements[j].value = v;
			}
		}
		if (pary[i] & 16) {
		// 半角のみ
			for (cnt=0; cnt < v.length; cnt++){
				c = v.charAt(cnt);
				if ((c < '0' || c > '9') && (c < 'a' || c > 'z') && (c < 'A' || c > 'Z') && (c != '_') && (c != '-')){
					alert("半角英数のみを使用してください\n半角記号は _ と - のみ使用できます");
					break;
				}
			}
			if (cnt < v.length){
				break;
			}
		}
		i++;
	}
	if (j != max) {
		cForm.elements[j].style.backgroundColor  = "palegoldenrod";
		cForm.elements[j].focus();
		flg = false;
	} else {
		if (name.length != 0) {
			cForm.param.value = name;
		}
		cForm.submit();
		flg = true;
	}
	return flg;
};

/*
*	一括変更用確認処理
*/
function ckeff_sel(elm){
	var bret = false;
	if(elm){
		if(elm.value != -1){
			bret = true;
		}
	}
	return bret;
};
function ckeff_txt(elm, elm2){
	var bret = false;
	if(elm){
		if(elm.value.length > 0){
			if(elm.value != elm2.value){
				bret = true;
			}
		}
	}
	return bret;
};
function ckLump(cForm){
	var bret = true;
	if(ckeff_sel(cForm.sclass) == false){
		if(ckeff_txt(cForm.prestr, cForm.aftstr) == false){
			if(ckeff_sel(cForm.charge1) == false){
				if(ckeff_sel(cForm.charge2) == false){
					if(ckeff_sel(cForm.simp) == false){
						if(ckeff_sel(cForm.sdif) == false){
							if((ckeff_sel(cForm.syear) == false) || (ckeff_sel(cForm.smonth) == false) || (ckeff_sel(cForm.sday) == false)){
								bret = false;
							}
						}
					}
				}
			}
		}
	}
	if(bret == false){
		alert("変更点が何も指定されていません。");
	}else{
		bret = confirm("一括変更を実行します。変更は取り消せません。よろしいですか？");
	}
	return bret;
};

/*
* メールアドレス書式確認
*/
function ckEmail(mail){
	var bret = false;
	if(mail.match("^[0-9A-Za-z._]+@[0-9A-Za-z.]+$")){
		bret = true;
	}
	return bret;
}

