/*
*	$id:ckForm.inc (c)A.Ida 2017/3/10 15:37:31
*	フォーム内のTEXTタイプのINPUTの内容チェックを行う
*	JavaScrypt内でINCLUDEして使う
*	INPUT:
*		cForm - documentのFormオブジェクト
*		pary - 各TEXTで行うチェック内容の論理和の配列
*			1 : 必須入力
*			2 : 半角数値文字のみであるか
*			4 : 桁数がnaryの値と同値であるか
*			8 : ヘッドゼロ処理（naryに満たない場合に不足桁数分ヘッドゼロする。チェックではなく変換処理の指定）
*			16: 半角英数のみ
*		nary - 桁数の配列
*		name - paramというnameのHIDDEN型オブジェクトのValueに代入する値。複数のbuttonで呼び出す場合の判別用
*	RETURN :
*		チェックで問題なければsubmit()してtrue
*		問題があれば問題のelementの色を変えてフォーカスセットしてfalse
*/
function ckForm(cForm, pary, nary, name)
{
	var max = cForm.elements.length;
	var i=0;
	for (var j=0;j < max;j++) {
		if(cForm.elements[j].type){
			if (cForm.elements[j].type != "text") {
				if (cForm.elements[j].type != "password") {
					if (cForm.elements[j].type != "textarea") {
						if (cForm.elements[j].type != "file") {
							continue;
						}
					}
				}
			}
		}else{
			continue;
		}
		
		var flg = false;
		cForm.elements[j].style.backgroundColor  = "#FFFFFF";
		var v = cForm.elements[j].value
		if (pary[i] & 1) {
		// 必須項目 
			if (v == "") {
	  			alert("必須入力です");
				break;
			}
		}
		if (pary[i] & 2) {
		// 数値
			if (v != "" ){
				if (isNaN(parseInt(v))) {
					alert("半角数字文字でなければなりません");
					break;
				}
			}
		}
		if (pary[i] & 4) {
		// 桁数
			if (v.length != nary[i]) {
				alert("桁数が不足しています");
				break;
			}
		}
		if (pary[i] & 8) {
		// ヘッドゼロ
			if (v.length < nary[i]) {
				for (k=v.length;k<nary[i];k++) {
					v = "0" + v;
				}
				cForm.elements[j].value = v;
			}
		}
		if (pary[i] & 16) {
		// 半角のみ
			for (cnt=0; cnt < v.length; cnt++){
				c = v.charAt(cnt);
				if ((c < '0' || c > '9') && (c < 'a' || c > 'z') && (c < 'A' || c > 'Z') && (c != '_') && (c != '-')){
					alert("半角英数のみを使用してください\n半角記号は _ と - のみ使用できます");
					break;
				}
			}
			if (cnt < v.length){
				break;
			}
		}
		i++;
	}
	if (j != max) {
		cForm.elements[j].style.backgroundColor  = "palegoldenrod";
		cForm.elements[j].focus();
		flg = false;
	} else {
		if (name.length != 0) {
			cForm.param.value = name;
		}
		cForm.submit();
		flg = true;
	}
	return flg;
};
