<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */
/*
 * +----------------------------------------------------------------------+
 *| PHP version 5                                                        |
 *+----------------------------------------------------------------------+
 *| Copyright (c) 2002-2010 Atsuro.Ida                                   |
 *+----------------------------------------------------------------------+
 *+----------------------------------------------------------------------+
 *| Authors: Atsuro.Ida <iserlown@pop06.odn.ne.jp>                       |
 *+----------------------------------------------------------------------+
 *
*	$id:ti_Donation.inc (c)A.Ida 2017/3/10 15:37:31
 *
 * ライセンスファイル評価とセッション変数初期化
 */

class Ti_Donation
{
	var $lic_regist = 0;
	var $lic_cdatas = array();
	var $lic_ckeys = array();
	var $lic_odatas = array();
	var $lic_okeys = array();
	var $lic_user = "TRYOUT";
	var $lic_uid = 0;
	var $lic_p_maxrow = 40;
	var $cnv;

	function Ti_Donation()
	{
		$this->cnv = new ti_jconv;
		mb_regex_encoding($this->cnv->C_CODE);
		$fname = "tiDonation.xml";
		$fdona = "tiDonation.stp";
		if (file_exists($fname)){
			$xml = xml_parser_create("UTF-8");
			xml_set_object($xml, $this);
			xml_parser_set_option($xml, XML_OPTION_CASE_FOLDING, false);
			xml_set_element_handler($xml,"hndStart","hndEnd");
			xml_set_character_data_handler($xml,"hndData");
		
			if ($fp = fopen($fname,"r")){
				while($line = fread($fp, 4096)){
					if(!xml_parse($xml,$line,feof($fp))){
						$msg = "<font color='red'>ライセンスファイルの解析エラーです。</font><br>\n";
						$msg .= xml_error_string(xml_get_error_code($xml));
						$msg .= ":行(" . xml_get_current_line_number($xml) . ")<br>\n";
						print($msg);
						break;
					}
				}
			}
			xml_parser_free($xml);
		}else if (file_exists($fdona)){
			$this->lic_regist = 1;
			$this->lic_user = "GENERAL";
			$this->lic_uid = "1";
		}
	}

	// データ部処理関数
	function hndData($hdl, $data){
		global	$g_data;
		$g_data = $data;
	}
	
	function getAttr($attrs, $name){
		return (isset($attrs[$name]) ? $attrs[$name] : null);
	}
	
	// 開始タグ
	function hndStart($hdl, $name, $attrs){
		global	$g_id;
		global	$g_valid;
		global	$g_key;
//		$g_id = $attrs["id"];
		$g_id = $this->getAttr($attrs, "id");
		$g_valid = $this->getAttr($attrs, "valid");
		$g_key = $this->getAttr($attrs,"key");
	}
	
	// 終了タグ
	function hndEnd($hdl, $name){
		global	$g_id;
		global	$g_valid;
		global	$g_key;
		global	$g_data;
	
		switch($name){
		case 'USER':
		//	$this->lic_user = mb_convert_encoding($g_data,"EUC-JP","UTF-8,SJIS,JIS,EUC-JP");
			$this->lic_user = $this->cnv->to_base($g_data);
			$this->lic_uid = $g_key;
			break;
		case 'DONATION':
			switch(md5($g_data)){
			case '00d06796e489999226fb5bb27fe1b3b2':
				$this->lic_regist = $g_key;
				break;
			default:
				$this->lic_regist = 0;
				break;
			}
			break;
		case 'CUST':
			if($this->lic_regist){
				if($g_valid){
					$this->lic_cdatas[$g_id] = $g_data;
					$this->lic_ckeys[$g_id] = $g_key;
				}
			}
			break;
		case 'OPT':
			if($this->lic_regist){
				if($g_valid){
				//	$data = mb_convert_encoding($g_data,"EUC-JP","UTF-8,SJIS,JIS,EUC-JP");
					$data = $this->cnv->to_base($g_data);
					$data = mb_ereg_replace("%%KEY%%", $g_key, $data);
					$this->lic_odatas[$g_id] = $data;
					$this->lic_okeys[$g_id] = $g_key;
				}
			}
			break;
		case 'ROW':
			$iwk = $g_data / 10;
			if($iwk < 1){
				$iwk = 1;
			}else if($iwk > 9){
				$iwk = 9;
			}
			$iwk *= 10;
			$this->lic_p_maxrow = $iwk;
			break;
		default:
			break;
		}
	}
}

class ti_lic
{
	var $lic;
	var $key;
	
	function ti_lic()
	{
		if (isset($_SESSION["lic"]))
		{
			$this->lic = $_SESSION["lic"];
		}else{
			$this->lic = null;
		}
	}
	
	function getMaxRow()
	{
		$res = 40;
		if ($this->lic)
		{
			$res = $this->lic->lic_p_maxrow;
		}
		return $res;
	}
	
	function getOkey($id)
	{
		$res = false;
		if ($this->lic)
		{
			$res = isset($this->lic->lic_okeys[$id]);
			if ($res){
				$this->key = $this->lic->lic_okeys[$id];
			}
		}
		return $res;
	}
	
	function ynItemId()
	{
		return $this->getOkey("item_id");
	}
	
	function chkItemId($k)
	{
		$ik = (int)($k);
		$res = $this->ynItemId();
		if ($res)
		{
			if ((((int)($this->key)) & $ik) != $ik)
			{
				$res = false;
			}
		}
		return $res;
	}
	
	function ynDupOpe()
	{
		return $this->getOkey("dup_ope");
	}
	
	function ynRunCard()
	{
		return $this->getOkey("run_card");
	}
	
	function ynMkiPlan()
	{
		return $this->getOkey("mki_plan");
	}
	
	function ynPgsLst()
	{
		return $this->getOkey("pgs_lst");
	}
	
	function ynAnaSum()
	{
		return $this->getOkey("ana_sum");
	}
	
	function ynIdleSec()
	{
		return $this->getOkey("idle_sec");
	}

	function ynIniPsel()
	{
		return $this->getOkey("ini_psel");
	}
	
	function ynSelCur()
	{
		return $this->getOkey("sel_cur");
	}
	
	function ynMkiSize()
	{
		return $this->getOkey("mki_size");
	}
}
?>
