<?php
/*
*	$id:ti_convers.inc (c)A.Ida 2017/3/10 15:37:31
*	会話ＤＢ制御クラス
*/
class ti_convers {
	var $p_db;
	var $p_estr;

	var $p_ckey;
	var $p_uckey;
	var $p_pid;
	var $p_iid;
	var $p_bid;
	var $p_cid;
	var $p_name;
	var $p_subj;
	var $p_subj_;
	var $p_body;
	var $p_body_;
	var $p_dwrite;
	var $p_cid_a;
	var $p_name_a;
	var $p_dterm;
	var $p_dread;
	var $p_ans;
	var $p_uid;

	// コンストラクタ
	function ti_convers($db){
		$this->p_db = $db;
		$this->p_estr = "";
	}

	// 0 -> NULL
	function toSQL($in) {
		if($in == 0){
			$ret = "NULL, ";
		}else{
			$ret = sprintf("%d, ",$in);
		}
		return $ret;
	}

	// 会話書き込み
	function InsConv($uckey,$pid,$iid,$bid,$cid,$subj,$body,$cid_a = "",$y,$m,$d){
		$ret = false;
		
		$this->p_db->Halt_On_Error = "no";
		$this->p_db->query("BEGIN");
		// 回答済みチェック
		$sSql = sprintf("SELECT count(*) AS cnt FROM tconvers WHERE nuckey = %d", $uckey);
		$this->p_db->query($sSql);
		$this->p_db->next_record();
		if($this->p_db->f("cnt") == 0){
			// nckey取得
			$sSql = "SELECT nextval('sconvers') AS nckey";
			if($this->p_db->query($sSql)){
				$this->p_db->next_record();
				$this->p_ckey = $this->p_db->f("nckey");
				
				$sSql = "INSERT INTO tconvers (";
				$sSql .= "nckey,nuckey,npid,niid,nbid,cid,csubj,cbody,dwrite,cid_a,dterm";
				$sSql .= ") VALUES (";
				$sSql .= $this->toSQL($this->p_ckey);
				$sSql .= $this->toSQL($uckey);
				$sSql .= sprintf("%d, ",$pid);
				$sSql .= $this->toSQL($iid);
				$sSql .= $this->toSQL($bid);
				$sSql .= sprintf("'%s', ",$cid);
				$sSql .= sprintf("'%s', ",addslashes($subj));
				$sSql .= sprintf("'%s', ",addslashes($body));
				$sSql .= "'NOW', ";
				if($cid_a == ""){
					$sSql .= "NULL, NULL";
				}else{
					$sSql .= sprintf("'%s', ",$cid_a);
					$sSql .= sprintf("'%d/%d/%d'",$y,$m,$d);
				}
				$sSql .= ")";
				if($this->p_db->query($sSql)){
					$ret = true;
					if($uckey > 0){
					// 質問に対する回答だった
						if($this->ckQQ($uckey, $cid)){
						// 質問が自分の質問に対する回答を兼ねていた
							// 質問への既読設定
							$ret = $this->UpRead($uckey,1);
						}
					}
				}else{
					$this->p_estr = "発言の書き込みに失敗しました。";
				}
			}else{
				$this->p_estr = "発言ＩＤの取得に失敗しました。";
			}
		}else{
			$this->p_estr = "既に回答済みのため、この発言はキャンセルされました。";
		}
		if($ret){
			$this->p_db->query("END");
		}else{
			$this->p_db->query("ROLLBACK");
		}
		return $ret;
	}
	
	// 質問が質問に対する回答であり、その質問者が自身であるかをチェック
	function ckQQ($uckey,$cid){
		$ret = false;
		$sSql = sprintf("SELECT count(*) AS cnt FROM vconvers WHERE nckey = %d AND cuid = '%s'", $uckey, $cid);
		$this->p_db->query($sSql);
		$this->p_db->next_record();
		if($this->p_db->f("cnt") > 0){
			$ret = true;
		}
		return $ret;
	}

	// 既読設定
	function UpRead($ckey, $rmode){
		$ret = false;
		$sSql = "UPDATE tconvers SET ";
		switch($rmode){
		case 0:		// 未読にする
			$sSql .= "dread = null";
			break;
		default:	// 既読にする
			$sSql .= "dread = NOW()";
			break;
		}
		$sSql .= sprintf(" WHERE nckey = '%d'", $ckey);
		if($this->p_db->query($sSql)){
			$ret = true;
		}else{
			$this->p_estr = "既読設定に失敗しました。";
		}
		return $ret;
	}

	// プロパティにレコードの内容設定
	function SetData(){
		$this->p_ckey  = $this->p_db->f("nckey");
		$this->p_uckey = $this->p_db->f("nuckey");
		$this->p_pid   = $this->p_db->f("npid");
		$this->p_iid   = $this->p_db->f("niid");
		$this->p_bid   = $this->p_db->f("nbid");
		$this->p_cid   = $this->p_db->f("cid");
		$this->p_cid_a = $this->p_db->f("cid_a");
		$this->p_subj_ = $this->p_db->f("csubj");
		$this->p_subj  = htmlspecialchars($this->p_db->f("csubj"));
		$this->p_body  = nl2br(htmlspecialchars($this->p_db->f("cbody")));
		$this->p_body_ = $this->p_db->f("cbody");
		$this->p_ans   = $this->p_db->f("nans");
		$this->p_uid   = $this->p_db->f("cuid");
	}

	// 指定投稿読込み
	function ReadOne($ckey){
		$sSql = sprintf("SELECT * FROM vconvers WHERE nckey = %d", $ckey);
		$this->p_db->query($sSql);
		if($this->p_db->next_record()){
			$this->SetData();
		}
	}

	// 読込み開始
	function ReadConvStart($pid,$iid,$bid){
		$sSql = "SELECT C.*, M.cname AS cname, M2.cname AS cname_a,"; 
		$sSql .= " TO_CHAR(C.dwrite,'YYYY/MM/DD HH24:MI') AS cwrite,";
		$sSql .= " TO_CHAR(C.dterm,'YYYY/MM/DD') AS cterm,";
		$sSql .= " TO_CHAR(C.dread,'YYYY/MM/DD') AS cread";
		$sSql .= " FROM vconvers C";
		$sSql .= " INNER JOIN muser M ON C.cid = M.cid";
		$sSql .= " LEFT JOIN muser M2 ON C.cid_a = M2.cid";
		$sSql .= sprintf(" WHERE C.npid = %d", $pid);
		if($iid > 0){
			$sSql .= sprintf(" AND C.niid = %d", $iid);
		}else{
			$sSql .= " AND C.niid IS null";
		}
		if($bid > 0){
			$sSql .= sprintf(" AND C.nbid = %d", $bid);
		}else{
			$sSql .= " AND C.nbid IS null";
		}
		$sSql .= " ORDER BY C.nckey DESC";
		$this->p_db->query($sSql);
		$this->rnum = $this->p_db->num_rows();
	}

	// 会話読込み
	function ReadConv($rno){
		$ret = -1;
		if($rno < $this->rnum){
			$this->p_db->seek($rno);
			$this->p_db->next_record();
			$this->SetData();
			$this->p_name = htmlspecialchars($this->p_db->f("cname"));
			$this->p_name_a = htmlspecialchars($this->p_db->f("cname_a"));
			$this->p_dwrite = $this->p_db->f("cwrite");
			$this->p_dterm = $this->p_db->f("cterm");
			$this->p_dread = $this->p_db->f("cread");
			$this->p_ans = $this->p_db->f("nans");
			$this->p_uid = $this->p_db->f("cuid");

			$ret = $rno;
		}
		return $ret;
	}

	// 会話読込み終了
	function ReadConvEnd(){
		// KEEP
	}
}
?>
