<?php
/*
*	$id:ti_findCls.inc (c)A.Ida 2017/3/10 15:37:31
*	検索管理クラス
*/

class ti_findcls {
	var $p_projs;
	var $p_iids;
	
	var $db;
	
	// コンストラクタ
	function ti_findcls($projs){
		$this->p_projs = $this->ary2csv($projs);
		$this->db = new DB_Ti;
	}
		
	function ary2csv($ary){
		$csv = "";
		while(list($key,$val) = each($ary)){
			if($csv != ""){
				$csv .= ", ";
			}
			$csv .= $val;
		}
		return $csv;
	}
	
	function mkChargeOpts($def_uid){
		$opts = "";
		$sSql  = sprintf("SELECT DISTINCT cid, cname FROM vpmember WHERE npid IN (%s)", $this->p_projs);
		$sSql .= " ORDER BY cname";
		$this->db->query($sSql);
		
		$opts = "<option value=\"-1\">----</option>\n";
		while($this->db->next_record()){
			$cked = "";
			$uid = $this->db->f("cid");
			if(!is_null($def_uid)){
				if($uid == $def_uid){
					$cked = " selected";
				}
			}
			$opts .= sprintf("<option value=\"%s\"%s>%s</option>\n", $uid, $cked, htmlspecialchars($this->db->f("cname")));
		}
		return $opts;
	}
	
	function is_eff($val){
		$bret = false;
		if(!is_null($val)){
			if($val != -1){
				if($val != ""){
					$bret = true;
				}
			}
		}
		return $bret;
	}
	
	function fmtWhere($sWhere, $addstr){
		if(strlen($addstr) > 0){
			$sWhere .= " AND ";
		}
		$sWhere .= $addstr;
		return $sWhere;
	}
	
	function toSign($num){
		switch($num){
		case 0:
			$si = ">=";
			break;
		case 1:
			$si = "<=";
			break;
		default:
			$si = "=";
			break;
		}
		return $si;
	}
	
	function toDateStr($y,$m,$d){
		$dstr = "";
		if($this->is_eff($y)){
			if($this->is_eff($m)){
				if($this->is_eff($d)){
					$dstr = sprintf("%04d-%02d-%02d", $y, $m, $d);
				}
			}
		}
		return $dstr;
	}
	
	function mkWhere($req){
		$sWhere = "";
		// 任意文字列
		if($this->is_eff($req["findstr"])){
			$ary = explode(" ", $req["findstr"]);
			$o = $req["strobj"];
			while(list($key,$val) = each($ary)){
				$str = "(";
				// 操作
				if($o != 2){
					$str .= sprintf("(I.cope like '%%%s%%')", $val);
				}
				switch($o){
				case 0:	// 何れか
					$str .= " OR ";
					break;
				case 3:	// 両方
					$str .= " AND ";
					break;
				}
				// 結果
				if($o != 1){
					$str .= sprintf("(I.cexp like '%%%s%%')", $val);
				}
				$str .= ")";
				$sWhere = $this->fmtWhere($sWhere, $str);
			}
		}
		// 担当
		if($this->is_eff($req["charge1"])){
			$str = sprintf("I.cid = '%s'", $req["charge1"]);
			$sWhere = $this->fmtWhere($sWhere, $str);
		}
		if($this->is_eff($req["charge2"])){
			$str = sprintf("I.cid2 = '%s'", $req["charge2"]);
			$sWhere = $this->fmtWhere($sWhere, $str);
		}
		// 重要度
		if($this->is_eff($req["simp"])){
			$str = sprintf("I.nimp %s %d", $this->toSign($req["impobj"]), $req["simp"]);
			$sWhere = $this->fmtWhere($sWhere, $str);
		}
		// 難易度
		if($this->is_eff($req["sdif"])){
			$str = sprintf("I.ndif %s %d", $this->toSign($req["difobj"]), $req["sdif"]);
			$sWhere = $this->fmtWhere($sWhere, $str);
		}
		// 予定日 -- delete
/*
		$dstr = $this->toDateStr($req["syear"], $req["smonth"], $req["sday"]);
		if(strlen($dstr) > 0){
			$str = sprintf("I.dplan %s '%s'", $this->toSign($req["sobj"]), $dstr);
			$sWhere = $this->fmtWhere($sWhere, $str);
		}
*/
		// 実績数
		// 最終実績日
		return $sWhere;
	}
	
	function get_fpname($pid){
		$sSql = sprintf("SELECT toPName(%d) AS cpname_f", $pid);
		$this->db->query($sSql);
		$this->db->next_record();
		return $this->db->f("cpname_f");
	}

	function mkSQL($pid, $req){
		$sSql  = "SELECT C.*, I.*, U1.cname AS charge1, U2.cname AS charge2 ";
		$sSql .= "FROM titem I ";
		$sSql .= "INNER JOIN vclass C USING(npid, ncid) ";
		$sSql .= "INNER JOIN muser U1 USING(cid) ";
		$sSql .= "INNER JOIN muser U2 ON U2.cid = I.cid2 ";
		if(is_null($pid)){
			$sSql .= sprintf("WHERE I.npid IN (%s) ", $this->p_projs);
		}else{
			$sSql .= sprintf("WHERE I.npid = %d ", $pid);
		}
		$sSql .= $this->mkWhere($_REQUEST);
	}
}
