<?php
/*
*	$id:ti_funcs.inc (c)A.Ida 2017/3/10 15:37:31
*	共通クラス
*/

// 未投入セルの空白置換用
function nul2sp($str){
	if (strlen($str) == 0)
	{
		$str = "&nbsp;";
	}
	return $str;
}

// checked挿入
function pChecked($val){
	print(($val == 1) ? " CHECKED" : "");
}

//
// コード変換 PHP3,PHP4共通化
//
class ti_jconv {
	var $classname = "ti_jconv";
	var $is_Three = false;
	var $C_CODE = "UTF-8";
	var $C_BASE_CODES = "UTF-8,EUC-JP,SJIS,JIS";
	var $C_FROM_CODES = "EUC-JP,UTF-8,SJIS,JIS";
	
	// コンストラクタ
	function ti_jconv(){
		global $c_enc;
		if(substr(PHP_VERSION,0,1) == '3'){
			$this->is_Three = true;
		}
		$this->C_CODE = ($c_enc == 0) ? "EUC-JP" : "UTF-8";
		$this->C_BASE_CODES = ($c_enc == 0) ? "EUC-JP,UTF-8,SJIS,JIS" : "UTF-8,EUC-JP,SJIS,JIS";
		$this->C_FROM_CODES = ($c_enc == 1) ? "EUC-JP,UTF-8,SJIS,JIS" : "UTF-8,EUC-JP,SJIS,JIS";
	}

	// SJISに変換
	function to_sj($instr){
		if($this->is_Three == true){
			$rstr = $instr;
		}else{
			$rstr = mb_convert_encoding($instr, "SJIS", $this->C_BASE_CODES);
		}
		return $rstr;
	}

	// SJISのCSV１カラムに変換
	function to_csv_sj($instr){
		$rstr = $instr;
		if(strlen($instr) > 0){
			$rstr = str_replace("\"","\"\"",$rstr);
			$rstr = $this->to_sj($rstr);
			$rstr = str_replace(chr(13).chr(10),chr(10),$rstr);
			$rstr = "\"" . $rstr . "\"";
		}
		return $rstr;
	}
	
	// --- append V0.5 ---
	// 基本コードに変換
	function to_base($instr){
		$rstr = mb_convert_encoding($instr, $this->C_CODE, $this->C_FROM_CODES);
		return $rstr;
	}

	// SJISから基本コードに変換
	function to_base_sj($instr){
		$rstr = mb_convert_encoding($instr, $this->C_CODE, "SJIS,UTF-8,EUC-JP,JIS");
		return $rstr;
	}

	// 基本コードをUTF-8に変換
	function to_u8($instr){
		global $c_enc;
		$rstr = $instr;
		if($c_enc != 1)
		{
			$rstr = mb_convert_encoding($instr, "UTF-8", $this->C_CODE);
		}
		return $rstr;
	}
	// ---
}

//
// 単一ＤＢ情報取得
//
class ti_get {
	var $p_db;
	var $p_data1;
	var $p_data2;
	var $p_data3;

	// コンストラクタ
	function ti_get($db){
		$this->p_db = $db;
	}
	
	// カレントシーケンスＩＤ
	function getSeqCur($sname){
		$id = -1;
		$sSql = sprintf("SELECT currval('%s')", $sname);
		$this->p_db->query($sSql);
		$this->p_db->next_record();
		$id = $this->p_db->f("currval");
		return $id;
	}

	// プロジェクト名
	function fullPrjName($pid){
		$sSql = sprintf("SELECT toPName(%d) AS fullpname ", $pid);
		$this->p_db->query($sSql);
		$this->p_db->next_record();
		$pname = htmlspecialchars($this->p_db->f("fullpname"));
		return $pname;
	}
	
	// ユーザ名
	function userName($uid){
		$sSql = sprintf("SELECT cname FROM muser WHERE cid = '%s'", $uid);
		$this->p_db->query($sSql);
		$this->p_db->next_record();
		$cname = htmlspecialchars($this->p_db->f("cname"));
		return $cname;
	}

	// 分類名 from 項目ID
	function fullClsName($pid, $iid){
		$sSql = "SELECT get_fullcname(C.npid,C.nucid,C.cclass) AS fullcname";
		$sSql .= ", I.cope, I.cexp";
		$sSql .= " FROM tclass C";
		$sSql .= " INNER JOIN titem I ON I.npid = C.npid AND I.ncid = C.ncid";
		$sSql .= sprintf(" WHERE I.npid = %d AND I.niid = %d", $pid, $iid);
		$this->p_db->query($sSql);
		$this->p_db->next_record();
		$cname = htmlspecialchars($this->p_db->f("fullcname"));
		$this->p_data1 = nl2br(htmlspecialchars($this->p_db->f("cope")));
		$this->p_data2 = nl2br(htmlspecialchars($this->p_db->f("cexp")));
		if($this->p_data2 == ""){
			$this->p_data2 = "&nbsp";
		}
		return $cname;
	}

	// 障害タイトル
	function bugSubject($pid, $bid){
		$sSql = "SELECT niid, ctitle, cpheno, cproc FROM tbug";
		$sSql .= sprintf(" WHERE npid = %d AND nbid = %d", $pid, $bid);
		$this->p_db->query($sSql);
		$this->p_db->next_record();
		$csubj = htmlspecialchars($this->p_db->f("ctitle"));
		$this->p_data1 = nl2br(htmlspecialchars($this->p_db->f("cpheno")));
		$this->p_data2 = nl2br(htmlspecialchars($this->p_db->f("cproc")));
		if($this->p_data2 == ""){
			$this->p_data2 = "&nbsp";
		}
		$this->p_data3 = $this->p_db->f("niid");
		if($this->p_data3 == ""){
			$this->p_data3 = 0;
		}
		return $csubj;
	}
	
	// 資料有無 kind:'C''P''I''B''A'
	function ckAttach($kind, $pid, $iid){
		$res = FALSE;
		$sSql  = "SELECT count(*) AS cnt FROM tattach";
		$sSql .= sprintf(" WHERE npid = %d AND ckind = '%s' AND niid = %d", $pid, $kind, $iid);
		$this->p_db->query($sSql);
		$this->p_db->next_record();
		if($this->p_db->f("cnt") > 0){
			$res = TRUE;
		}
		return $res;
	}
	
	// 障害有無
	function ckBug($pid, $iid){
		$res = 0;
		$sSql  = sprintf("SELECT ckBug(%d, %d) AS res", $pid, $iid);
		$this->p_db->query($sSql);
		$this->p_db->next_record();
		$res = $this->p_db->f("res");
		return $res;
	}
	
	// 保留判定
	function ckHold($pid, $iid){
		$res = 0;
		$sSql = sprintf("SELECT count(*) AS cnt FROM vitemhld WHERE npid = %d AND niid = %d", $pid, $iid);
		$this->p_db->query($sSql);
		$this->p_db->next_record();
		$res = $this->p_db->f("cnt");
		return $res;
	}
}

// ＤＢから今日の日付取得
class ti_now{
	var $y;
	var $m;
	var $d;
	
	var $cy;
	var $cm;
	var $cd;
	
	function ti_now($db)
	{
		$db->query("SELECT * FROM vdays");
		$db->next_record();
		$this->y = $db->f("y");
		$this->m = $db->f("m");
		$this->d = $db->f("d");
		
		$this->cy = sprintf("%04d", $this->y);
		$this->cm = sprintf("%02d", $this->m);
		$this->cd = sprintf("%02d", $this->d);
	}
	
	function toStr()
	{
		$str = $this->cy . "/" . $this->cm . "/" . $this->cd;
		return $str;
	}
}

//
// option作成
//
class ti_mkOptions {
	var $ud_ary;
	var $ff_ary;
	var $oe_ary;
	
	var $optNum;	// 作成したoption数(HOptを除く)

	function ti_mkOptions(){
		$this->ud_ary = array("以上" => 0, "以下" => 1, "一致" => 2);
		$this->ff_ary = array("以降" => 0, "以前" => 1, "一致" => 2);
		$this->oe_ary = array("何れか" => 0,"操作のみ" => 1,"結果のみ" => 2,"両方" => 3);
	}

	// 未選択Optionの作成	
	function mkHOpt($hsize, $bstr=false)
	{
		$opt = "";
		$val = $bstr ? "" : -1;
		if ($hsize > 0)
		{
			$opt = sprintf("<option value=\"%s\">%s</option>\n", $val, str_repeat("-", $hsize));
		}
		return $opt;
	}
	
	function isNull($val)
	{
		$ret = is_null($val);
		if ($ret == false)
		{
			if (is_string($val))
			{
				if (strlen($val) == 0)
				{
					$ret = true;
				}
			}
		}
		return $ret;
	}
	
	// DATABASE汎用型
	function mkDBOpts($db, $txtcol, $valcol, $defval, $hsize=0, $bstr=false)
	{
		$this->optNum = 0;
		$opts = $this->mkHOpt($hsize, $bstr);
		while ($db->next_record()){
			$cked = "";
			if($db->f($valcol) == $defval){
				$cked = " selected";
			}
			$opts .= sprintf("<option value=\"%s\"%s>%s</option>\n", $db->f($valcol), $cked, htmlspecialchars($db->f($txtcol)));
			$this->optNum++;
		}
		return $opts;
	}
	
	// 連想配列型共通部
	// $ary:対象配列 $def:selected対象(val) $bhr:----の長さ
	function mkOpts($ary, $def, $hsize=0)
	{
		$this->optNum = 0;
		$opts = $this->mkHOpt($hsize);
		while (list($key, $val) = each($ary)){
			$cked = "";
			if(!$this->isNull($def)){
				if($val == $def){
					$cked = " selected";
				}
			}
			$opts .= sprintf("<option value=\"%d\"%s>%s</option>\n", $val, $cked, $key);
			$this->optNum++;
		}
		return $opts;
	}
	
	// mkOptsのkey-val反転型(defはkey)
	function mkOptsR($ary, $def, $hsize=0){
		$aryR = array_flip($ary);
		return $this->mkOpts($aryR, $def, $hsize);
	}
	
	// 数値範囲方共通部
	function mkNumOpts($start, $end, $size, $def, $bhr)
	{
		$this->optNum = 0;
		$opts = $this->mkHOpt($bhr ? $size : 0);
		$fmt = sprintf("%%0%dd", $size);
		for($val=$start; $val<=$end; $val++){
			$cked = "";
			if(!$this->isNull($def)){
				if($val == $def){
					$cked = " selected";
				}
			}
			$opts .= sprintf("<option value=\"%d\"%s>$fmt</option>\n", $val, $cked, $val);
			$this->optNum++;
		}
		return $opts;
	}
	
	// 重要度
	function mkImps($def, $bhf){
		global $c_iary;
		$hsize = $bhf ? 4 : 0;
		return $this->mkOpts($c_iary, $def, $hsize);
	}
	
	// 難易度
	function mkDifs($def, $bhf){
		global $c_dary;
		$hsize = $bhf ? 2 : 0;
		return $this->mkOpts($c_dary, $def, $hsize);
	}
	
	// 年
	function mkYears($def, $bhf){
		global $c_year_s;
		global $c_year_e;
		return $this->mkNumOpts($c_year_s, $c_year_e, 4, $def, $bhf);
	}
	
	// 月
	function mkMonths($def, $bhf){
		return $this->mkNumOpts(1, 12, 2, $def, $bhf);
	}
	
	// 日
	function mkDays($def, $bhf){
		return $this->mkNumOpts(1, 31, 2, $def, $bhf);
	}
	
	// 階層
	function mkLayer($def, $bhf){
		return $this->mkNumOpts(1, 9, 1, $def, $bhf);
	}
	
	// 以上・以下
	function mkUD($def, $bhf){
		$hsize = $bhf ? 4 : 0;
		return $this->mkOpts($this->ud_ary, $def, $hsize);
	}
	
	// 以降・以前
	function mkFF($def, $bhf){
		$hsize = $bhf ? 4 : 0;
		return $this->mkOpts($this->ff_ary, $def, $hsize);
	}

	// 操作・結果
	function mkOE($def, $bhf){
		$hsize = $bhf ? 4 : 0;
		return $this->mkOpts($this->oe_ary, $def, $hsize);
	}
}

//
// $_SESSIONや$_REQUESTの取得
//
class ti_request
{
	var $bChange;
	
	function ti_request()
	{
		$this->bChange = false;
	}
	
	// $_REQUEST抽出
	function getReq($vname, $def)
	{
		$res = $def;
		if (isset($_REQUEST[$vname]))
		{
			$res = $_REQUEST[$vname];
		}
		return $res;
	}
	
	// $_SESSION抽出
	function getSess($vname, $def)
	{
		$res = $def;
		if (isset($_SESSION[$vname]))
		{
			$res = $_SESSION[$vname];
		}
		return $res;
	}
	
	// ""を許さないgetSess
	function getSessNN($vname, $def)
	{
		$res = $this->getSess($vname, $def);
		if (strlen($res) == 0)
		{
			$res = $def;
		}
		return $res;
	}
	
	// $_REQUESTなければ$_SESSIONから抽出
	function getReqSess($vname, $gvname, $def)
	{
		$this->bChange = false;
		$res = $def;
		if (isset($_REQUEST[$vname]))
		{
			$res = $_REQUEST[$vname];
			if (isset($_SESSION[$gvname]))
			{
				if ($res != $_SESSION[$gvname])
				{
					// 既存のSESSIONと異なる値のREQUEST
					$this->bChange = true;
				}
			}
		}
		else if (isset($_SESSION[$gvname]))
		{
			$res = $_SESSION[$gvname];
		}
		return $res;
	}
	
	// $_REQUESTなければ$_SESSIONから抽出
	// 同時に$_SESSIONにセット
	function getReqSessSet($vname, $gvname, $def)
	{
		$res = $this->getReqSess($vname, $gvname, $def);
		$_SESSION[$gvname] = $res;
		return $res;
	}

	// CheckBok用
	// jvnameのREQUEST有無でREQUESTか初期値か判定する
	function getCBReq($vname, $jvname, $off, $def)
	{
		if (isset($_REQUEST[$jvname]))
		{
			$res = $this->getReq($vname, $off);
		}
		else
		{
			$res = $def;
		}
		return $res;
	}
	
	function getCBReqSessSet($vname, $jvname, $gvname, $off, $def)
	{
		if (isset($_REQUEST[$jvname]))
		{
			$res = $this->getReq($vname, $off);
		}
		else
		{
			$res = $this->getSess($gvname, $def);
		}
		$_SESSION[$gvname] = $res;
		return $res;
	}
	
	// $_REQUESTから抽出、無ければ中断
	function getReqCheck($vname, $enableNull=false)
	{
		$res = null;
		if (isset($_REQUEST[$vname]))
		{
			$res = $_REQUEST[$vname];
			if (($enableNull == false) && ($this->isNull($res)))
			{
				print "<font color='red'>未設定の必須パラメタがあります。中断します。($vname)</font><br>\n";
				exit(0);
			}
		}
		else
		{
			print "<font color='red'>パラメタが不足しています。中断します。($vname)</font><br>\n";
			exit(0);
		}
		return $res;
	}
	
	// $_SESSIONから抽出、無ければ中断
	function getSessCheck($vname, $enableNull=false)
	{
		$res = null;
		if (isset($_SESSION[$vname]))
		{
			$res = $_SESSION[$vname];
			if (($enableNull == false) && ($this->isNull($res)))
			{
				print "<font color='red'>未設定の必須情報があります。中断します。($vname)</font><br>\n";
				exit(0);
			}
		}
		else
		{
			print "<font color='red'>情報が不足しています。中断します。($vname)</font><br>\n";
			exit(0);
		}
		return $res;
	}
	
	// $_SESSIONがunsetならデフォルト値セット
	function setSessDef($vname, $def)
	{
		if (!isset($_SESSION[$vname]))
		{
			$_SESSION[$vname] = $def;
		}
		return $_SESSION[$vname];
	}
	
	function isNull($val)
	{
		$res = false;
		if (is_null($val))
		{
			$res = true;
		}
		else if (is_string($val) && strlen($val) == 0)
		{
			$res = true;
		}
		return $res;
	}
	
	// 配列確認と要素数
	function is_ary_cnt($ary, $bcheck=false)
	{
		$res = 0;
		if (is_array($ary))
		{
			$res = count($ary);
		}
		if ($bcheck)
		{
			if ($res <= 0)
			{
				print "<font color='red'>未設定の必須パラメタがあります。中断します。</font><br>\n";
				exit(0);
			}
		}
		return $res;
	}
}
