<?php
/*
*	$id:ti_item_view.inc (c)A.Ida 2017/3/10 15:37:31
*	項目一覧クラス
*/
class ti_itemView {
	var $g_pid;
	var $g_nr;
	var $g_ccnt;			// 分類最大階層
	var $g_iids = array();	// 添付資料有り項目配列
	var $g_biid;
	
	var $db;
	
	// コンストラクタ
	function ti_itemView($pid){
		// 変数初期化
		$this->g_pid = $pid;
		// ＤＢクラス作成
		$this->db = new DB_Ti(true);
		// ラウンド数取得
		$this->getRound($pid);
		// 項番表示モード
		$lic = new ti_lic();
		$this->g_biid = $lic->chkItemId(1);
	}
	
	// プロジェクトラウンド数
	function getRound($pid){
		$sSql = sprintf("SELECT COALESCE(nround, 0)+1 AS nr FROM %d", $pid);
		$this->db->query($sSql);
		$this->db->next_record();
		$this->g_nr = $this->db->f("nr");
		return $this->g_nr;
	}
	
	// 分類最大階層取得
	function getMaxClsLvl(){
		$sSql = sprintf("SELECT MAX(cntClass(npid,ncid,0)) AS ccnt  from tclass WHERE npid = %d", $this->g_pid);
		$this->db->query($sSql);
		$this->db->next_record();
		$this->g_ccnt = $this->db->f("ccnt");
		return $this->g_ccnt;
	}
	
	// 添付資料を持つ項目取得
	function getAttachs(){
		$sSql = "SELECT DISTINCT niid FROM tattach ";
		$sSql .= sprintf("WHERE npid = %d AND ckind = 'I' AND cfname is NULL ", $this->g_pid);
		$sSql .= "ORDER BY niid";
		$this->db->query($sSql);
		$indx=0;
		while($this->db->next_record()){
			$g_iids[$indx++] = $this->db->f("niid");
		}
	}
	
	function printTH($txt){
		printf("<th nowrap><font size='-1'>%s</font></th>\n", $txt);
	}

	// ヘッダ出力
	function printHead($opt=0){
		print("<table class='view' cellspacing=0>\n");
		print("<tr>\n");
		$this->printTH("項番");
		if($opt & 1){
			$this->printTH("選");
		}
		for($c=0;$c<$this->g_ccnt;$c++){
			$name = sprintf("分類%02d", $c+1);
			$this->printTH($name);
		}
		$this->printTH("操作");
		$this->printTH("結果");
		$this->printTH("重");
		$this->printTH("難");
		$this->printTH("資");
		$this->printTH("実担");
		$this->printTH("実日");
		$this->printTH("記");
		$this->printTH("相");
		$this->printTH("主担");
		$this->printTH("副担");
		print("</tr>\n");
	}
	
	function printTD($txt){
		printf("<td class=\"bd view\"><font size=\"-1\">%s</font></td>\n", $txt);
	}
	
	// データQUERY
	function queryDatas($where){
		global $c_dexec_lst;
		
		$sSql  = "SELECT C.*, I.*, ";
		$sSql .= sprintf("coalesce(to_char(I.dexec, '%s'), '&nbsp') AS cexec, ", $c_dexec_lst);
		$sSql .= "toUName(I.cid) AS cname, ";
		$sSql .= "toUName(I.cid2) AS cname2, ";
		$sSql .= "nsp(toUName(cid_r)) AS cname_r, ";
		$sSql .= "ckBug(I.npid, I.niid) AS bflg ";
		$sSql .= "FROM vitem I ";
		$sSql .= "INNER JOIN vclass C USING(npid, ncid) ";
		$sSql .= $where;
		$this->db->query($sSql);
		
		return $this->db->num_rows();
	}

	// 一覧出力
	// $opt: 1-選
	function printDatas($opt){
		global $c_iaryR;
		global $c_daryR;
		
		// 分類のrowspan決定処理
		for($c=1; $c<=$this->g_ccnt;$c++){
			$fwd_id[$c] = -1;
			$spn_cnt[$c][0] = 0;
			$spn_cnt[$c][1] = 1;
		}
		while($this->db->next_record()){
			$cgflg = 0;
			for($c=1; $c<=$this->g_ccnt;$c++){
				$nno = sprintf("n%d", $c);
				if(($fwd_id[$c] == $this->db->f($nno)) && ($cgflg == 0)){
					$spn_cnt[$c][$spn_cnt[$c][0]]++;
				}else{
					$cgflg = 1;
					$fwd_id[$c] = $this->db->f($nno);
					$spn_cnt[$c][0]++;
					$spn_cnt[$c][$spn_cnt[$c][0]] = 1;
				}
			}
		}
		// ここから
		$this->db->seek(0);
		for($c=1; $c<=$this->g_ccnt; $c++){
			$fwd_id[$c] = -1;
			$spn_cnt[$c][0] = 1;
		}
		$i = 1;
		$indx = 0;
		while($this->db->next_record()){
		//	print("<tr>\n");
			$even = "odd";
			if($i%2 == 0){
				$even = "even";
			}
			$rowid = sprintf("%d-%d", $this->g_pid, $i);
			printf("<tr class=%s id=r%s onMouseOver='ovrColor(\"%s\");' onMouseOut='outColor(\"%s\");'>\n", $even, $rowid, $rowid, $rowid);
			// 項番
			$cls = "caption";
			if(($this->g_nr > 1) && ($this->db->f("nround2") == 0)){
				// 実績の全く無い項目
				$cls = "alert";
			}
			printf("<td class=\"bd %s\" align=\"right\"'><font size=\"-1\">%03d</font></td>\n", $cls, $this->g_biid ? $this->db->f("niid") : $i);
			// 選
			if($opt & 1){
				printf("<td class=\"bd view\"><input type=\"checkbox\" name=\"ck[]\" value=\"%d-%d\" onClick=\"fckck()\"></td>\n", $this->db->f("npid"), $this->db->f("niid"));
			}
			// 分類
			$cgflg = 0;
			for($c=1; $c<=$this->g_ccnt; $c++){
				$nno = sprintf("n%d", $c);
				if(($fwd_id[$c] != $this->db->f($nno)) || ($cgflg == 1)){
					$cgflg = 1;
					$cno = sprintf("c%d", $c);
					$cstr = $this->db->f($cno);
					if(strlen($cstr) == 0){
						$cstr = "-";
						$align = "center";
					}else{
						$cstr = nl2br(htmlspecialchars($cstr));
						$align = "left";
					}
					printf("<td class=\"bd cls\" bgcolor='#CCCCCC' rowspan=\"%d\" align=\"%s\"><font size=\"-1\">%s</font></td>\n", $spn_cnt[$c][$spn_cnt[$c][0]], $align, $cstr);
					$spn_cnt[$c][0]++;
					$fwd_id[$c] = $this->db->f($nno);
				}
			}
			// 操作
			$this->printTD(nl2br(htmlspecialchars($this->db->f("cope"),0)));
			// 結果
			$this->printTD(nl2br(htmlspecialchars($this->db->f("cexp"),0)));
			// 重要度
			$this->printTD($c_iaryR[$this->db->f("nimp")]);
			// 難易度
			$this->printTD($c_daryR[$this->db->f("ndif")]);
			// 資料 append V0.3
			print("<td class=\"bd view\">");
			$str = "<font size=\"-1\">無</font>";
			if(isset($iids)){
				for($indx=0; $indx<count($this->iids); $indx++){
					if($this->iids[$indx] == $this->db->f("niid")){
						$str = sprintf("<input type=\"button\" name=\"attach\" value=\"資\" onClick=\"toAttach(%d,%d);\">\n", $this->db->f("npid"), $this->db->f("niid"));
						break;
					}
				}
			}
			print($str);
			print("</td>\n");
			// 前実施者
			$this->printTD($this->db->f("cname_r"));
			// 前実施日
			$this->printTD($this->db->f("cexec"));
			
			// メモ
			if($this->db->f("cmemo")){
				$imgf = "img/memo_yes.jpg";
			}else{
				$imgf = "img/memo_no.jpg";
			}
			printf("<td class=\"bd view\"><img src=\"%s\" onClick=\"toMemo(%d,%d)\"></td>\n", $imgf, $this->db->f("npid"), $this->db->f("niid"));
			// 相談 add V0.3.4
			printf("<td class=\"bd view\"><input type='button' name='conv' value=' ' onClick='toConv(%d,%d);'></td>\n",$this->g_pid,$this->db->f("niid"));
			// 主担当
			$this->printTD($this->db->f("cname"));
			// 副担当
			$this->printTD($this->db->f("cname2"));
			print("</tr>\n");
			$i++;
		}
		print("</table>\n");
	}
	
	function mkAll($where, $opt=0){
		$this->getMaxClsLvl();
		$this->getAttachs();
		$num = $this->queryDatas($where);
		if($num > 0){
			$this->printHead($opt);
			$this->printDatas($opt);
		}else{
			print("<p class=\"warn\">該当項目はありません。</p>\n");
		}
		return $num;
	}
}
