<?php
/*
* テスト項目運用システム - 各種パラメタ定義ファイル
*
*	$id:ti_local.inc (c)A.Ida 2017/3/10 15:37:31
*
* このスクリプトは必要に応じてユーザの手で編集されます。
* 詳細は、「インストール手順書」及び「カスタマイズ解説」を参照してください。
*/ 

# IIS運用でmagic_quotes_runtimeをOffにできないときはコメントアウトしてみてくだ
# さい。ただし、テストはしていません。
# set_magic_quotes_runtime(0);

//
// エンコード
// 現版では基本的にUTF-8固定です。作者からEUC版の提供を受けた場合のみ変更してください。
//
global $c_enc;
$c_enc = 1;	// 0:EUC-JP 1:UTF-8

//
// データベースへの接続情報
// ご使用の環境に合わせて編集してください。
// 詳細は「インストール手順書」を参照のこと。
//
// hostspecは、指定しないと動かない場合と、指定すると動かない場合があるようです。
// 理由はよく分かりません。
// hostspecを指定しないと動かない場合としては、Windowsでusername,passwordを指定した場合
// を確認しています。それ以外では指定なしで動作しました。
//
global $c_dsnary;
$c_dsnary = array(
	'phptype'  => 'pgsql',		// 現版では変更不可
//	'hostspec' => 'localhost',	// hostname[:port]
	'database' => 'pgti',		// データベース名
	'username' => '',		// データベースのユーザ名
	'password' => '',		// パスワード
	);

//	
// 添付資料登録先
//
global $c_dsnary;
$c_attach = "./attach";

//
// 権限種別
//
global $c_permary;
$c_permary = array(
#		"limited"    => 0,
		"tester"     => 1,
		"leader"     => 3,
#		"pm"         => 7,	// 予約
#		"top"        => 15,	// 予約
		"admin"      => 31
	);
//
// 権限種別（日本語）
//
global $c_aary;
$c_aary = array(
#	"limited"    => "実施専任",
	"tester"     => "一般",
	"leader"     => "リーダ",
#	"pm"         => "マネージャ",
#	"top"        => "管理職",
	"admin"      => "管理者"
	);
//	
// 難易度
// 変更に際してはカスタマイズ解説書を参照のこと
//
global $c_dary;
$c_dary = array(
	"特"	=> 4,
	"高"	=> 3,
	"中"	=> 2,
	"低"	=> 1
	);
global $c_daryR;
$c_daryR = array_flip($c_dary);

//
// 難易度の重み付け
// 「分析」で難易度加味で進捗を評価するときの重み付けを変更したい場合にはこの連想
// 配列の右側の数値を変更します。
// 旧版との互換のために小さな数値にしてますが、個人的には「特」には50くらい与えた
// いところです。面倒な項目は本当に面倒ですからね。
// 運用開始後でも随時変更して問題ありません。
//
global $c_dwary;
$c_dwary = array(
	4	=> 4,	// 特
	3	=> 3,	// 高
	2	=> 2,	// 中
	1	=> 1	// 低
	);

//
// 重要度
//
global $c_iary;
$c_iary = array(
	"必須"	=> 4,
	"重要"	=> 3,
	"中度"	=> 2,
	"略可"	=> 1,
	"保留"	=> 0
	);
global $c_iaryR;
$c_iaryR = array_flip($c_iary);

//
// 障害種別
//
global $c_kary;
$c_kary = array(
	"ドキュメントミス" => 5,
	"プログラムミス" => 4,
	"仕様ミス" => 3,
	"他プログラム" => 2,
	"使用ミス・誤解" => 1,
	"仕様変更" => 0,
	"同件" => 7,
	"保留" => 6
	);
global $c_karyR;
$c_karyR = array_flip($c_kary);

//
// 障害として実績カレンダーにカウントしない障害種別
// $c_karyの右辺の数値を列挙します。
//
global $c_kary_non;
$c_kary_non = array(0,1,7);

//
// メール送信機能を有効にする場合はtrueに変更してください。
//
global $c_mail_valid;
$c_mail_valid = false;

//
// メール本文の文字コード
// 通常は変更の必要は無いと思いますが、GNOME端末とかでmailxで見ると文字化けするようなので
// その回避策として設けました。
//
global $c_mail_enc;
$c_mail_enc = "JIS";

//
// メールバックエンド指定
// SMTPホスト名やポート番号はphp.iniの"SMTP","smtp_port"から取得します。
// sendmailへのパスも同様にphp.iniの"sendmail_path"から取得します。
//
global $c_mail_backend;
$c_mail_backend = 1;		// 0:sendmail 1:SMTP

//
// ＳＭＴＰ認証
// SMTP認証が必要な場合には$c_smtp_authをtrueにしてユーザ名とパスワードを設定して下さい。
// パスワードを設定した場合には本ファイルの管理に気を付けてください。インストール手順書通りの標準的な設定では容易に参照されます。
//
global $c_smtp_auth;
$c_smtp_auth = false;
global $c_smtp_user;
global $c_smtp_passwd;
$c_smtp_user = "";			// SMTP認証ユーザ名
$c_smtp_passwd = ""; 		// SMTP認証パスワード

//
// 送信元メールアドレス
//
global $c_mail_from;
$c_mail_from = "xxxxx@xxx.xx.jp";	// 4文字以下ならphp.iniのsendmail_fromが使用されます。
global $c_mail_reply;
$c_mail_reply = $c_mail_from;

//
// サーバＵＲＬ(メール本文中に使用する回答ＵＲＬなどに使用されます)
// $_SERVER['SERVER_NAME']はアクセスのしかたによっては予期せぬ結果（"localhost"
// になったりとか）になるので下記のように直接指定するように書き換えた方が安心
// です。
// スラッシュ(/)で終了させてください。
// $c_server_url = "http://HostName/tisystem/";
//
global $c_server_url;
$c_server_url = sprintf("http://%s/tisystem/", $_SERVER['SERVER_NAME']);

//
// Subversionコマンドパス
// パスが通ってない場合はここにsvnコマンドのあるフォルダをフルパス指定します。
// 通常は設定の必要は無いと思います。
// $c_svn_path = "c:\\program files\\Subversion\\bin\\";
//
global $c_svn_path;
$c_svn_path = "";

//
// Subversion設定ファイルパス
// Can't determine the user's config path のエラーになった場合にWebサーバの
// 実行ユーザが変更可能なSubversion設定ファイルへのパスを設定します。
// $c_svn_conf = "c:\\svn\\conf\\Subversion";
//
global $c_svn_conf;
$c_svn_conf = "";

//
// 年範囲
//
global $c_year_s;
$c_year_s = 2010;	// セレクトボックスに古い年が表示されて鬱陶しい場合はここを変更します
global $c_year_e;
$c_year_e = 2020;

//
// 実施日フォーマット
// テスト実施日の表示形式をPostgreSQLのto_char()のテンプレートで指定します。
//

// 実施画面項目一覧
global $c_dexec_lst;
$c_dexec_lst = "YYYY/MM/DD";

// 実施画面カード型
global $c_dexec_card;
$c_dexec_card = "YYYY/MM/DD HH24:MI";

// ファイル出力（「実施予定日」にも影響します）
global $c_dexec_csv;
$c_dexec_csv = "YYYY-MM-DD";
?>
