<?php
/*
*	$id:ti_mail.inc (c)A.Ida 2017/3/10 15:37:31
*	メール送信クラス
*/

class ti_mail {
	var $g_pid;		// プロジェクトＩＤ
	var $g_kind;	// 1:障害発行 2:障害回答 3:障害確認 11:相談発行
	var $g_id;		// 障害票ＩＤ or 相談ＩＤ
	var $g_from;
	var $g_eof;
	
	var $g_body;
	
	// クラス
	var $db;
	var $cnv;
	
	// 有効無効
	var $p_valid;
	
	// 共通
	var $p_pname;				// プロジェクト名
	var $p_from;				// 発行者ＩＤ
	var $p_fromN;				// 発行者名
	var $p_to;					// 回答担当者ＩＤ
	var $p_toN;					// 回答担当者名
	var $p_dissue;				// 発行日
	var $p_plan;				// 回答期限
	var $p_toAddrs = array();	// 送信メアド
	var $p_toNames = array();	// 送信メンバ名
	var $p_ans;					// 回答者ＩＤ
	var $p_ansN;				// 回答者名
	// 相談
	var $p_subj;				// 相談表題
	var $p_to2;					// 質問者ＩＤ
	var $p_to2N;				// 質問者名
	// 障害
	var $p_bsubj;				// 障害票表題
	var $p_text = array();		// 障害本文
	var $p_imp;					// 重要度
	var $p_bkind;				// 障害種別
	var $p_src;					// 修正対象
	var $p_bid;					// 障害ＩＤ
	var $p_at_b = array();		// 添付資料（発行）
	var $p_at_a = array();		// 添付資料（回答）
	var $p_conf;				// 確認者ＩＤ
	var $p_confN;				// 確認者名
	var $p_note;				// 備考
	var $p_dans;				// 回答日
	var $p_dconf;				// 確認日
	// 項目
	var $p_iid;					// 項目
	var $p_cname;				// 分類名
	var $p_conv;				// 相談内容
	var $p_itext = array();		// 項目本文

	// コンストラクタ
	function ti_mail($pid, $kind, $id){
		global $c_mail_valid;
		
		$this->p_valid = true;
		if(isset($c_mail_valid)){	// V0.4互換のため未定義はtrue
			$this->p_valid = $c_mail_valid;
		}
		
		if($this->p_valid){
			$this->g_pid  = $pid;
			$this->g_kind = $kind;
			$this->g_id   = $id;
		
			// 初期化
			$this->p_to = $this->p_from = $this->p_to2 = $this->p_ans = "";
			
			// ＤＢクラス作成
			$this->db = new DB_Ti;
			// コード変換クラス作成
			$this->cnv = new ti_jconv;
		}
	}
	
	// 有効判定
	function is_valid(){
		return $this->p_valid;
	}
	
	// 項目情報取得
	function getItemData($pid, $iid){
		$res = FALSE;
		$sSql = "SELECT get_fullcname(C.npid,C.nucid,C.cclass) AS fullcname";
		$sSql .= ", I.cope, I.cexp";
		$sSql .= " FROM tclass C";
		$sSql .= " INNER JOIN titem I ON I.npid = C.npid AND I.ncid = C.ncid";
		$sSql .= sprintf(" WHERE I.npid = %d AND I.niid = %d", $pid, $iid);
		$this->db->query($sSql);
		if($this->db->next_record()){
			$this->p_itext[0] = $this->db->f("cope");	// 操作
			$this->p_itext[1] = $this->db->f("cexp");	// 結果
			$this->p_cname = $this->db->f("fullcname");	// 分類
			$res = TRUE;
		}
		return $res;
	}
	
	// 障害情報取得
	function getBugData($pid, $bid){
		$res = FALSE;
		$sSql = sprintf("SELECT * FROM vbug WHERE npid = %d AND nbid = %d", $pid, $bid);
		$this->db->query($sSql);
		if($this->db->next_record()){
			// 項目ＩＤ
			$this->p_iid = $this->db->f("niid");
			// 表題
			$this->p_bsubj = $this->db->f("ctitle");
			// 重要度
			$this->p_imp = $this->db->f("nimp_b");
			// 本文
			$this->p_text[0] = $this->db->f("cpheno");
			$this->p_text[1] = $this->db->f("cproc");
			$this->p_text[2] = $this->db->f("ccause");
			$this->p_text[3] = $this->db->f("ccope");
			// 障害種別
			$this->p_bkind = $this->db->f("nkind");
			// 修正対象
			$this->p_src = $this->db->f("csrc");
			// 確認者
			$this->p_conf = $this->db->f("cid_c");
			// 備考
			$this->p_note = $this->db->f("cnote");
			// 発行日
			$this->p_dissue = $this->db->f("dissue");
			// 回答日
			$this->p_dans = $this->db->f("dans");
			// 発行日
			$this->p_dconf = $this->db->f("dconf");
			
			if($this->g_kind < 10){	// 相談の障害情報取得時は除外
				// 発行者
				$this->p_from = $this->db->f("cid_b");
				// 回答担当
				$this->p_to = $this->db->f("cid_p");
				// 期限
				$this->p_plan = $this->db->f("dterm");
				// 回答者
				$this->p_ans = $this->db->f("cid_a");
			}
			$res = TRUE;
		}
		return $res;
	}
	
	// 添付資料情報取得
	function getattach($pid, $bid){
		$sSql  = "SELECT B.npid, A.ckind, A.nadd, B.cfname, B.ccmnt FROM tattach A";
		$sSql .= " INNER JOIN tattach B ON B.nattach = A.nattach_s";
		$sSql .= sprintf(" WHERE A.npid = %d AND A.ckind IN ('B','A') AND A.niid = %d", $pid, $bid);
		$sSql .= " ORDER BY A.ckind, A.nadd";
		$this->db->query($sSql);
		$this->p_at_b = array();
		$this->p_at_a = array();
		$indx_a = $indx_b = 0;
		while($this->db->next_record()){
			if($this->db->f("ckind") == 'B'){
			// 発行
				$this->p_at_b[$indx_b]->pid = $this->db->f("npid");
				$this->p_at_b[$indx_b]->fname = $this->db->f("cfname");
				$this->p_at_b[$indx_b]->cmnt = $this->db->f("ccmnt");
				$indx_b++;
			}else{
			// 回答
				$this->p_at_a[$indx_a]->pid = $this->db->f("npid");
				$this->p_at_a[$indx_a]->fname = $this->db->f("cfname");
				$this->p_at_a[$indx_a]->cmnt = $this->db->f("ccmnt");
				$indx_a++;
			}
		}
	}
	
	// 添付資料リンクＵＲＬ
	function mkAttachURL($atary){
		global $c_server_url;
		global $c_attach;
		$str = "";
		$max = count($atary);
		if($max > 0){
			$str .= "\n[添付資料]----\n";
			for($indx=0; $indx<$max; $indx++){
				$url  = sprintf("%s%s/%d/%s", $c_server_url, $c_attach, $atary[$indx]->pid, $atary[$indx]->fname);
				if(strlen($atary[$indx]->cmnt) > 0){
					$url .= sprintf("  : %s", $atary[$indx]->cmnt);
				}
				$str .= $url . "\n";
			}
		}
		return $str;
	}

	// ユーザ名取得
	function getUName($uid){
		$res = "";
		if(strlen($uid) > 0){
			$sSql = sprintf("SELECT cname FROM muser WHERE cid = '%s'", $uid);
			$this->db->query($sSql);
			$this->db->next_record();
			$res = $this->db->f("cname");
		}
		return $res;
	}
	
	// ＤＢ情報取得
	function getData(){
		$res = FALSE;
		// プロジェクト名
		$sSql = sprintf("SELECT toPName(%d) AS fullpname ", $this->g_pid);
		$this->db->query($sSql);
		$this->db->next_record();
		$this->p_pname = $this->db->f("fullpname");
		
		switch($this->g_kind){
		case 1:
		case 2:
		case 3:
			// 障害票 -----------------------
			$res = $this->getBugData($this->g_pid, $this->g_id);
			if($res){
				// 添付資料情報
				$this->getAttach($this->g_pid, $this->g_id);
				if(strlen($this->p_iid) > 0){
					// 項目情報追加
					$this->getItemData($this->g_pid, $this->p_iid);
				}
			}
			break;
		case 11:
			// 相談 ------------------------
			$sSql = sprintf("SELECT * FROM vconvers WHERE nckey = %d AND npid = %d", $this->g_id, $this->g_pid);
			$this->db->query($sSql);
			if($this->db->next_record()){
				// 項目ＩＤ
				$this->p_iid = $this->db->f("niid");
				// 障害ＩＤ
				$this->p_bid = $this->db->f("nbid");
				// 表題
				$this->p_subj = $this->db->f("csubj");
				// 発行者
				$this->p_from = $this->db->f("cid");
				// 発行日
				$this->p_dissue = $this->db->f("dwrite");
				// 回答担当
				$this->p_to = $this->db->f("cid_a");
				// 質問者
				$this->p_to2 = $this->db->f("cuid");
				// 回答期限
				$this->p_plan = $this->db->f("dterm");
				// 本文
				$this->p_conv = $this->db->f("cbody");
				
				if(strlen($this->p_iid) > 0){
					// 項目情報追加
					$this->getItemData($this->g_pid, $this->p_iid);
				}
				if(strlen($this->p_bid) > 0){
					// 障害情報追加
					$this->getBugData($this->g_pid, $this->p_bid);
				}
				$res = TRUE;
			}
			break;
		default:
			break;
		}
		if($res){
			// ユーザ名称取得
			$this->p_fromN = $this->getUName($this->p_from);
			$this->p_toN = $this->getUName($this->p_to);
			$this->p_to2N = $this->getUName($this->p_to2);
			$this->p_confN = $this->getUName($this->p_conf);
			$this->p_ansN = $this->getUName($this->p_ans);
		}
		return $res;
	}
	
	// 改行までの文字列取得
	function getOneLine($src, &$start){
		$res = FALSE;
		if(($pos = mb_strpos($src, "\n", $start)) === FALSE){
		}else{
			$pos += mb_strlen("\n");	// \nも含める
			$res = mb_substr($src, $start, ($pos - $start));
			$start = $pos;
		}
		return $res;
	}
	
	// 指定バイトサイズの文字列substr
	function subStrWidth($src, &$pos, $width){
		$n = 0;
		$w = 0;
		$swk = "";
		$this->g_eof = FALSE;
		while($w < $width){
			$c = mb_substr($src, $pos+$n, 1);
			if(strlen($c) > 0){
				$w += mb_strwidth($c);
				$swk .= $c;
				$n++;
			}else{
				$this->g_eof = TRUE;;
				break;
			}
		}
		$pos += $n;
		return $swk;
	}

	// 改行挿入
	function insNL($src, $size = 70){
		$start = 0;
		$res = "";
		// １行取得
		while($line = $this->getOneLine($src, $start)){
			if(mb_strwidth($line) > ($size + mb_strlen("\n"))){	// \n分の超過は許可
				$swk = "";
				$pos = 0;
				while($pos<mb_strlen($line)){
					$swk .= $this->subStrWidth($line, $pos, $size) . "\n";
					if($this->g_eof){
						break;
					}
				}
				$line = $swk;
			}
			$res .= $line;
		}
		return $res;
	}
	
	// セパレータ
	function mkSepLine($title, $size = 70){
		$line = "";
		if(strlen($title) > 0){
			$num = $size - strlen($title) - 2;
			$num /= 2;
			for($i=0; $i<$num; $i++){
				$line .= "-";
			}
			$line .= " " . $title . " ";
			for($i=0; $i<$num; $i++){
				$line .= "-";
			}
		}else{
			for($i=0; $i<$size; $i++){
				$line .= "-";
			}
		}
		$line .= "\n";
		return $line;
	}
	
	// 本文編集
	function mkBody(){
		global $c_iaryR;
		global $c_karyR;
		global $c_server_url;
		$body = "";
		$url = "";
		switch($this->g_kind){
		case 1:
		case 2:
		case 3:
			switch($this->g_kind){
			case 1:
				$swk = "発行";
				break;
			case 2:
				$swk = "回答";
				break;
			default:
				$swk = "確認";
				break;
			}
			$swk = "障害票（" . $swk . "）";
			$body .= $this->mkSepLine($swk);
			$body .= sprintf("[障害票番号　] %04d-%04d\n", $this->g_pid, $this->g_id);
			$body .= sprintf("[表題　　　　] %s\n", $this->p_bsubj);
			$body .= sprintf("[プロジェクト] %s\n", $this->p_pname);
			if(strlen($this->p_cname) > 0){
				$body .= sprintf("[分類　　　　] %s\n", $this->p_cname);
			}
			$body .= sprintf("[発行者　　　] %s\n", $this->p_fromN);
			$body .= sprintf("[発行日　　　] %s\n", $this->p_dissue);
			$body .= sprintf("[回答担当者　] %s\n", $this->p_toN);
			$body .= sprintf("[重要度　　　] %s\n", $c_iaryR[$this->p_imp]);
			$body .= sprintf("[回答期限日　] %s\n", $this->p_plan);
			$body .= "\n";
			$body .= "[現象]--------\n";
			$body .= $this->p_text[0] . "\n";
			$body .= "\n";
			$body .= "[手順]--------\n";
			$body .= $this->p_text[1] . "\n";
			$body .= $this->mkAttachURL($this->p_at_b);
			if($this->g_kind >= 2){
				$body .= "\n";
				$body .= $this->mkSepLine("");
				$body .= sprintf("[回答者　　　] %s\n", $this->p_ansN);
				$body .= sprintf("[回答日　　　] %s\n", $this->p_dans);
				$body .= "\n";
				$body .= "[原因]--------\n";
				$body .= $this->p_text[2] . "\n";
				$body .= "\n";
				$body .= "[対処]--------\n";
				$body .= $this->p_text[3] . "\n";
				$body .= $this->mkAttachURL($this->p_at_a);
				$body .= "\n";
				$body .= sprintf("[障害種別　　] %s\n", $c_karyR[$this->p_bkind]);
				$body .= sprintf("[修正対象　　] %s\n", $this->p_src);
				if($this->g_kind == 3){
					$body .= "\n";
					$body .= $this->mkSepLine("");
					$body .= sprintf("[確認者　　　] %s\n", $this->p_confN);
					$body .= sprintf("[確認日　　　] %s\n", $this->p_dconf);
					if(strlen($this->p_note) > 0){
						$body .= "[備考]--------\n";
						$body .= $this->p_note . "\n";
					}
				}
			}
			$url = sprintf("index.php?pid=%d&bid=%d", $this->g_pid, $this->g_id);
			break;
		case 11:
			$swk = $swk2 = "";
			if(strlen($this->p_to) > 0){
				$swk2 = "質問";
			}
			if(strlen($this->p_to2) > 0){
				$swk = "回答";
				if(strlen($swk2) > 0){
					$swk .= "兼";
				}
			}
			$swk .= $swk2;
			if(strlen($swk) > 0){
				$swk = "（" . $swk . "）";
			}
			$swk = "相談" . $swk;
			$body .= $this->mkSepLine($swk);
			$body .= sprintf("[表題　　　　] %s\n", $this->p_subj);
			$body .= "[相談対象　　] ";
			if(strlen($this->p_bid) > 0){
				$body .= "障害票";
			}else if(strlen($this->p_iid) > 0){
				$body .= "項目";
			}else{
				$body .= "プロジェクト";
			}
			$body .= "\n";
			$body .= sprintf("[プロジェクト] %s\n", $this->p_pname);
			if(strlen($this->p_cname) > 0){
				$body .= sprintf("[分類　　　　] %s\n", $this->p_cname);
			}
			if(strlen($this->p_bid) > 0){
			// 障害票
				$body .= sprintf("[障害票番号　] %04d-%04d\n", $this->g_pid, $this->p_bid);
				$body .= sprintf("[障害票表題　] %s\n", $this->p_bsubj);
			}
			$body .= sprintf("[相談者　　　] %s\n", $this->p_fromN);
			$body .= sprintf("[相談日　　　] %s\n", $this->p_dissue
			);
			if(strlen($this->p_to) > 0){
				$body .= sprintf("[回答責任者　] %s\n", $this->p_toN);
				$body .= sprintf("[回答期限日　] %s\n", $this->p_plan);
			}else{
				$body .= "[回答責任者　] 【回答不要】\n";
				$body .= "[回答期限日　] なし\n";
			}
			$body .= "\n";
			$body .= "[相談内容]----\n";
			$body .= $this->p_conv . "\n";
			$url = sprintf("index.php?pid=%d&ckey=%d", $this->g_pid, $this->g_id);
			break;
		}
		// 行長が長ければ改行を挿入
		$this->g_body = $this->insNL($body);
		if(strlen($this->p_to) > 0){
			// URLは改行しない
			$this->g_body .= sprintf("\n[回答はこちらから]\n%s%s\n", $c_server_url, $url);
		}
	}
	
	// val権限がnec権限を内包していればTRUE
	function ckPerm($val, $nec){
		global $perm;
		$res = FALSE;
		$valno = $perm->permissions[$val];
		$necno = $perm->permissions[$nec];
		if(($valno & $necno) == $necno){
			$res = TRUE;
		}
		return $res;
	}
	
	// 指定ユーザのメール情報取得
	function getMailInfo($uid, &$addr, &$name){
		$bret = false;
		if(strlen($uid) > 0){
			$sSql  = "SELECT E.*, U.cname FROM tmail E INNER JOIN muser U USING(cid)";
			$sSql .= sprintf(" WHERE E.cid = '%s'", $uid);
			switch($this->g_kind){
			case 11:
				$sSql .= " AND E.cconv IN ('1','2')";
				break;
			default:
				$sSql .= " AND E.cbug IN ('1','2')";
				break;
			}
			$this->db->query($sSql);
			if($this->db->next_record()){
				$addr = $this->db->f("cmail");
				$name = $this->db->f("cname");
				$bret = true;
			}
		}
		return $bret;
	}
	
	// アドレス追加
	function addAddr($addr, $name, &$addrAry, &$nameAry){
		$res = false;
		if(!in_array($addr, $addrAry)){
			array_push($addrAry, $addr);
			array_push($nameAry, $name);
			$res = true;
		}
		return $res;
	}
	
	// アドレス取得
	// Retur:送信先の数
	function getAddr(){
		$this->p_toAddrs = array();
		$this->p_toNames = array();
		
		switch($this->g_kind){
		case 2:
			break;
		case 1:
		case 11:
			// 回答責任者へ
			$bret = $this->getMailInfo($this->p_to, $addr, $name);
			if($bret){
				$this->addAddr($addr, $name, $this->p_toAddrs, $this->p_toNames);
			}
			break;
			break;
		default:
			// 回答者へ
			$bret = $this->getMailInfo($this->p_ans, $addr, $name);
			if($bret){
				$this->addAddr($addr, $name, $this->p_toAddrs, $this->p_toNames);
			}
			break;
		}
		switch($this->g_kind){
		case 2:
		case 3:
			// 発行者へ
			$bret = $this->getMailInfo($this->p_from, $addr, $name);
			if($bret){
				$this->addAddr($addr, $name, $this->p_toAddrs, $this->p_toNames);
			}
			break;
		}
		if($this->g_kind == 11){
			// 相談で回答（親発言がある）場合は質問者にも通知
			$bret = $this->getMailInfo($this->p_to2, $addr, $name);
			if($bret){
				$this->addAddr($addr, $name, $this->p_toAddrs, $this->p_toNames);
			}
		}

		// リーダ以上の全件指定ユーザに追加送信
		$sSql  = "SELECT  E.*, U.cname, A.perms FROM tpmember M";
		$sSql .= " INNER JOIN auth_user_md5 A ON M.cid = A.username";
		$sSql .= " INNER JOIN tmail E ON M.cid = E.cid";
		$sSql .= " INNER JOIN muser U ON M.cid = U.cid";
		$sSql .= sprintf(" WHERE npid = %d", $this->g_pid);
		switch($this->g_kind){
		case 11:
			$sSql .= " AND E.cconv = '2'";
			break;
		default:
			$sSql .= " AND E.cbug = '2'";
			break;
		}
		$this->db->query($sSql);
		while($this->db->next_record()){
			if($this->ckPerm($this->db->f("perms"), "leader")){
				$this->addAddr($this->db->f("cmail"), $this->db->f("cname"), $this->p_toAddrs, $this->p_toNames);
			}
		}
		return count($this->p_toAddrs);
	}
	
	// 送信先事前確認
	function getTos(){
		$num = 0;
		if($this->is_valid()){	// 送信先が無ければ何もしないので
			$res = $this->getData();
			if($res){
				$num = $this->getAddr();
			}
		}
		return $num;
	}
	
	// 送信先リスト文字列生成（メッセージ用）
	function toTos(){
		$tos = "";
		$num = $this->getTos();
		for($indx=0; $indx<$num; $indx++){
			if(strlen($tos) > 0){
				$tos .= "\\n";
			}
			$tos .= sprintf("%s <%s>", $this->p_toNames[$indx], $this->p_toAddrs[$indx]);
		}
		return $tos;
	}
	
	// 送信先リスト文字列生成（メール用）
	function toTosMail(){
	//	mb_internal_encoding("EUC-JP") ;
		mb_internal_encoding($this->cnv->C_CODE) ;
		$tos = "";
		$num = $this->getTos();
		for($indx=0; $indx<$num; $indx++){
			if(strlen($tos) > 0){
				$tos .= ", ";
			}
			$tos .= sprintf("%s <%s>", mb_encode_mimeheader($this->p_toNames[$indx]), $this->p_toAddrs[$indx]);
		}
		return $tos;
	}
	
	// 送信
	function send(){
		$res = TRUE;
		// 送信先
		$to = $this->toTosMail();
		if (strlen($to) > 0)
		{
			mb_language("Japanese") ;
		//	mb_internal_encoding("EUC-JP") ;
			mb_internal_encoding($this->cnv->C_CODE) ;
			// メールインスタンス生成
			global $c_mail_backend;
			$backend = "sendmail";
			$params = array();
			switch($c_mail_backend)
			{
			case 1:		// SMTP
				global $c_smtp_auth;
				global $c_smtp_user;
				global $c_smtp_passwd;
				$backend = "smtp";
				$params = array(
					"host" => ini_get("SMTP") ? ini_get("SMTP") : "localhost",
					"port" => ini_get("smtp_port") ? ini_get("smtp_port") : 25,
					"auth" => $c_smtp_auth,
					"username" => $c_smtp_user,
					"password" => $c_smtp_passwd
				);
				break;
			default:	// sendmail
				$params = array(
					"sendmail_path" => ini_get("sendmail_path"),
					"sendmail_args" => ""
				);
				break;
			}
			$mail = Mail::factory($backend, $params);
		
			if(PEAR::isError($mail) == false)
			{
				// subject
				switch($this->g_kind){
				case 1:
					$subj = "【障害票】" . $this->p_bsubj;
					break;
				case 2:
					$subj = "【障害票(回答)】" . $this->p_bsubj;
					break;
				case 3:
					$subj = "【障害票(確認)】" . $this->p_bsubj;
					break;
				case 11:
					$subj = "【相談】" . $this->p_subj;
					break;
				}
				// ヘッダ
				global $c_mail_from;
				$from = (strlen($c_mail_from) > 4) ? $c_mail_from : ini_get("sendmail_from");
				$header = array(
					"From" => sprintf("%s <%s>", mb_encode_mimeheader("テスト項目運用システム", "ISO-2022-JP"),  $from),
					"Subject" => mb_encode_mimeheader($subj,"ISO-2022-JP")
				);
				// 送信
				global $c_mail_enc;
				$res = $mail->send($to, $header, mb_convert_encoding($this->g_body, $c_mail_enc, "auto"));
			}else{
				$res = $mail;
			}
		}	// 送信対象が無い場合も何もせず正常終了
		if(PEAR::isError($res))
		{
			print($res->getMessage());
			print("<br>\n");
			$res = false;
		}
		return $res;
	}
/*	function send(){
		global $c_mail_from;
		global $c_mail_reply;
		mb_language("Japanese") ;
	//	mb_internal_encoding("EUC-JP") ;
		mb_internal_encoding($this->cnv->C_CODE) ;
		$res = TRUE;
		// 送信先
		$to = $this->toTosMail();
		if(strlen($to) > 0){
			// subject
			switch($this->g_kind){
			case 1:
				$subj = "【障害票】" . $this->p_bsubj;
				break;
			case 2:
				$subj = "【障害票(回答)】" . $this->p_bsubj;
				break;
			case 3:
				$subj = "【障害票(確認)】" . $this->p_bsubj;
				break;
			case 11:
				$subj = "【相談】" . $this->p_subj;
				break;
			}
			// ヘッダ
			if(strlen($c_mail_from) > 4){
				$head  = sprintf("From: %s <%s>\n", mb_encode_mimeheader("テスト項目運用システム"),  $c_mail_from);
			}
			if(strlen($c_mail_reply) > 4){
				$head .= sprintf("Reply-To: %s\n", $c_mail_reply);
			}
			$head .= sprintf("X-Mailer: PHP/%s", phpversion());
			// 送信
			$res = mb_send_mail($to, $subj, $this->g_body, $head);
		}	// 送信対象が無い場合も何もせず正常終了
		return $res;
	}
*/	
	// 送信済み確認
	function getMaxAdd(){
		$max = 0;
		$sSql  = "SELECT max(NADD) AS admax FROM lmail";
		$sSql .= sprintf(" WHERE nkind = %d AND npid = %d AND nid = %d", $this->g_kind, $this->g_pid, $this->g_id);
		$this->db->query($sSql);
		if($this->db->next_record()){
			$max = $this->db->f("admax");
		}
		return $max;
	}
	
	// ログ出力
	function wrLog(){
		$to = addslashes(str_replace("\\n",", ",$this->toTos()));
		if(strlen($to) > 0){
			$this->db->query("BEGIN");
			$this->db->query("LOCK TABLE lmail IN SHARE ROW EXCLUSIVE MODE");
			$nadd = $this->getMaxAdd() + 1;
			$sSql  = "INSERT INTO lmail (nkind, npid, nid, nadd, dsend, cto) VALUES";
			$sSql .= sprintf(" (%d, %d, %d, %d, 'NOW', '%s')",  $this->g_kind, $this->g_pid, $this->g_id, $nadd, $to);
			$this->db->query($sSql);
			$this->db->query("END");
		}
	}
	
	// 一括処理
	function mail(){
		$res = $this->getData();
		if($res){
			$num = $this->getAddr();
			if($num > 0){
				$this->mkBody();
				$res = $this->send();
				if($res){
					$this->wrLog();
				}
			}
		}
		return $res;
	}
}		

class ti_mailUtil
{
	// メールアドレス文字列検証
	// #PEAR::Mailを導入した場合はRFC822パースに変える
	function ckMail($mail){
		$res = FALSE;
		$mail2 = strstr($mail, '@');
		if(strlen($mail2) > 3){
			if(strlen($mail) > strlen($mail2)){
				$res = TRUE;
			}
		}
		return $res;
	}
}

