<?php
/*
*	$id:ti_rdfile.inc (c)A.Ida 2017/3/10 15:37:31
*	ファイル読込クラス
*/

class ti_rdfile {
	var $g_path;
	var $g_path_base;
	var $g_pid;
	var $g_tmpfld;
	var $g_fp;		// ファイルデスクプリタ
	var $g_colNum;	// 総列数
	var $g_erstr;
	var $g_preClsAry = array();
	var $g_preClsIDAry = array();
	var $g_corder;	// 分類order
	var $g_iorder;
	var $g_mkClsNum;
	var $g_erItemNum;
	var $g_clsID;
	var $g_canNext;	// 強制続行可否
	
	var $i_uid;		// デフォルト担当者ＩＤ
	var $i_fcls;	// 分類のみ
	var $i_fcmt;	// 強制コミット
	var $i_fhead;	// 項目行
	var $i_delm;	// デミリタ（0:カンマ 1:タブ）
	
	var $p_clsAry = array();
	var $p_ope;
	var $p_exp;
	var $p_cha1;
	var $p_cha2;
	var $p_imp;
	var $p_dif;
	var $p_plan;
	var $p_memo;
	
	var $db;
	var $cnv;
	
	var $colAry = array();
	
	var $MAX_COL = 18;
	var $g_headAry = array();

	// コンストラクタ
	function ti_rdfile($pid, $path, $tmpfld){
		// 変数初期化
		$this->g_path = $path;
		$this->g_pid = $pid;
		$this->g_tmpfld = $tmpfld;
		$this->g_erstr = "";
		$this->i_uid = "";
		$this->i_fcls = 0;
		$this->i_fcmt = 0;
		$this->i_fhead = 2;
		$this->g_corder = $this->g_iorder = 1;
		$this->g_mkClsNum = $this->g_erItemNum = 0;
		$this->g_clsID = 0;
		$this->g_canNext = TRUE;

		// 直前分類情報記憶領域初期化
		for($i=0; $i<9; $i++){
			$this->g_preClsAry[$i] = "";
			$this->g_preClsIDAry[$i] = 0;
		}
		// ＤＢクラス作成
		$this->db = new DB_Ti;
		// コード変換クラス作成
		$this->cnv = new ti_jconv;
	}
	
	// オープン
	function open()
	{
		$res = FALSE;
		$estr = "";
		// $C_CODEに変換（PHP5ではSJISファイルではfgetcsvが正常動作しないらしい）
		// file_get_contentsは4.3以前では使えない
		$fp = fopen($this->g_path, "rb");
		$buf = "";
		if($fp){
			while (!feof($fp)) {
				$buf .= fread($fp, 8192);
			}
			fclose($fp);
		//	$buf = mb_convert_encoding($buf, $this->C_CODE, "SJIS,UTF-8,EUC-JP,JIS");
			$buf = $this->cnv->to_base($buf);
			// 作業ファイル作成
			$this->g_path_base = sprintf("%s/rdbase_%d.tmp", $this->g_tmpfld, $this->g_pid);
			$this->g_fp = fopen($this->g_path_base, "w+b");
			if($this->g_fp){
				 if($size = fwrite($this->g_fp, $buf)){
				 	rewind($this->g_fp);
				 	$res = TRUE;
				 }else{
					$estr = sprintf("作業ファイル(%s)への書き込みに失敗しました。", $this->g_path_base);
				 }
			}else{
				$estr = sprintf("作業ファイル(%s)の作成に失敗しました。", $this->g_path_base);
			}
		}else{
			$estr = "アップロードファイルを開けません。";
		}
		if($res == FALSE){
			$this->g_canNext = FALSE;
			printf("<p class='error'>%s</p>\n", $estr);
		}
		
		return $res;
	}
	
	// クローズ
	function close()
	{
		if($this->g_fp){
			fclose($this->g_fp);
			// 作業ファイル削除
			unlink($this->g_path_base);
		}
	}
	
	// fgetcsv
	function GetCsvLine(){
		$delm = ",";
		switch($this->i_fdelm){
		case 1:
			$delm = "\t";
			break;
		default:
			break;
		}
		$this->colAry = fgetcsv($this->g_fp, 4096, $delm);
	}
	
	// 項目部解析
	function anaHead(){
		$cflg = $oflg = $eflg = $c1flg = $c2flg = $iflg = $dflg = $pflg = FALSE;
		$this->g_colNum = count($this->colAry);
		if($this->g_colNum > $this->MAX_COL){
			$this->g_colNum = $this->MAX_COL;
		}
		for($i=0; $i<9; $i++){$this->p_clsAry[$i] = "";}
		for($col=0; $col<$this->g_colNum; $col++){
			$this->g_headAry[$col] = "";
			// 分類
			if($swk = strstr($this->colAry[$col], "分類")){
				$no = mb_substr($swk, mb_strlen("分類"));
				$no = (int)(mb_convert_kana($no, "n", $this->cnv->C_CODE));
				if(is_int($no)){
					if(($no > 0) && ($no < 10)){
						$this->g_headAry[$col] = $no-1;
						if($no == 1){
							$cflg = TRUE;
						}
						continue;
					}
				}
			}
			if($this->i_fcls != 1){
				// 操作
				if(strstr($this->colAry[$col], "操作")){
					$this->g_headAry[$col] = "p_ope";
					$oflg = TRUE;
					continue;
				}
				// 結果
				if(strstr($this->colAry[$col], "結果")){
					$this->g_headAry[$col] = "p_exp";
					$eflg = TRUE;
					continue;
				}
				// 主担当
				if(strstr($this->colAry[$col], "主担当")){
					$this->g_headAry[$col] = "p_cha1";
					$c1flg = TRUE;
					continue;
				}
				// 副担当
				if(strstr($this->colAry[$col], "副担当")){
					$this->g_headAry[$col] = "p_cha2";
					$c2flg = TRUE;
					continue;
				}
				// 重要度
				if(strstr($this->colAry[$col], "重要度")){
					$this->g_headAry[$col] = "p_imp";
					$iflg = TRUE;
					continue;
				}
				// 難易度
				if(strstr($this->colAry[$col], "難易度")){
					$this->g_headAry[$col] = "p_dif";
					$dflg = TRUE;
					continue;
				}
				// 予定日
				if(strstr($this->colAry[$col], "予定日")){
					$this->g_headAry[$col] = "p_plan";
					$pflg = TRUE;
					continue;
				}
				// メモ
				if(strstr($this->colAry[$col], "メモ")){
					$this->g_headAry[$col] = "p_memo";
					continue;
				}
			}
		}
		if($cflg == FALSE){
			printf("<p class='error'>「分類１」がありません。<br/>中断します。</p>");
			$this->g_canNext = FALSE;
		}else if($this->i_fcls != 1){
			if($oflg == FALSE){
				print("<p class='error'>「操作」列がありません。中断します。</p>\n");
				$this->g_canNext = FALSE;
			}
			if($eflg == FALSE){
				print("<p class='error'>「結果」列がありません。中断します。</p>\n");
				$this->g_canNext = FALSE;
			}
			if($oflg && $eflg){
				print("<ul>\n");
				if($c1flg == FALSE){
					print("<li>「主担当」列がありません。ログインユーザを主担当として続行します。\n");
				}
				if($c2flg == FALSE){
					print("<li>「副担当」列がありません。ログインユーザを副担当として続行します。\n");
				}
				if($iflg == FALSE){
					print("<li>「重要度」列がありません。値２の重要度で続行します。\n");
				}
				if($dflg == FALSE){
					print("<li>「難易度」列がありません。値２の難易度で続行します。\n");
				}
				if($pflg == FALSE){
					print("<li>「予定日」列がありません。本日で続行します。\n");
				}
				print("</ul>\n");
			}else{
				$cflg = FALSE;
			}
		}
		return $cflg;
	}	
	
	// データ格納変数初期化
	function iniVal(){
		for($i=0; $i<9; $i++){
			$this->p_clsAry[$i] = "";
		}
		$this->p_ope = $this->p_exp = "";
		$this->p_cha1 = $this->p_cha2 = $this->i_uid;
		$this->p_imp = $this->p_dif = 2;
		$this->p_plan = strftime("%Y/%m/%d");
		$this->p_memo = "";
	}
	
	function getColData($col){
		return isset($this->colAry[$col]) ? $this->colAry[$col] : "";
	}
			
	// データ部解析
	// 各列のデータ格納変数に格納
	function anaData(){
		// プロパティ初期化
		$this->iniVal();
		// 各列処理
		for($col=0; $col<$this->g_colNum; $col++){
			$valname = $this->g_headAry[$col];
			if(strlen($valname) > 0){
			// anaHeadで有効列とされた列
				if(is_int($valname)){
				// 分類
//					$this->p_clsAry[(int)($valname)] = $this->colAry[$col];
					$this->p_clsAry[(int)($valname)] = $this->getColData($col);
				}else{
				// その他
//					$this->$valname = $this->colAry[$col];
					$this->$valname = $this->getColData($col);
				}
			}
		}
	}
	
	// ヘッダ処理
	function rdHead(){
		$res = TRUE;
		// ヘッダまでスキップ
		for($i=0; $i<$this->i_fhead - 1; $i++){
			$dmy = fgets($this->g_fp, 4096);
			if($dmy == FALSE){
				$res = FALSE;
				break;
			}
		}
		if($res){
			// ヘッダ
			$this->GetCsvLine();
			if($this->colAry){
				$res = $this->anaHead();
			}
		}
		return $res;
	}
	
	// 空行判定
	function is_blank(&$ary){
		$res = FALSE;
		$num = count($ary);
		if($num == 0){
			$res = TRUE;
		}else if($num == 1){
			if(strlen(trim($ary[0])) == 0){
				$res = TRUE;
			}
		}
		return $res;
	}
												
	
	// 行処理
	// 0:対象あり 1:空行 2:EOF
	function rdData(){
		$res = 2;
		$this->GetCsvLine();
		if($this->colAry){
			if($this->is_blank($this->colAry)){
				$res = 1;
			}else{
				$this->anaData();
				$res = 0;
			}
		}
		return $res;
	}
	
	// 配列比較 
	// return:一致する最後の要素番号
	function cmpAry(&$a1, &$a2, $num){
		// a2が未投入の間、a1の内容を引き継ぐ
		for($i=0; $i<$num; $i++){
			if(strlen($a2[$i]) > 0){
				break;
			}
			if(strlen($a1[$i]) > 0){
				$a2[$i] = $a1[$i];
			}
		}
		// 比較
		for($i=0; $i<$num; $i++){
			if($a1[$i] != $a2[$i]){
				break;
			}
		}
		return $i;
	}
	
	// 分類作成
	function mkClass(){
		$res = TRUE;
		$this->g_clsID = 0;
		$ucid = 0;
		$cmpNum = $this->cmpAry($this->g_preClsAry, $this->p_clsAry, 9);
		for($c=$cmpNum; $c<9; $c++){
		// 直前と同一でない列以降は既存でない可能性あり
			if($this->p_clsAry[$c] == ""){
				for($i=$c; $i<9; $i++){
					$this->g_preClsIDAry[$i] = 0;
				}
				break;	// 終了
			}
			// 既存チェック
			$sSql  = "SELECT ncid FROM vclass";
			$sSql .= " WHERE npid = " . $this->g_pid;
			for($i=0; $i<=$c; $i++){
				if($this->p_clsAry[$i] == ""){
					break;
				}
				$sSql .= sprintf(" AND c%d = '%s'", $i+1, $this->p_clsAry[$i]);
			}
			$this->db->query($sSql);
			if($this->db->next_record()){
				// 既存する場合はＩＤを記録
				$this->g_preClsIDAry[$c] = $this->db->f("ncid");
			}else{
			// 既存しないので作る
				// 親ＩＤ取得
				if($c == 0){
					$ucid = 0;
				}else{
					$ucid = $this->g_preClsIDAry[$c-1];
				}
				// ＩＤ作成
				$sSql = "SELECT nextval('scid') AS ncid";
				$this->db->query($sSql);
				if($this->db->next_record()){
					$cid = $this->db->f("ncid");
					$this->g_preClsIDAry[$c] = $cid;
					// 作成
					$sSql  = "INSERT INTO tclass (npid, ncid, norder, nlvl, nucid, cclass) VALUES (";
					$sSql .= sprintf("%d, %d, %d, %d, %d, '%s'", $this->g_pid, $cid, $this->g_corder, $c+1, $ucid, $this->p_clsAry[$c]);
					$sSql .= ")";
					if($this->db->query($sSql)){
						$this->g_corder++;
						$this->g_mkClsNum++;
					}else{
						$this->g_erstr = sprintf("分類追加エラー：%s(%d)", $this->db->Error, $this->db->Errno);
						$this->g_canNext = FALSE;
						$res = FALSE;
						break;
					}
				}else{
					$this->g_erstr = sprintf("分類ＩＤエラー：%s(%d)", $this->db->Error, $this->db->Errno);
					$this->g_canNext = FALSE;
					$res = FALSE;
					break;
				}
			}
		}
		if($res){
			for($c=0; $c<9; $c++){
				// 分類保存
				$this->g_preClsAry[$c] = $this->p_clsAry[$c];
				// 最下位レベル分類がこの項目の分類
				if($this->g_preClsIDAry[$c] != 0){
					$this->g_clsID = $this->g_preClsIDAry[$c];
				}
			}
			if(($this->g_clsID == 0) && ($this->i_fcls != 1)){
				$this->g_erstr = "有効な分類情報が無いのでこの項目は作成できません。";
				$this->g_erItemNum++;
				$res = FALSE;
			}
		}

		return $res;
	}
	
	// 担当者ＩＤ取得
	function chguid($uid){
		$res = "";
		if($uid == ""){
			$uid = $this->i_uid;
		}
		// まず、IDとして確認
		$sSql = sprintf("SELECT count(*) AS cnt FROM tpmember WHERE npid = %d AND cid = '%s'", $this->g_pid, $uid);
		$this->db->query($sSql);
		$this->db->next_record();
		if($this->db->f("cnt") > 0){
			$res = $uid;
		}else{
			// 名称で確認
			$sSql = sprintf("SELECT cid FROM vpmember WHERE npid = %d AND cname = '%s'", $this->g_pid, $uid);
			$this->db->query($sSql);
			if($this->db->next_record()){
				// 見つかった（複数あったとしてもたまたま最初に見つけたものを有効にする）
				$res = $this->db->f("cid");
			}
		}
		return $res;
	}
	
	// 重要度取得
	// 無い場合は２を使用
	function chgimp($imp){
		global $c_iary;
		global $c_iaryR;
		$res = "";
		if($imp == ""){
		// 無い場合は２を使用
			$imp = 2;
		}
		if(array_key_exists($imp, $c_iaryR)){
			// 数値として有効
			$res = $imp;
		}else if(array_key_exists($imp, $c_iary)){
			// 文字として数値に変換
			$res = $c_iary[$imp];
		}
		return $res;
	}
	
	// 難易度取得
	// 無い場合は２を使用
	function chgdif($dif){
		global $c_dary;
		global $c_daryR;
		$res = "";
		if($dif == ""){
		// 無い場合は２を使用
			$dif = 2;
		}
		if(array_key_exists($dif, $c_daryR)){
			// 数値として有効
			$res = $dif;
		}else if(array_key_exists($dif, $c_dary)){
			// 文字として数値に変換
			$res = $c_dary[$dif];
		}
		return $res;
	}
	
	// 日付
	function chgplan($plan){
		global $c_year_s;
		global $c_year_e;
		$res = "";
		if(strlen($plan) > 0){
			$dary = preg_split("/[.\/ :-]/", $plan);
			if(count($dary) >= 3){
				$y = (int)$dary[0];
				$m = (int)$dary[1];
				$d = (int)$dary[2];
				if(checkdate($m, $d, $y)){
					if(($y >= $c_year_s) && ($y <= $c_year_e)){
						$res = sprintf("to_date('%04d/%02d/%02d', 'YYYY/MM/DD')", $y, $m, $d);
					}
				}
			}
		}else{
			$res = "'NOW'";
		}
		return $res;
	}
	
	// データ行作成
	function insData($cid){
		$estr = "";
		$bflg = FALSE;
		$res = FALSE;
		// チェック及び補正
		if(strlen($this->p_ope) > 0){
			if(strlen($this->p_exp) > 0){
				$this->p_cha1 = $this->chguid($this->p_cha1);
				if(strlen($this->p_cha1) > 0){
					$this->p_cha2 = $this->chguid($this->p_cha2);
					if(strlen($this->p_cha2) > 0){
						$this->p_imp = $this->chgimp($this->p_imp);
						if(strlen($this->p_imp) > 0){
							$this->p_dif = $this->chgdif($this->p_dif);
							if(strlen($this->p_dif) > 0){
								$this->p_plan = $this->chgplan($this->p_plan);
								if(strlen($this->p_plan) > 0){
									$bflg = TRUE;
								}else{
									$estr = "「予定日」が日付として認識できないか範囲外です";
								}
							}else{
								$estr = "「難易度」が割り当てられません";
							}
						}else{
							$estr = "「重要度」が割り当てられません";
						}
					}else{
						$estr = "「副担当」が割り当てられません";
					}
				}else{
					$estr = "「主担当」が割り当てられません";
				}
			}else{
				$estr = "「結果」がありません";
			}
		}else{
			$estr = "「操作」がありません";
		}
		if($bflg){
			// 項目ＩＤ
			$this->db->query("SELECT nextval('siid') AS iid");
			if($this->db->next_record()){
				$iid = $this->db->f("iid");
				// 作成
				$sSql  = "INSERT INTO titem (npid, niid, ncid, norder, cope, cexp, cid, cid2, nimp, ndif, dplan, cmemo) VALUES (";
				$sSql .= sprintf("%d, %d, %d, %d, '%s', '%s', '%s', '%s', %d, %d, %s, '%s'", $this->g_pid, $iid, $cid, $this->g_iorder, $this->p_ope, $this->p_exp, $this->p_cha1, $this->p_cha2, $this->p_imp, $this->p_dif, $this->p_plan, $this->p_memo);
				$sSql .= ")";
				if($this->db->query($sSql)){
					$this->g_iorder++;
					$res = TRUE;
				}else{
					$this->g_erstr = sprintf("項目追加エラー：%s(%d)", $this->db->Error, $this->db->Errno);
					$this->g_canNext = FALSE;
				}
			}
			if($res == FALSE){
				$this->g_erstr = sprintf("項目ＩＤエラー：%s(%d)", $this->db->Error, $this->db->Errno);
				$this->g_canNext = FALSE;
			}
		}else{
			$this->g_erstr = sprintf("%sので項目が作成できません。", $estr);
			$this->g_erItemNum++;
		}
		return $res;
	}
	
	// １行追加
	// rdDataでEOFになるまではエラーでも続行するので復帰値を見てない
	function insOne(){
		$ret = TRUE;
		$this->erstr = "";
		while(($res = $this->rdData()) == 1);	// １行読込（空行skip）
		if($res == 0){
			// 分類処理
			if($this->mkClass()){
				if(($this->i_fcls != 1) && ($this->g_clsID != 0)){
					// データ処理
					$this->insData($this->g_clsID);
				}
			}
		}else{
			$ret = FALSE;	// EOF
		}
		return $ret;
	}
	
	// 排他
	function excl(){
		$res = FALSE;
		// 排他
		$sSql = sprintf("SELECT * FROM tproj WHERE npid = %d FOR UPDATE NOWAIT", $this->g_pid);
		if($this->db->query($sSql)){
			// 項目の既存確認
			$sSql = sprintf("SELECT count(*) AS cnt FROM titem WHERE npid = %d", $this->g_pid);
			$this->db->query($sSql);
			$this->db->next_record();
			if($this->db->f("cnt") > 0){
				printf("<p class='error'>既に項目が登録されています。中断します。</p>\n");
				$this->g_canNext = FALSE;
			}else{
				// 分類が既存する場合にcorderを再設定
				$sSql = sprintf("SELECT max(norder) AS nord FROM tclass WHERE npid = %d", $this->g_pid);
				$this->db->query($sSql);
				if($this->db->next_record()){
					$this->g_corder = $this->db->f("nord") + 1;
				}
				$res = TRUE;
			}
		}else{
			$this->g_canNext = FALSE;
		}
		return $res;
	}
	
	// 全処理
	function insAll(){
		$res = FALSE;
		// トランザクション開始
		$this->db->query("BEGIN");
		// 排他処理
		if($this->excl()){
			// オープン
			if($this->open()){
				// ヘッダ処理
				if($this->rdHead()){
					// 行ループ
					$row = 1;
					print("<table class='warn'>\n");
					while($this->insOne()){
						if(strlen($this->g_erstr) > 0){
							printf("<tr><td align='right'>%d行目</td><td>%s</td></tr>\n", $row, $this->g_erstr);
							$this->g_erstr = "";
						}
						if($this->g_canNext == FALSE){
							break;
						}
						$row++;
					}
					print("</table>\n");
				}
				$this->close();
			}
		}
		// トランザクション終了
		if((($this->i_fcmt == 1) || ($this->g_erItemNum == 0)) && ($this->g_canNext)){
			$this->db->query("COMMIT");
			$res = TRUE;
		}else{
			$this->db->query("ROLLBACK");
		}
		return $res;
	}
}
?>
