<?php
/*
*	$id:ti_tvSvn.inc (c)A.Ida 2017/3/10 15:37:31
*	svn diff ファイルリスト作成（jquery版)
*	どういう分けか、同一ページでMDB2を使うとpopenがハングする現象に遭遇。
*	しかたないので障害画面でURLを取得して通知する仕様に変更 V0.5
*/

class ti_tvsvn {
	var $g_repos;	// リポジトリＵＲＬ
	var $g_pid;
	var $g_rs;		// 開始リビジョン
	var $g_re;		// 終了リビジョン
	var $g_emsg;
	var $g_lvl_pre;
	
//	var $db;
	var $cnv;
	
	var $p_diffAry = array();
	var $p_pathAry = array();

	// コンストラクタ
	function ti_tvsvn($pid, $rs, $re, $url){
		// クラス作成
	//	$this->db = new DB_Ti;
		$this->cnv = new ti_jconv;
		// 初期化
		$this->g_repos = "";
		$this->g_pid = $pid;
		$this->g_rs = $rs;
		$this->g_re = $re;
		$this->g_repos = $url;
		$this->g_emsg = "";
	}
	
	// Grape付きexec() 
	// １行目が該当行でなければ全行を返す
	function exec_ex($cmd, $cond, &$retAry){
		$retAry = array();
		$top = 1;
		
		if($h = popen($cmd, "r"))
		{
			while(!feof($h)){
				$line = fgets($h);
				if(strpos($line, $cond) === FALSE){
					if($top > 0){
						$top = 2;
						$retAry[] = $line;
					}
				}else{
					if($top == 1){
						$top = 0;
					}
					$retAry[] = $line;
				}
			}
			pclose($h);
		}
	}
	
	// パス整形
	// flg:true - サイズがあれば末尾に/を付ける
	function fmtPath($path_, $flg=false){
		$path = trim($path_);
		if(strlen($path) > 0){
			$c = "/";
			if($this->is_win()){
				$c = "\\";
			}
			while(substr($path, -1, 1) == $c){
				$path = substr($path, 0, strlen($path) - 1);
			}
			if($flg){
				if(strlen($path) > 0){
					$path .= $c;
				}
			}
		}
		return $path;
	}
	
	// OS判定
	function is_win(){
		$res = true;
		switch(substr(php_uname('s'),0,1)){
		case 'L':	// Linux
		case 'F':	// FreeBSD
		case 'H':	// HP-UX
		case 'S':	// SunOS
		case 'M':	// Mac
			$res = false;
			break;
		default:
			break;
		}
		return $res;
	}
	
	// svnコマンド編集
	//  2>&1 は標準エラー出力を標準出力にリダイレクト。svn diffはこうしないと空振りする。
	//  URLやpathを\"で囲むとWin2000版ではパラメタエラーになる（コマンドプロンプトでは大丈夫）
	//  全体を\"で囲むとWinは通るがLinuxでエラーになる。
	//  Win2003では--config-dirを指定しないとエラーになる。
	function fmtCmd($cmd_){
		global $c_svn_conf;
		$cmd = $cmd_;
		if(strlen($c_svn_conf) > 0){
			$cmd .= " --config-dir " . $this->fmtPath($c_svn_conf);
		}
// これをやるとpopenでハングする場合があるのでやめる。
//		if($this->is_win()){
//			$cmd = "\"" . $cmd . "\"";
//		}
		$cmd .= " 2>&1";
		return $cmd;
	}
		
	
	// Diff実行
	function svnDiff($path=""){
		global $c_svn_path;
		$res = FALSE;
		$rcode = 0;
		// svn実行
		if(strlen($path)){
			// 指定ファイル
			$cmd = sprintf("\"%ssvn\" diff -r %d:%d --old \"%s\" \"%s\"", $this->fmtPath($c_svn_path, true), $this->g_rs, $this->g_re, $this->g_repos, $path);
			$cmd = $this->fmtCmd($cmd);
			exec($cmd, $this->p_diffAry, $rcode);
		}else{
			// 全体
			$cmd = sprintf("\"%ssvn\" diff -r %d:%d \"%s\"", $this->fmtPath($c_svn_path, true), $this->g_rs, $this->g_re, $this->g_repos);
			$cmd = $this->fmtCmd($cmd);
			$this->exec_ex($cmd, "Index: ", $this->p_diffAry);
		}
		if(count($this->p_diffAry) > 0){
			if($pos = strpos($this->p_diffAry[0], "Index: ") === FALSE){
			}else{
				if($pos == 0){
					$res = TRUE;
				}
			}
		}
		if($res == FALSE){
			$this->g_emsg  = sprintf("svn diff の実行結果を認識できません。Code:%d\n", $rcode);
			if(count($this->p_diffAry) > 0){
				$this->g_emsg .= "<br>\n１行目が\"Index:\"で始まりません。\n";
				for($i=0; $i<count($this->p_diffAry); $i++){
					$this->g_emsg .= "<br>\n" . $this->cnv->to_base($this->p_diffAry[$i]) . "\n";
				}
			}else{
				$this->g_emsg .= "<br>\n結果が１行もありません。\n";
			}
		}
		return $res;
	}
	
	// Log実行
	function svnLog(){
		global $c_svn_path;
		$res = FALSE;
		$rcode = 0;
		// svn実行
		$cmd = sprintf("\"%ssvn\" log -r %d:%d \"%s\"", $this->fmtPath($c_svn_path, true), $this->g_rs, $this->g_re, $this->g_repos);
		$cmd = $this->fmtCmd($cmd);
		exec($cmd, $this->p_diffAry, $rcode);
		if(count($this->p_diffAry) > 3){
			$res = TRUE;
		}
		if($res == FALSE){
			$this->g_emsg  = sprintf("svn log の実行結果を認識できません。Code:%d\n", $rcode);
			for($i=0; $i<count($this->p_diffAry); $i++){
				$this->g_emsg .= "<br>" . $this->cnv->to_base($this->p_diffAry[$i]) . "\n";
			}
		}
		return $res;
	}
	
	// ファイル行だけの配列作成
	function mkPathAry(){
		$max = count($this->p_diffAry);
		for($indx=0; $indx<$max; $indx++){
			$line = $this->p_diffAry[$indx];
			if(strncmp($line, "Index: ", 7) == 0){
				// ファイル名行
				$path = rtrim(mb_substr($line, 7));
				array_push($this->p_pathAry, $path);
			}
		}
		// ソート
		sort($this->p_pathAry, SORT_REGULAR);
	}
	
	// 配列比較
	function arycomp($a1, $a2){
		$max1 = count($a1);
		$max2 = count($a2);
		for($indx=0; ($indx<$max1) && ($indx<$max2); $indx++){
			if($a1[$indx] != $a2[$indx]){
				break;
			}
		}
		return $indx;
	}
	
	// ルート
	function initOut($name){
		print("<ul id='$name' class='filetree'>\n");
	}

	// 出力
	function FListTvOut(&$sess){
		$fldID = 0;
		$filID = 1;
		$flds_pre = array();
		$fldIDs_pre = array();
		$flds = array();
		
		$url = $sess->url("ti_up_bug_svn_diff.php?dmy=svn");
		// ファイル名配列作成
		$this->mkPathAry();
		 
		$max = count($this->p_pathAry);
		$this->g_lvl_pre = 0;
		// ファイルループ
		for($indx=0; $indx<$max; $indx++){
			$path = $this->p_pathAry[$indx];
			$flds = explode("/", $path);
			$lvl = $this->arycomp($flds, $flds_pre);
			$maxfld = count($flds);

			if($lvl < $this->g_lvl_pre)
			{
				// 前ファイルから下がったフォルダを閉じる
				while($lvl < $this->g_lvl_pre){ print("</ul>\n</li>\n"); $this->g_lvl_pre--; }
			}
			// 前ファイル相違フォルダからのパス内フォルダループ
			for(; $lvl<$maxfld-1; $lvl++){
				print("<li>$flds[$lvl]\n<ul>\n");
			}
			// ファイル
			printf("<li><a href='%s&pid=%d&rs=%d&re=%d&repos=%s&path=%s' target='svn_diff'>%s</a></li>\n", $url, $this->g_pid, $this->g_rs, $this->g_re, $this->g_repos, urlencode($path), $flds[$lvl]);

			$this->g_lvl_pre = $lvl;
		}
	}
	
	function endOut(){
		while(0 < $this->g_lvl_pre){ print("</ul>\n</li>\n"); $this->g_lvl_pre--; }
		print("</ul>\n");
	}
}

