--
-- $id:Cr_const.sql (c)A.Ida 2017/3/10 15:37:32
-- 参照整合制約作成 V0.5
-- 古いPostgresは参照整合性制約を削除する機能が無いので要注意
--
-- ユーザの整合
ALTER TABLE muser ADD CONSTRAINT ref_user 
FOREIGN KEY (cid) REFERENCES auth_user_md5(username)
ON DELETE CASCADE;

ALTER TABLE tpmember ADD CONSTRAINT ref_member 
FOREIGN KEY (cid) REFERENCES muser(cid);

-- プロジェクトの整合
ALTER TABLE tpmember ADD CONSTRAINT ref_proj 
FOREIGN KEY (npid) REFERENCES tproj(npid)
ON DELETE CASCADE;

ALTER TABLE tclass ADD CONSTRAINT ref_proj_class
FOREIGN KEY(npid) REFERENCES tproj(npid)
ON DELETE CASCADE;

-- 参照整合の循環が発生するので削除 V0.3.3
-- ALTER TABLE titem ADD CONSTRAINT ref_proj_item
-- FOREIGN KEY(npid) REFERENCES tproj(npid)
-- ON DELETE CASCADE;

ALTER TABLE tbug ADD CONSTRAINT ref_proj_bug
FOREIGN KEY(npid) REFERENCES tproj(npid)
ON DELETE CASCADE;

-- add V0.3
ALTER TABLE tattach ADD CONSTRAINT ref_proj_attach
FOREIGN KEY(npid) REFERENCES tproj(npid)
ON DELETE CASCADE;

-- add V0.3.4
-- delete V0.4 ref_bug_bmarkに移行
-- ALTER TABLE tbmark ADD CONSTRAINT ref_proj_bmark
-- FOREIGN KEY(npid) REFERENCES tproj(npid)
-- ON DELETE CASCADE;

-- add V0.3.4
ALTER TABLE tconvers ADD CONSTRAINT ref_proj_convers
FOREIGN KEY(npid) REFERENCES tproj(npid)
ON DELETE CASCADE;

-- 項目と相談 add V0.3.4
ALTER TABLE tconvers ADD CONSTRAINT ref_item_convers
FOREIGN KEY(npid,niid) REFERENCES titem(npid,niid)
ON DELETE CASCADE;

-- 項目と結果
ALTER TABLE tresult ADD CONSTRAINT ref_item_result
FOREIGN KEY(npid,niid) REFERENCES titem(npid,niid)
ON DELETE CASCADE;


-- 障害と回答
ALTER TABLE tans ADD CONSTRAINT ref_bug
FOREIGN KEY(npid,nbid) REFERENCES tbug(npid,nbid)
ON DELETE CASCADE;

-- 障害と障害参照 add V0.5.1
ALTER TABLE tbugref ADD CONSTRAINT ref_bug_bugref
FOREIGN KEY(npid,nbid) REFERENCES tbug(npid,nbid)
ON DELETE CASCADE;


-- 分類と項目
-- ON DELETE CASCADE追加 V0.3.3
ALTER TABLE titem ADD CONSTRAINT ref_class 
FOREIGN KEY (npid,ncid) REFERENCES tclass(npid,ncid)
ON DELETE CASCADE;

-- メールとユーザ add V0.4
ALTER TABLE tmail ADD CONSTRAINT ref_mail_user
FOREIGN KEY (cid) REFERENCES muser(cid)
ON DELETE CASCADE;

-- リポジトリとプロジェクト add V0.4
ALTER TABLE trepos ADD CONSTRAINT ref_rep_proj
FOREIGN KEY (npid) REFERENCES tproj(npid)
ON DELETE CASCADE;

-- リビジョンと障害回答 add V0.4
ALTER TABLE trev ADD CONSTRAINT ref_rev_ans
FOREIGN KEY (npid, nbid) REFERENCES tans(npid, nbid)
ON DELETE CASCADE;

-- 障害とマーク add V0.4
ALTER TABLE tbmark ADD CONSTRAINT ref_bmark_bug
FOREIGN KEY (npid, nbid) REFERENCES tbug(npid, nbid)
ON DELETE CASCADE;

-- 関連と項目 add V0.4
ALTER TABLE titemref ADD CONSTRAINT ref_ref_item
FOREIGN KEY (npid, niid) REFERENCES titem(npid, niid)
ON DELETE CASCADE;

-- 保留と項目 add V0.5
ALTER TABLE titemhld ADD CONSTRAINT ref_hld_item
FOREIGN KEY (npid, niid) REFERENCES titem(npid, niid)
ON DELETE CASCADE;


