--
-- $id:Cr_titb.sql (c)A.Ida 2017/3/10 15:37:32
-- テスト項目運用システム V0.5.1用
-- 運用後に再実行してはいけないもの
--

--
-- ログインユーザ管理（PEAR::AUTHで使用）
--
-- DROP TABLE auth_user_md5 ;
CREATE TABLE auth_user_md5 (
  user_id varchar(32) PRIMARY KEY,
  username varchar(32) UNIQUE NOT NULL,
  password varchar(32) DEFAULT '' NOT NULL,
  perms varchar(255)
);

-- 初期ユーザ登録
INSERT INTO auth_user_md5 VALUES ('c14cbf141ab1b7cd009356f555b607dc','admin','21232f297a57a5a743894a0e4a801fc3','admin');

--
-- テーブル作成
--

-- ユーザ情報
-- DROP TABLE MUSER;
CREATE TABLE MUSER (
	CID	VARCHAR(32)	NOT NULL,
	CNAME	VARCHAR(40)	NOT NULL,
	DLOGIN	TIMESTAMP,				-- DATE to TIMESTAMP V0.4
	PRIMARY KEY(CID)
);
-- 初期ユーザ登録
INSERT INTO muser VALUES ('admin','admin',NULL);

-- プロジェクト情報 add NROUND V0.3
-- DROP TABLE TPROJ;
CREATE TABLE TPROJ (
	NPID	INT4	NOT NULL,
	NLVL    INT2    NOT NULL,
	NUPID	INT4	NOT NULL,
	CPNAME	TEXT	NOT NULL,
	CSUCCE  CHAR(1) ,
	CID     VARCHAR(16) NOT NULL,
	DMAKE   DATE	NOT NULL,
	DUPDATE DATE	,
	CMEMO   TEXT	,
	NROUND	INT4	,
	PRIMARY KEY(NPID)
);

-- プロジェクトメンバ
-- DROP TABLE TPMEMBER;
CREATE TABLE TPMEMBER (
	NPID	INT4	NOT NULL,
	CID     VARCHAR(16)	NOT NULL,
	PRIMARY KEY(NPID, CID)
);

-- 分類情報
CREATE TABLE TCLASS (
	NPID	INT4	NOT NULL,
	NCID	INT4	NOT NULL,
	NORDER  INT4    NOT NULL,   -- add v0.2
	NLVL    INT2    NOT NULL,
	NUCID	INT4	NOT NULL,
	CCLASS	TEXT	NOT NULL,
	PRIMARY KEY(NPID, NCID)
);

-- 項目情報
-- DROP TABLE TITEM;
CREATE TABLE TITEM (
	NPID	INT4	NOT NULL,
	NIID	INT4	NOT NULL,
	NCID	INT4	NOT NULL,
	NORDER	INT2	NOT NULL,
	COPE	TEXT,
	CEXP	TEXT,
	CID	VARCHAR(32) NOT NULL,
	CID2	VARCHAR(32) NOT NULL,
	NIMP	INT2	NOT NULL,
	NDIF	INT2	NOT NULL,
	DPLAN	DATE,
	CMEMO	TEXT,
	PRIMARY KEY(NPID, NIID)
);

-- テスト実施結果
-- DROP TABLE TRESULT;
CREATE TABLE TRESULT (
	NPID	INT4	NOT NULL,
	NIID	INT4	NOT NULL,
	NROUND	INT2	NOT NULL,      -- 回数
	CID_R	VARCHAR(32) NOT NULL,  -- 実施者  
	DEXEC	TIMESTAMP	NOT NULL,  -- 実施日 DATE to TIMESTAMP V0.4
	PRIMARY KEY(NPID, NIID, NROUND)
);

-- 障害票（発行）
-- DROP TABLE TBUG;
CREATE TABLE TBUG (
	NPID	INT4    NOT NULL,
	NBID	INT4    NOT NULL,
	NIID	INT4    ,
	NROUND	INT2    ,
	CTITLE	TEXT    NOT NULL,       -- 表題
	CID_B	VARCHAR(32) NOT NULL,   -- 発行者
	DISSUE	DATE	NOT NULL,       -- 発行日        
	CPHENO	TEXT    NOT NULL,       -- 現象
	CPROC	TEXT    ,               -- 手順
	NIMP_B	INT2    ,               -- 重度
	DTERM	DATE    ,               -- 回答期限
	CID_P	VARCHAR(32) NOT NULL,   -- 回答担当
	CNOTE	TEXT,                   -- 備考
	PRIMARY KEY(NPID,NBID)
);

-- 障害票（回答）
-- DROP TABLE TANS;
CREATE TABLE TANS (
	NPID	INT4    NOT NULL,
	NBID	INT4    NOT NULL,
	CID_A	VARCHAR(32) NOT NULL,   -- 回答者
	DANS	DATE    NOT NULL,       -- 回答日
	CCAUSE	TEXT    NOT NULL,       -- 原因
	CCOPE	TEXT    ,               -- 対処
	NKIND	INT2    ,               -- 種別
	CSRC	TEXT    ,               -- 修正対象
	CID_C	VARCHAR(32) ,           -- 確認者
	DCONF	DATE    ,               -- 確認日
	PRIMARY KEY(NPID,NBID)
);

-- 添付資料 add V0.3
-- DROP TABLE TATTACH;
CREATE TABLE TATTACH (
	NATTACH INT4    NOT NULL,
	NPID	INT4	NOT NULL, 
	CKIND   CHAR(1) NOT NULL,   -- C:共通 I:項目 B:障害 A:障害回答
	NIID	INT4	NOT NULL,   -- 項目番号 or 障害番号
	NADD    INT4    NOT NULL,   -- 追番
	CFNAME  TEXT    NULL,
	CCMNT	TEXT	NULL,
	CID     VARCHAR(32) NULL,
	NATTACH_S   INT4    NULL,   -- リンク用
	PRIMARY KEY(NPID, CKIND, NIID, NADD)
);

-- 障害票マーク add V0.3.4
-- DROP TABLE TBMARK;
CREATE TABLE TBMARK (
	CID		VARCHAR(32)	NOT NULL,
	NPID	INT4    	NOT NULL,
	NBID	INT4    	NOT NULL,
	PRIMARY KEY(CID, NPID, NBID)
);


-- 相談テーブル add V0.3.4
-- DROP TABLE TCONVERS;
CREATE TABLE TCONVERS (
	NCKEY	INT4		NOT NULL,
	NUCKEY	INT4		NULL,
	NPID	INT4		NOT NULL,
	NIID	INT4		NULL,
	NBID	INT4		NULL,
	CID		VARCHAR(32)	NOT NULL,
	CSUBJ	TEXT		NOT NULL,
	CBODY	TEXT		NOT NULL,
	DWRITE	TIMESTAMP	NOT NULL,
	CID_A	VARCHAR(32)	NULL,
	DTERM	DATE		NULL,
	DREAD	TIMESTAMP	NULL,
	PRIMARY KEY(NCKEY)
);

-- メアドテーブル add V0.4
-- DROP TABLE TMAIL;
CREATE TABLE TMAIL (
	CID		VARCHAR(32)			NOT NULL,
	CBUG	CHAR(1)				NOT NULL,	-- 0:不許可 1:許可 2:全件
	CCONV	CHAR(1)				NOT NULL,	-- 0:不許可 1:許可 2:全件
	CRECOG	CHAR(1)	Default '0' NOT NULL,	-- 現版未使用
	CMAIL	VARCHAR(64) 		NOT NULL,
	PRIMARY KEY(CID)
);

-- メール発信ログ add V0.4
-- DROP TABLE LMAIL;
CREATE TABLE LMAIL (
	NKIND	INT4			NOT NULL,		-- 1:障害発行 2:回答 3:確認 11:相談
	NPID	INT4			NOT NULL,		-- 
	NID		INT4			NOT NULL,		-- 障害:nbid 相談:nckey
	NADD	INT4			NOT NULL,
	DSEND	TIMESTAMP		NOT NULL,
	CTO		TEXT			NULL,			-- 
	PRIMARY KEY(NKIND,NPID,NID,NADD,DSEND)
);

-- リポジトリテーブル add V0.4
-- DROP TABLE TREPOS;
CREATE TABLE TREPOS (
	NPID	INT4			NOT NULL,
	CURL	VARCHAR(256)	NOT NULL,
	PRIMARY KEY(NPID)
);

-- リビジョンテーブル add V0.4
-- DROP TABLE TREV;
CREATE TABLE TREV (
	NPID	INT4	NOT NULL,
	NBID	INT4	NOT NULL,
	NADD	INT4	Default 1	NOT NULL, 
	NRS		INT4	NOT NULL,
	NRE		INT4	NOT NULL,
	PRIMARY KEY(NPID,NBID,NADD)
);

-- 項目関連付けテーブル add V0.4
-- DROP TABLE TITEMREF;
CREATE TABLE TITEMREF (
	NPID	INT4			NOT NULL,	
	NIID	INT4			NOT NULL,	-- 項目ＩＤ
	CKIND	CHAR(1)			NOT NULL,	-- B:障害票 R:根拠
	NADD	INT4			NOT NULL,
	NPID_O	INT4			NOT NULL,
	NID_O	INT4			NOT NULL,	-- 障害番号など
	PRIMARY KEY(NPID, NIID, CKIND, NADD)
);

-- 保留テーブル add V0.5
-- DROP TABLE TITEMHLD;
CREATE TABLE TITEMHLD (
	NPID	INT4			NOT NULL,	
	NIID	INT4			NOT NULL,	-- 項目ＩＤ
	CKIND	CHAR(1)			NOT NULL,	-- B:障害票 R:根拠
	NADD	INT4			NOT NULL,
	NPID_O	INT4			NOT NULL,
	NID_O	INT4			NOT NULL,	-- 障害番号など
	PRIMARY KEY(NPID, NIID, CKIND, NADD)
);

-- 障害票参照テーブル add V0.5.1
CREATE TABLE TBUGREF (
	NPID	INT4    NOT NULL,
	NBID	INT4    NOT NULL,
	NIID	INT4    ,
	NROUND	INT2    ,
	PRIMARY KEY(NPID,NBID,NIID)
);
	
--
-- シーケンス作成
--

-- プロジェクトＩＤ
-- DROP SEQUENCE spid;
CREATE SEQUENCE spid;

-- 分類ＩＤ
-- DROP SEQUENCE scid;
CREATE SEQUENCE scid;

-- 項目ＩＤ
-- DROP SEQUENCE siid;
CREATE SEQUENCE siid;

-- 添付資料ＩＤ add V0.3
-- DROP SEQUENCE satid;
CREATE SEQUENCE satid;

-- 相談ＩＤ add V0.3.4
-- DROP SEQUENCE sconvers;
CREATE SEQUENCE sconvers;
