--
-- $id:Cr_tilog_trg.sql (c)A.Ida 2010/9/27 22:54:26
-- ƥȹܱѥƥ V0.5
-- Ͽѥȥꥬ
--

-- LPROJ
CREATE or REPLACE FUNCTION wl_lproj() RETURNS trigger AS '
declare
begin
	INSERT INTO LPROJ(
		DCHG_L,
		CACT_L,
		NPID,
		NLVL,
		NUPID,
		CPNAME,
		CSUCCE,
		CID,
		DMAKE,
		DUPDATE,
		CMEMO,
		NROUND
	)VALUES(
		CURRENT_TIMESTAMP,
		TG_ARGV[0],
		OLD.NPID,
		OLD.NLVL,
		OLD.NUPID,
		OLD.CPNAME,
		OLD.CSUCCE,
		OLD.CID,
		OLD.DMAKE,
		OLD.DUPDATE,
		OLD.CMEMO,
		OLD.NROUND
	);
	RETURN NEW;
end;
' LANGUAGE 'plpgsql';

DROP TRIGGER trg_lproj_update ON TPROJ;
CREATE TRIGGER trg_lproj_update
	BEFORE UPDATE ON TPROJ FOR EACH ROW
	EXECUTE PROCEDURE wl_lproj('U');

DROP TRIGGER trg_lproj_delete ON TPROJ;
CREATE TRIGGER trg_lproj_delete
	BEFORE DELETE ON TPROJ FOR EACH ROW
	EXECUTE PROCEDURE wl_lproj('D');

-- LCLASS
CREATE or REPLACE FUNCTION wl_lclass() RETURNS trigger AS '
declare
begin
	INSERT INTO LCLASS(
		DCHG_L,
		CACT_L,
		NPID,
		NCID,
		NORDER,
		NLVL,
		NUCID,
		CCLASS
	)VALUES(
		CURRENT_TIMESTAMP,
		TG_ARGV[0],
		OLD.NPID,
		OLD.NCID,
		OLD.NORDER,
		OLD.NLVL,
		OLD.NUCID,
		OLD.CCLASS
	);
	RETURN NEW;
end;
' LANGUAGE 'plpgsql';
		
DROP TRIGGER trg_lclass_update ON TCLASS;
CREATE TRIGGER trg_lclass_update
	BEFORE UPDATE ON TCLASS FOR EACH ROW
	EXECUTE PROCEDURE wl_lclass('U');

DROP TRIGGER trg_lclass_delete ON TCLASS;
CREATE TRIGGER trg_lclass_delete
	BEFORE DELETE ON TCLASS FOR EACH ROW
	EXECUTE PROCEDURE wl_lclass('D');

-- LITEM
CREATE or REPLACE FUNCTION wl_litem() RETURNS trigger AS '
declare
begin
	INSERT INTO LITEM(
		DCHG_L,
		CACT_L,
		NPID,
		NIID,
		NCID,
		NORDER,
		COPE,
		CEXP,
		CID,
		CID2,
		NIMP,
		NDIF,
		DPLAN,
		CMEMO
	)VALUES(	
		CURRENT_TIMESTAMP,
		TG_ARGV[0],
		OLD.NPID,
		OLD.NIID,
		OLD.NCID,
		OLD.NORDER,
		OLD.COPE,
		OLD.CEXP,
		OLD.CID,
		OLD.CID2,
		OLD.NIMP,
		OLD.NDIF,
		OLD.DPLAN,
		OLD.CMEMO
	);
	RETURN NEW;
end;
' LANGUAGE 'plpgsql';

DROP TRIGGER trg_litem_update ON TITEM;
CREATE TRIGGER trg_litem_update
	BEFORE UPDATE ON TITEM FOR EACH ROW
	EXECUTE PROCEDURE wl_litem('U');

DROP TRIGGER trg_litem_delete ON TITEM;
CREATE TRIGGER trg_litem_delete
	BEFORE DELETE ON TITEM FOR EACH ROW
	EXECUTE PROCEDURE wl_litem('D');

-- LRESULT
CREATE or REPLACE FUNCTION wl_lresult() RETURNS trigger AS '
declare
begin
	INSERT INTO LRESULT(
		DCHG_L,
		CACT_L,
		NPID,
		NIID,
		NROUND,
		CID_R,
		DEXEC
	)VALUES(
		CURRENT_TIMESTAMP,
		TG_ARGV[0],
		OLD.NPID,
		OLD.NIID,
		OLD.NROUND,
		OLD.CID_R,
		OLD.DEXEC
	);
	RETURN NEW;
end;
' LANGUAGE 'plpgsql';
		
DROP TRIGGER trg_lresult_update ON TRESULT;
CREATE TRIGGER trg_lresult_update
	BEFORE UPDATE ON TRESULT FOR EACH ROW
	EXECUTE PROCEDURE wl_lresult('U');

DROP TRIGGER trg_lresult_delete ON TRESULT;
CREATE TRIGGER trg_lresult_delete
	BEFORE DELETE ON TRESULT FOR EACH ROW
	EXECUTE PROCEDURE wl_lresult('D');

-- LBUG
CREATE or REPLACE FUNCTION wl_lbug() RETURNS trigger AS '
declare
begin
	INSERT INTO LBUG(
		DCHG_L,
		CACT_L,
		NPID,
		NBID,
		NIID,
		NROUND,
		CTITLE,
		CID_B,
		DISSUE,
		CPHENO,
		CPROC,
		NIMP_B,
		DTERM,
		CID_P,
		CNOTE
	)VALUES(
		CURRENT_TIMESTAMP,
		TG_ARGV[0],
		OLD.NPID,
		OLD.NBID,
		OLD.NIID,
		OLD.NROUND,
		OLD.CTITLE,
		OLD.CID_B,
		OLD.DISSUE,
		OLD.CPHENO,
		OLD.CPROC,
		OLD.NIMP_B,
		OLD.DTERM,
		OLD.CID_P,
		OLD.CNOTE
	);
	RETURN NEW;
end;
' LANGUAGE 'plpgsql';
		
DROP TRIGGER trg_lbug_update ON TBUG;
CREATE TRIGGER trg_lbug_update
	BEFORE UPDATE ON TBUG FOR EACH ROW
	EXECUTE PROCEDURE wl_lbug('U');

DROP TRIGGER trg_lbug_delete ON TBUG;
CREATE TRIGGER trg_lbug_delete
	BEFORE DELETE ON TBUG FOR EACH ROW
	EXECUTE PROCEDURE wl_lbug('D');

		
-- LANS
CREATE or REPLACE FUNCTION wl_lans() RETURNS trigger AS '
declare
begin
	INSERT INTO LANS(
		DCHG_L,
		CACT_L,
		NPID,
		NBID,
		CID_A,	
		DANS,
		CCAUSE,	
		CCOPE,
		NKIND,
		CSRC,
		CID_C,	
		DCONF
	)VALUES(
		CURRENT_TIMESTAMP,
		TG_ARGV[0],
		OLD.NPID,
		OLD.NBID,
		OLD.CID_A,
		OLD.DANS,
		OLD.CCAUSE,
		OLD.CCOPE,
		OLD.NKIND,
		OLD.CSRC,
		OLD.CID_C,
		OLD.DCONF
	);
	RETURN NEW;
end;
' LANGUAGE 'plpgsql';

DROP TRIGGER trg_lans_update ON TANS;
CREATE TRIGGER trg_lans_update
	BEFORE UPDATE ON TANS FOR EACH ROW
	EXECUTE PROCEDURE wl_lans('U');

DROP TRIGGER trg_lans_delete ON TANS;
CREATE TRIGGER trg_lans_delete
	BEFORE DELETE ON TANS FOR EACH ROW
	EXECUTE PROCEDURE wl_lans('D');

