--
-- $id:alt033to034.sql (c)A.Ida 2017/3/10 15:37:32
-- テスト項目運用システム　ＤＢバージョンアップ
-- V0.3.4で追加したテーブルを作成します。
-- 変更後も、V0.3 V0.3.1 V0.3.2 V0.3.3 V0.3.4 でＤＢを共有可能です。
--

-- 障害票マーク
-- DROP TABLE TBMARK;
CREATE TABLE TBMARK (
	CID	VARCHAR(32)	NOT NULL,
	NPID	INT4    	NOT NULL,
	NBID	INT4    	NOT NULL,
	PRIMARY KEY(CID, NPID, NBID)
);

ALTER TABLE tbmark ADD CONSTRAINT ref_proj_bmark
FOREIGN KEY(npid) REFERENCES tproj(npid)
ON DELETE CASCADE;

-- 相談テーブル
-- DROP TABLE TCONVERS;
CREATE TABLE TCONVERS (
	NCKEY	INT4		NOT NULL,
	NUCKEY	INT4		NULL,
	NPID	INT4		NOT NULL,
	NIID	INT4		NULL,
	NBID	INT4		NULL,
	CID	VARCHAR(32)	NOT NULL,
	CSUBJ	TEXT		NOT NULL,
	CBODY	TEXT		NOT NULL,
	DWRITE	TIMESTAMP	NOT NULL,
	CID_A	VARCHAR(32)	NULL,
	DTERM	DATE		NULL,
	DREAD	TIMESTAMP	NULL,
	PRIMARY KEY(NCKEY)
);

DROP INDEX joConvers;
CREATE INDEX joConvers
ON tconvers
(nuckey);
DROP INDEX joConvers2;
CREATE INDEX joConvers2
ON tconvers
(npid);

ALTER TABLE tconvers ADD CONSTRAINT ref_proj_convers
FOREIGN KEY(npid) REFERENCES tproj(npid)
ON DELETE CASCADE;
ALTER TABLE tconvers ADD CONSTRAINT ref_item_convers
FOREIGN KEY(npid,niid) REFERENCES titem(npid,niid)
ON DELETE CASCADE;

-- 相談ＩＤ
-- DROP SEQUENCE sconvers;
CREATE SEQUENCE sconvers;

-- 相談ビュー
DROP VIEW vconvers;
CREATE VIEW vconvers AS
SELECT
	C.*,
	C2.nckey AS nans,	-- 回答の発言ＩＤ
	C3.cid AS cuid		-- 相談者
FROM
	tconvers C
	INNER JOIN tproj P ON P.npid = C.npid AND P.csucce IS null
	LEFT JOIN tconvers C2 ON C2.nuckey = C.nckey
	LEFT JOIN tconvers C3 ON C3.nckey = C.nuckey;
;

-- 担当者として登録されているか確認
CREATE or REPLACE FUNCTION chkUsedMemb(INTEGER, TEXT) RETURNS TEXT AS '
declare
    pid alias for $1;
    id alias for $2;
    sret TEXT;
    rrow tresult%ROWTYPE;
    irow titem%ROWTYPE;
begin
    if char_length(id) > 0 then
    	SELECT * INTO rrow
	FROM tresult
	WHERE npid = pid AND cid_r = id;
	if NOT FOUND then
	    SELECT * INTO irow
	    FROM titem
	    WHERE npid = pid AND (cid = id OR cid2 = id);
	    if NOT FOUND then
	        return ''0''; -- 未使用
	    else
                return ''1''; -- 使用済
            end if;
	else
            return ''1''; -- 使用済
	end if;
    else
        return ''0'';     -- 対象外
    end if;
end;
' LANGUAGE 'plpgsql';

-- 正常終了後、ご使用の環境に合わせて権限付与のSQLを実行してください。
-- Webサーバの実行ユーザに合わせて事前に編集が必要です。詳細はインストール手順書
-- を参照してください。
-- Linux   - Apache : Gr_ti.sql (install_vine26_php3.htm/install_vine31_php4.htm)
-- Windows - IIS    : Gr_ti_iis.sql (install_win_iis.htm)
-- Windows - Apache : Gr_ti_win.sql (install_win_apache.htm)

