--
-- $id:alt04to041.sql (c)A.Ida 2017/3/10 15:37:32
-- テスト項目運用システム　ＤＢバージョンアップ
-- V0.4.1で追加・変更したファンクションを反映します。
--

-- １行抽出 append V0.4.1
CREATE or REPLACE FUNCTION oneline(TEXT) RETURNS TEXT AS 
$BODY$
declare
	strin alias for $1;
	sret TEXT;
	indx INTEGER;
begin
	indx := position(E'\r' in strin);
	if indx = 0 then
		indx := position(E'\n' in strin);
	end if;
	if indx > 0 then
		if indx = 1 then
			sret := ' ';
		else
			sret := substring(strin from 1 for indx-1);
		end if;
	else
		sret := strin;
	end if;
	return sret;
end;
$BODY$
 LANGUAGE 'plpgsql';

-- 分類のフルネーム生成 exchenge V0.4.1
CREATE or REPLACE FUNCTION get_fullcname(INTEGER, INTEGER, TEXT) RETURNS TEXT AS '
declare
    pid alias for $1;
    p1  alias for $2;
    p2  alias for $3;
    sret TEXT;
    prow tclass%ROWTYPE;
begin
    sret := oneline(p2);
    if p1 > 0 then
        SELECT * INTO prow FROM tclass WHERE npid = pid AND tclass.ncid = p1;
        sret := oneline(prow.cclass) || '' - '' || sret;
        sret := get_fullcname(pid, prow.nucid, sret);
    end if;
    return sret;
end;
' LANGUAGE 'plpgsql';

