--
-- $id:alt05to051.sql (c)A.Ida 2017/3/10 15:37:32
-- テスト項目運用システム　ＤＢバージョンアップ
-- V0.5.1で追加したテーブルを反映します。
--

CREATE TABLE TBUGREF (
	NPID	INT4    NOT NULL,
	NBID	INT4    NOT NULL,
	NIID	INT4    ,
	NROUND	INT2    ,
	PRIMARY KEY(NPID,NBID,NIID)
);
ALTER TABLE tbugref ADD CONSTRAINT ref_bug_bugref
FOREIGN KEY(npid,nbid) REFERENCES tbug(npid,nbid)
ON DELETE CASCADE;


DROP VIEW vbugref;
CREATE VIEW vbugref AS
SELECT
	NPID,
	NBID,
	NIID,
	NROUND,
	CCAUSE
FROM VBUG2
UNION
SELECT
	R.NPID,
	R.NBID,
	R.NIID,
	R.NROUND,
	B.CCAUSE
FROM TBUGREF R LEFT JOIN VBUG2 B USING(NPID, NBID)
;

CREATE or REPLACE FUNCTION ckBug(INTEGER, INTEGER) RETURNS INTEGER AS '
declare
	pid alias for $1;
	iid alias for $2;	
	ret integer;
	bug_cnt integer;
	ans_cnt integer;
begin
	SELECT count(npid), count(ccause) 
	INTO bug_cnt, ans_cnt
	FROM vbugref
	WHERE npid = pid AND niid = iid;
	if bug_cnt = 0 then
		ret := 0;   -- 
	else
		if bug_cnt = ans_cnt then
			ret := 1;   -- 
		else
			ret := 2;   -- 
		end if;
	end if;
	return ret;
end;
' LANGUAGE 'plpgsql';

-- 項目に関連した障害の抽出
CREATE or REPLACE FUNCTION get_Bugs2(INTEGER, INTEGER, INTEGER) RETURNS TEXT AS '
declare
	pid alias for $1;	-- プロジェクト番号
	iid alias for $2;	-- 項目番号
	nr alias for $3;	-- 実施回数
	sret TEXT;
	prow tbug%ROWTYPE;
	rrow tbugref%ROWTYPE;
begin
	sret := '''';
	for prow IN SELECT * FROM tbug WHERE npid = pid AND niid = iid AND nround = nr loop
		if sret != '''' then
			sret := sret || '':'';
		end if;
		sret := sret || to_char(prow.npid, ''FM0999'') || ''-'' || to_char(prow.nbid, ''FM0999'');
	end loop;
	for rrow IN SELECT * FROM tbugref WHERE npid = pid AND niid = iid AND nround = nr loop
		if sret != '''' then
			sret := sret || '':'';
		end if;
		sret := sret || to_char(rrow.npid, ''FM0999'') || ''-'' || to_char(rrow.nbid, ''FM0999'');
	end loop;
	return sret;
end;
' LANGUAGE 'plpgsql';

