<?php
/*
*	$id:test2.php (c)A.Ida 2017/3/10 15:37:30
*	インストール簡易確認
*/
header("Content-Type: text/html;charset=UTF-8");
error_reporting(E_ALL & ~E_DEPRECATED & ~E_STRICT);
?>
<html>
<head>
<title>テスト項目運用システム - インストール簡易確認</title>
</head>
<body>
<p>
テスト項目運用システムの実行環境を簡単にチェックし結果を表示します。<br>
標準的な設定でインストールされていることを前提としています。
独自な設定をされている場合には不当なエラーを表示するかもしれません。<br>
また、これでエラーが見つからないからといって問題なしと断定できるわけでもないです。
</p>
<hr>
<br>
<?php
$g_msg = "";

if(ck_cfg())
{
	print("php.ini設定値チェック：ＯＫ<br>\n");
	if(ck_exist())
	{
		print("インストール忘れチェック：ＯＫ<br>\n");
		if(ck_extent())
		{
			print("ＰＨＰ拡張モジュールチェック：ＯＫ<br>\n");
			if(ck_final())
			{
				print("その他、ＤＢ等チェック：ＯＫ<br>\n");
			}
			else
			{
				$g_msg = "<b>環境に問題があるようです。</b><br>\n" . $g_msg;
			}
		}
		else
		{
			$g_msg = "<b>ＰＨＰの拡張モジュールに不足があるようです。</b><br>\n" . $g_msg;
		}
	}
	else
	{
		$g_msg = "<b>不足しているファイルがあるようです。</b><br>\n" . $g_msg;
	}
}
else
{
	$g_msg = "<b>php.iniの設定に問題があるようです。</b><br>\n" . $g_msg;
}

if(strlen($g_msg) == 0){
	$g_msg = "エラーは見つけられませんでした。";
}else{
	$g_msg = "<font color='red'>\n" . $g_msg . "</font>\n";
}


// include_pathを対象にしたfile_exists()もどき
function file_exists_pls($fpath)
{
	$res = false;
	$fp = @fopen($fpath, "r", 1);
	if($fp)
	{
		fclose($fp);
		$res = true;
	}
	return $res;
}

function ck_exist()
{
	global $g_msg;
	$bret = true;
	clearstatcache();
	// Auth
	if (!file_exists_pls("Auth/Auth.php"))
	{
		$g_msg .= "PEARのAuthがインストールされていないようです。<br>";
		$bret = false;
	}
	// MDB2
	if(!file_exists_pls("MDB2.php"))
	{
		$g_msg .= "PEARのMDB2がインストールされていないようです。<br>";
		$bret = false;
	}
	// PGSQL
	if(!file_exists_pls("MDB2/Driver/pgsql.php"))
	{
		$g_msg .= "PEARのMDB2_Driver_pgsqlがインストールされていないようです。<br>";
		$bret = false;
	}
	// JQUERY
	if((!file_exists("jq/jquery.js")) || (!file_exists("jq/tv/jquery.treeview.js")))
	{
		$g_msg .= "jQuery,treeviewがコピーされていないか変名し忘れているようです。<br>\n";
		$bret = false;
	}
	return $bret;
};

function ck_extent()
{
	global $g_msg;
	$bret = true;
	$extary = get_loaded_extensions();
	if(!array_search("mbstring", $extary, false))
	{
		$g_msg .= "mbstringがロードされていないようです。<br>\n";
		$bret = false;
	}
	if(!array_search("pgsql", $extary, false))
	{
		$g_msg .= "pgsqlがロードされていないようです。<br>\n";
		$bret = false;
	}
	if(!array_search("gd", $extary, false))
	{
		$g_msg .= "gdがロードされていないようです。<br>\n";
		$bret = false;
	}
	return $bret;
};

function ck_cfg()
{
	global $g_msg;
	$bret = true;
	$var = get_cfg_var("magic_quotes_gpc");
	if($var != "" && $var != "0")
	{
		$g_msg .= "magic_quotes_gpcをOffにしてください。<br>\n";
		$bret = false;
	}
	$var = strtolower(get_include_path());
	//if(strpos($var, "pear") === false)
	if(!file_exists_pls("PEAR.php"))
	{
		$g_msg .= "include_pathにpearが見つかりません。php.iniのinclude_pathの設定 又は httpd.confで.htaccessが有効になるようにAllowOverrideが設定されているか確認してください。<br>\n";
		$bret = false;
	}
	if(strpos($var, "lib") === false)
	{
		$g_msg .= "include_pathにlibが見つかりません。php.iniのinclude_pathの設定 又は httpd.confで.htaccessが有効になるようにAllowOverrideが設定されているか確認してください。<br>\n";
		$bret = false;
	}
	return $bret;
};
	
function ck_final()
{
	global $g_msg;
	global $c_attach;
	$bret = true;
	// DB
	if (file_exists_pls("ti_db.inc"))
	{
include_once("ti_db.inc");
		$db = new DB_Ti;
		if ($db->p_db == null)
		{
			$g_msg = "データベースに接続できません。\n" . $db->Error . "<br>\n";
			$bret = false;
		}
		else
		{
			$bret = $db->query("SELECT count(*) AS cnt FROM muser");
			if($bret)
			{
				if(!($db->next_record()))
				{
					$g_msg .= "データベースの内容に問題があるようです。<br>\n";
					$bret = false;
				}
			}else{
				$g_msg .= "データベース環境に問題があるようです。<br>\n" . $db->Error . "<br>\n" . $db->ErrDetail . "<br>\n";
			}
		}
		// attach - 環境によっては正しい結果が得られないもよう
		if(!is_writeable($c_attach))
		{
			$g_msg .= "添付ファイル格納先($c_attach)が書き込み禁止です。<br>\n";
			$bret = false;
		}
	}
	else
	{
		$g_msg .= "libディレクトリ配下のファイルを見つけられません。include_pathを見直してください。\nＤＢと添付ファイル格納先のテストを省略します。<br>";
		$bret = false;
	}
	return $bret;
}

?>
<div align="center">
<?php print($g_msg); ?>
</div>
</body>
</html>
