<?php
/*
*	$id:ti_ana_class.php (c)A.Ida 2017/3/10 15:37:30
*	テスト項目運用システム - 分類別項目数
*/
include("ti_prepend.inc");
page_open(array("sess"=>"Ti_Session",
		"auth"=>"Ti_Auth",
		"perm"=>"Ti_Perm"));
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<link rel="STYLESHEET" href="tistyle.css" type="TEXT/CSS">
<SCRIPT Language="JavaScript">
<!--
// -->
</SCRIPT>
<title>テスト項目運用システム - 分類別項目数</title>
</head>

<body class="fit">

<?php
$req = new ti_request();
$g_pid = $req->getReqCheck("pid");
$db = new DB_Ti;
$get = new ti_get($db);
$pname = $get->fullPrjName($g_pid);
// 分類の最大階層決定
$sSql = sprintf("SELECT MAX(cntClass(npid,ncid,0)) AS ccnt from tclass WHERE npid = %d", $g_pid);
$db->query($sSql);
$db->next_record();
$ccnt = $db->f("ccnt");
?>
<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr><td class="proj" width="100%">分類別項目数分布表：
<?php print($pname); ?>
</td></tr>
</table>
<form name="frmAnaClass" method="POST" action="<?php $sess->purl("ti_ana_class_act.php");?>">
<table>
<tr><td>
<p class="caption">
分類毎のテスト項目数です。ガバレッジ判定の参考にしてください。
</p>
</td><td align="right">
<input type="button" value="閉じる" onClick="window.close();">
</td></tr>
<tr><td colspan="2">
<table class="view" border="1" cellspacing="0">
<tr>
<th nowrap><font size="-1">項番</font></th>
<?php
for($c=0;$c<$ccnt;$c++){
	printf("<th nowrap><font size=\"-1\">分類%02d</font></th>\n", $c+1);
}
?>
<th nowrap><font size="-1">直下項目数</font></th>
<th nowrap><font size="-1">配下項目数</font></th>
</tr>
<?php
// 各分類直下の項目数取得
$sSql  = sprintf("SELECT * FROM vanaclass WHERE npid = %d ", $g_pid);
$sSql .= "ORDER BY o1, o2, o3, o4, o5, o6, o7, o8, o9";
$db->query($sSql);
// 各レベルの各分類配下合計項目数取得（最下位を除く）
for($c=1; $c<$ccnt; $c++){
	$dbAry[$c] = new DB_Ti;
	$sSql  = sprintf("SELECT n%d, sum(cnt) AS itemnum, count(*) AS spn FROM vanaclass WHERE npid = %d AND n%d != 0 ", $c, $g_pid, $c);
	$sSql .= "GROUP BY n1, o1";
	for($c2=2; $c2<=$c; $c2++){ 
		$sSql .= sprintf(", n%d, o%d", $c2, $c2);
	}
	$sSql .= " ORDER BY o1";
	for($c2=2; $c2<=$c; $c2++){ 
		$sSql .= sprintf(", o%d", $c2);
	}
	$dbAry[$c]->query($sSql);
}
// ここから
$row = 1;
while($db->next_record()){
	$ccls = nl2br(htmlspecialchars($db->f("cclass")));
	$cnt = $db->f("cnt");
	$lvl = $db->f("nlvl"); 
	print("<tr>\n");
	// 項番
	printf("<td class=\"bd caption\" align=\"right\"><font size=\"-1\">%03d</font></td>\n", $row++);
	if($lvl < $ccnt){
		// span, 配下項目数取得
		$dbAry[$lvl]->next_record();
		$spn = $dbAry[$lvl]->f("spn");
		$inum = $dbAry[$lvl]->f("itemnum");
	}else{
		$spn = 1;
	}
	// 分類名
	printf("<td class=\"bd cls\" rowspan=\"%d\">%s</td>\n", $spn, $ccls);
	// ハイフン
	for($c=$lvl; $c<$ccnt; $c++){
		print("<td class=\"bd cls\" align=\"center\">-</td>\n");
	}
	if($spn == 1){
	// 配下なし
		if($cnt == 0){
			print("<td class=\"bd view\" align=\"right\"><font color='red'>0</font></td>\n");
		}else{
			printf("<td class=\"bd view\" align=\"right\">%d</td>\n", $cnt);
		}
		print("<td class=\"bd view\" align=\"right\">&nbsp;</td>\n");
	}else{
	// 配下あり
		printf("<td class=\"bd view\" align=\"right\">%d</td>\n", $cnt);
		if($inum == 0){
			print("<td class=\"bd view\" align=\"right\"><font color='red'>0</font></td>\n");
		}else{
			printf("<td class=\"bd view\" align=\"right\">%d</td>\n", $inum);
		}
	}
	print("</tr>\n");
}
?>
</table>
</td></tr>
</table>
</form>

</body>
</html>
<?php
  page_close();
?>

