<?php
/*
*	$id:ti_ana_item_graph_calen.php (c)A.Ida 2017/3/10 15:37:30
*	テスト項目運用システム - 実績カレンダーグラフ
*/
include("ti_prepend.inc");
page_open(array("sess"=>"Ti_Session",
		"auth"=>"Ti_Auth",
		"perm"=>"Ti_Perm"));
if(function_exists("i18n_http_output")){
	i18n_http_output("pass");
}
header("Content-Type: image/png");
header("Cache-control: no-cache");
require_once("ti_graph.inc");

$req = new ti_request();
$projs = $req->getReqCheck("projs");
$can_x = $req->getReq("xsize", 640);
$can_y = $req->getReq("ysize", 450);
$font_id = 2;

// クラス生成
$cGraph = new ti_graph($can_x, $can_y);
// キャンパス
$img = imagecreate($can_x,$can_y);
// 色定義
$c_back = imagecolorallocate($img,255,255,255);
$c_line = imagecolorallocate($img,119,136,153);
$c_run = imagecolorallocate($img,0,255,0);
$c_bug = imagecolorallocate($img,255,0,0);

// データ取得
$db = new DB_Ti;
include("ti_calen.inc");

// 初期化
$cGraph->init(count($tary), max($rcnt, $bcnt), $font_id);
// 背景色
imagefill($img,0,0,$c_back);
// 座標軸
$cGraph->setlinesize($img, 2);
imageline($img, $cGraph->p_zero_x, $cGraph->p_zero_y, $cGraph->p_zero_x + $cGraph->p_len_x, $cGraph->p_zero_y, $c_line);
imageline($img, $cGraph->p_zero_x, $cGraph->p_zero_y - $cGraph->p_len_y, $cGraph->p_zero_x, $cGraph->p_zero_y, $c_line);
// 目盛り表示間隔
$y_skip = ceil($cGraph->p_max_y / 10);
if($y_skip == 0){
	$y_skip = 1;
}
$cGraph->setlinesize($img, 1);
for($y_num=$y_skip; $y_num<=$cGraph->p_max_y; $y_num+=$y_skip){
	$y = $cGraph->toY($y_num);
	// 目盛り
	$x = $cGraph->p_zero_x - 5;
	$x -= imagefontwidth($font_id) * strlen($y_num);
	imagestring($img, $font_id, $x, $y - (imagefontheight($font_id) / 2), $y_num, $c_line);
	// 横罫線
	imageline($img, $cGraph->p_zero_x, $y , $cGraph->p_zero_x + $cGraph->p_len_x, $y, $c_line);
}
// グラフ描画
$x_cnt = 1;
$x_pre = $cGraph->p_zero_x;
$y_pre_run = $cGraph->p_zero_y;
$y_pre_bug = $cGraph->p_zero_y;
$x_skip = ceil(count($tary) / 10);
while(list($key, $vary) = each($tary)){
	$x = $cGraph->toX($x_cnt);
	// 日付表示判定
	$flg = true;
	if($x_skip > 0){
		if($x_cnt % $x_skip > 0){
			$flg = false;
		}
	}
	if($flg){
		// 日付
		imagestringup($img, $font_id, $x - (imagefontheight($font_id) / 2), $cGraph->p_can_y - 5, $key, $c_line);
		// 縦罫線
		$cGraph->setlinesize($img, 1);
		imagedashedline($img, $x, $cGraph->p_zero_y, $x, $cGraph->p_zero_y - $cGraph->p_len_y, $c_line);
	}
	$cGraph->setlinesize($img, 1);
	// 実績
	$y = $cGraph->toY($vary["rcnt"]);
	imageline($img, $x_pre, $y_pre_run, $x, $y, $c_run);
	$cGraph->drawPoint($img, $x, $y, $c_run);
	$y_pre_run = $y;
	// 障害
	$y = $cGraph->toY($vary["bcnt"]);
	imageline($img, $x_pre, $y_pre_bug, $x, $y, $c_bug);
	$cGraph->drawPoint($img, $x, $y, $c_bug);
	$y_pre_bug = $y;
	
	$x_pre = $x;
	$x_cnt++;
}

// 出力
imagepng($img);
imageDestroy($img);
?>
<?php
  page_close();
?>

