<?php
/*
*	$id:ti_ana_item_view.php (c)A.Ida 2017/3/10 15:37:31
*	テスト項目運用システム - 分析結果
*/
include("ti_prepend.inc");
page_open(array("sess"=>"Ti_Session",
		"auth"=>"Ti_Auth",
		"perm"=>"Ti_Perm"));
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<link rel="STYLESHEET" href="tistyle.css" type="TEXT/CSS" media="all">
<link rel="STYLESHEET" href="tiprint.css" type="TEXT/CSS" media="print">
<SCRIPT Language="JavaScript">
<!--
function jgraph(pids){
	var win = window.open('<?php $sess->purl("ti_ana_item_graph.php?dmy=0"); ?>&projs=' + pids, 'ti_graph');
	win.focus();
};
function jbugs(pids){
	var win = window.open('<?php $sess->purl("ti_select_bug.php?mode=ana"); ?>&projs=' + pids, 'ctrl');
	win.focus();
};
// -->
</SCRIPT>
<title>TI-System - 分析結果</title>
</head>

<body class="fit">

<?php
// 標準日付文字列（yyyy-mm-dd）をUNIXタイムに変換
function to_intStm($d)
{
	$y = substr($d,0,4);
	$m = substr($d,5,2);
	$d = substr($d,8,2);
	return mktime(0,0,0,$m,$d,$y);
}
// 難易度加味時の重み変換用CASE文作成
function mkCase($colName)
{
	global $c_dwary;
	$case = "CASE " . $colName;
	foreach($c_dwary as $key => $val)
	{
		$case .= " WHEN " . $key . " THEN " . $val;
	}
	$case .= " END";
	return $case;
}
$lic = new ti_lic();
$bsum = $lic->ynAnaSum();
$req = new ti_request();
$g_pid = $req->getSessCheck("g_pid");
$rproj = $req->getReq("rproj", $bsum ? 1 : 0);		// 配下
$cbdif = $req->getReq("cbdif", "off");	// 難易度加味
$csub = $req->getReq("csub", "off");	// 副担当

$db = new DB_Ti(true);

if($rproj == 0){
// 直下のみ
	$projs = sprintf("%d", $g_pid);
}else{
// 配下
	$sSql = sprintf("SELECT get_children(%d,'') AS chdr", $g_pid);
	$db->query($sSql);
	$db->next_record();
	if(strlen($db->f("chdr")) == 0){
		$projs = sprintf("%d", $g_pid);
	}else{
		$projs = sprintf("%d, %s", $g_pid, $db->f("chdr"));
	}
}

// 基本情報 -------------------------
$sSql  = "SELECT ";
$sSql .= "count(*) AS icnt, ";
$sSql .= "count(dexec) AS ecnt ";
$sSql .= sprintf("FROM vitem WHERE npid in (%s)", $projs);
$db->query($sSql);
$db->next_record();
$icnt = $db->f("icnt");	// 項目数
$ecnt = $db->f("ecnt");	// 実施済み項目数
if($icnt == 0){
	$ecnt_p = 0;
}else{
	$ecnt_p = $ecnt * 100 / $icnt;
}

// append V0.3
$sSql = sprintf("SELECT count(*) AS rcnt FROM tresult WHERE npid in (%s)", $projs);
$db->query($sSql);
$db->next_record();
$rcnt = $db->f("rcnt");	// 実施数

$sSql  = "SELECT ";
$sSql .= "count(*) AS bcnt, ";
$sSql .= "count(ccause) AS acnt ";
$sSql .= sprintf("FROM vbug WHERE npid in (%s)", $projs);
$db->query($sSql);
$db->next_record();
$bcnt = $db->f("bcnt");	// 障害数
$acnt = $db->f("acnt");	// 回答済み数
if($bcnt == 0){
	$acnt_p = 100;	// 0 -> 100 V0.3
}else{
	$acnt_p = $acnt * 100 / $bcnt;
}

$sSql  = "SELECT ";
$sSql .= "count(*) AS cnt ";
$sSql .= sprintf("FROM vitemhld WHERE npid in (%s)", $projs);
$db->query($sSql);
$db->next_record();
$hcnt = $db->f("cnt");	// 保留項目数
?>

<table border="0" width="100%">
<tr><td colspan=2>
<p class="caption">
基本情報
</p>
</td></tr>
<tr><td colspan=2>
<table border="1" width="100%" class="form" cellspacing="0" cellpadding="2">
<tr><td class="caption" align="right">
項目数
</td><td align="right">
<?php
printf("%d項目\n", $icnt);
if ($hcnt > 0){
	printf("（内%d項目保留）", $hcnt);
}
?>
</td><td class="caption" align="right">
実績数
</td><td align="right">
<?php printf("%d\n", $rcnt); ?>
</td><td class="caption" align="right">
実施済項目数（率）
</td><td align="right">
<?php printf("%d項目(%d%%)\n", $ecnt, $ecnt_p); ?>
</td><td class="caption" align="right">
発生障害数
</td><td align="right">
<?php printf("%d件\n", $bcnt); ?>
</td><td class="caption" align="right">
回答済障害数（率）
</td><td align="right">
<?php printf("%d件(%d%%)\n", $acnt, $acnt_p); ?>
</td></tr>
</table>
</td></tr>
<?php
// 重要度別進捗度 -----------------
$sSql = sprintf("SELECT MAX(nround) AS nr_x FROM tresult WHERE npid IN (%s)", $projs);
$db->query($sSql);
$db->next_record();
$nr_x = $db->f("nr_x");		// 最大回数
?>
<tr><td colspan=2>
<p class="caption">
重要度別進捗
</p>
</td></tr>
<tr><td colspan=2>
<table width="100%" class="view" cellspacing="0">
<tr>
<th nowrap>回数</th>
<?php
while(list($key,$val) = each($c_iary)){
	printf("<th nowrap>「%s」以上</th>\n", $key);
}
?>
</tr><tr>
<td class="bd caption" align="right">
<?php if($cbdif == "on"): ?>
総項目度数
<?php else: ?>
総項目数
<?php endif; ?>
</td>
<?php
// 項目数行分
if($cbdif == "on"){
	$case = mkCase("ndif");
	$icnt_sql = "sum($case)";
}else{
	$icnt_sql = "count(*)";
}
$sSql = sprintf("SELECT %s AS icnt, nimp FROM titem WHERE npid IN (%s) ", $icnt_sql, $projs);
$sSql .= "GROUP BY nimp ORDER BY nimp DESC"; 
$db->query($sSql);
$db->next_record();
$isum = 0;
reset($c_iary);
// 重要度名列ループ
while(list($key,$val) = each($c_iary)){
	if($db->f("nimp") == $val){
		$isum += $db->f("icnt");
		$db->next_record();
	}
	$icnts[$val] = $isum;
	printf("<td class=\"bd caption\" align=\"center\">%d</td>\n", $isum);
}
print("</tr><tr>\n");
// 各ラウンド分
$sSql  = sprintf("SELECT %s AS icnt, nimp, nround FROM vitem2 ", $icnt_sql);
$sSql .= sprintf("WHERE npid IN (%s) AND nround > 0 ", $projs);
$sSql .= "GROUP BY nimp, nround ORDER BY nround, nimp DESC";
$db->query($sSql);
$db->next_record();
// ラウンドループ
for($nr=1;$nr<=$nr_x;$nr++){
	printf("<tr><td class=\"bd caption\"align=\"center\">%d回目</td>\n", $nr);
	$isum = 0;
	reset($c_iary);
	// 重要度ループ
	while(list($key,$val) = each($c_iary)){
		if(($db->f("nimp") == $val) && ($db->f("nround") == $nr)){
			$isum += $db->f("icnt");
			$db->next_record();
		}
		if($icnts[$val] == 0){
			$par = 100;	// 0除算対策
		}else{
			$par = $isum*100/$icnts[$val];
		}
		$str = sprintf("%d(%d%%)", $isum, $par);  
		printf("<td class=\"bd view\" align=\"center\">%s</td>\n", $str);
	}
	print("</tr>\n");
}
?>
</table>
</td></tr>
<?php
// 担当別進捗 -----------------
$scid = ($csub == "on") ? "cid2" : "cid";
$sSql = "SELECT ";
if($cbdif == "on"){
	// 難易度加味
	$case = mkCase("I.ndif");
	$sSql .= "sum($case) AS nall, sum(case COALESCE(P.nround,0)+1 when I.nround2 then NULL else I.ndif end)  AS nstill, ";
}else{
	// 単純項目数
	$sSql .= "count(*) AS nall, count(NULLIF(COALESCE(P.nround,0)+1, I.nround2)) AS nstill, ";
}
$sSql .= "max(I.dplan) AS deplan, ";
$sSql .= "min(CASE I.nround2 WHEN COALESCE(P.nround,0)+1 THEN I.dexec ELSE NULL END) AS dsexec, ";
$sSql .= "M.cname AS cname ";
$sSql .= "FROM vitem I ";
$sSql .= sprintf("INNER JOIN muser M ON (I.%s = M.cid) ",$scid);
$sSql .= "INNER JOIN tproj P ON (P.npid = I.npid) ";
$sSql .= "WHERE P.csucce IS NULL ";
$sSql .= sprintf("AND I.npid IN (%s) ", $projs);
if($perm->have_perm("leader") == false){
	$sSql .= sprintf("AND I.%s = '%s' ", $scid, $auth->auth["uname"]);
}
$sSql .= sprintf("GROUP BY I.%s, M.cname ",$scid);
$sSql .= "ORDER BY nall";

$db->query($sSql);
?>
<tr><td colspan=2>
<p class="caption">
担当別進捗<small>（完了済ラウンドでの実績は計算外です。）</small>
</p>
</td></tr>
<tr><td colspan=2>
<table width="100%" class="view" cellspacing="0">
<tr>
<th nowrap>担当者</th>
<?php if($cbdif == "on"): ?>
	<th nowrap>項目総度数</th>
	<th nowrap>済項目度数</th>
<?php else: ?>
	<th nowrap>項目総数</th>
	<th nowrap>済項目数</th>
<?php endif; ?>
<th nowrap>進捗率</th>
<th nowrap>作業開始日</th>
<th nowrap>消費日数</th>
<th nowrap>作業完了予定日</th>
<th nowrap>予測作業完了日</th>
</tr>
<?php
// 担当者別ループ
while($db->next_record()){
	print("<tr>\n");
	// 担当者名
	printf("<td class=\"bd caption\" nowrap>%s</td>\n", $db->f("cname"));
	// 総項目数
	$nall = $db->f("nall");
	printf("<td class=\"bd view\" nowrap align=\"right\">%d</td>\n", $nall);
	// 済項目数
	$nfin = $nall - $db->f("nstill");
	printf("<td class=\"bd view\" nowrap align=\"right\">%d</td>\n", $nfin);
	// 進捗率
	$par = 0;
	if($nall > 0){
		$par = $nfin * 100 / $nall;
	}
	printf("<td class=\"bd view\" nowrap align=\"right\">%d%%</td>\n", $par);
	if($db->f("dsexec") == ""){
	// 未着手
		print("<td class=\"bd view\" nowrap align=\"center\"><font color=\"red\">未着手</font></td>\n");
		print("<td class=\"bd view\" nowrap align=\"center\">−</td>\n");
		print("<td class=\"bd view\" nowrap align=\"center\">−</td>\n");
		print("<td class=\"bd view\" nowrap align=\"center\">−</td>\n");
	}else{
	// 作業中
		// 作業開始日
		$ds = to_intStm($db->f("dsexec"));
		printf("<td class=\"bd view\" nowrap align=\"center\">%s</td>\n", strftime("%Y/%m/%d",$ds));
		// 消費日数
		$dn = mktime();
		$days = ($dn - $ds) / (3600*24);
		printf("<td class=\"bd view\" nowrap align=\"right\">%d日</td>\n", $days);
		// 作業終了予定日
		$dep = to_intStm($db->f("deplan"));
		printf("<td class=\"bd view\" nowrap align=\"center\">%s</td>\n", strftime("%Y/%m/%d",$dep));
		// 予測作業終了日
		$days2 = 0;
		if($par > 0){
			$days2 = $days * 100 / $par;
		}
		$de = $ds + ($days2 * 3600 * 24);
		print("<td class=\"bd view\" nowrap align=\"center\">");
		if($par == 100){
			print("<font color=\"blue\">完了済</font>\n");
		}else{
			$se = strftime("%Y/%m/%d",$de);
			if($de > $dep){
				printf("<font color=\"red\">%s</font>",$se);
			}else{
				print($se);
			}
		}
		print("</td>\n");
	}
	print("</tr>\n");
}
print("</table>\n");
if($db->num_rows() == 0){
	print("<p class=\"error\"><font size=-1>まだ項目がありません。</font></p>\n");
}
?>
</td></tr>
<tr><td nowrap>
<p class="caption">
障害種別集計
</p>
</td><td align=right>
<?php
// 種別別障害数 -----------------------------
printf("<input type='button' value='障害票一覧...' onClick='jbugs(\"%s\")' id='btnbug'>\n", $projs); 
?>
</td></tr>
<tr><td colspan=2>
<table width="100%" class="view" cellspacing="0">
<tr>
<th nowrap>障害種別</th>
<?php
while(list($key,$val) = each($c_kary)){
	printf("<th nowrap>%s</th>\n", $key);
}
?>
</tr><tr>
<td class="bd caption" align="right">回答済障害数</td>
<?php
// キー値よりc_kary内の定義順を優先させるため個々にSELECTする
reset($c_kary);
while(list($key,$val) = each($c_kary)){
	$sSql =  "SELECT count(*) AS cnt FROM tans";
	$sSql .= sprintf(" WHERE npid IN (%s)", $projs);
	$sSql .= sprintf(" AND nkind = %d", $val);
	$db->query($sSql);
	$db->next_record();
	printf("<td class='bd view' align='center' nowrap>%d</td>\n", $db->f("cnt"));
}
?>
</tr></table>
</td></tr>
<?php
// 実績カレンダー ---------------------------
require_once("ti_calen.inc");
$swk = "";
if(count($c_kary_non) > 0){
	reset($c_kary_non);
	while(list($key,$val) = each($c_kary_non)){
		$swk .= "[" . $c_karyR[$val] ."]";
	}
	$swk = "障害種別が" . $swk . "である回答済障害はカウント対象外になっています。";
}
?>
<tr class='noprn'><td nowrap>
<p class="caption">
実績カレンダー
<small>（数値は累計です。<?php print($swk); ?>）</small>
</p>
</td><td align=right>
<!-- 実績あり -->
<?php if(count($tary) > 0): ?>
<?php
printf("<input type='button' value='グラフ表示...' onClick='jgraph(\"%s\")' id='btngrp'>\n", $projs); 
?>
</td></tr>
<tr class='noprn'><td colspan=2>
<table width="100%" class="view" cellspacing="0">
<?php

// HTML化
$i = 0;
$cnum = 5;
while(list($key, $vary) = each($tary)){
	if($i%$cnum == 0){
		print("<tr>\n");
		if($i != 0){
			print("<td class=\"bd\" colspan=\"6\"></td></tr><tr>\n");
		}
		print("<td class=\"bdh caption\">日付</td>\n");
	}
	printf("<td class=\"bdh view\" align=\"center\"><b>%s</b></td>\n", $vary["date_s"]);
	$wary[$i%$cnum] = $vary;
	if($i%$cnum == $cnum-1){
		print("</tr><tr>\n");
		print("<td class=\"bd caption\">消化項目数</td>\n");
		for($j=0;$j<$cnum;$j++){
			$rcnt = $wary[$j]["rcnt"];
			$iwk = 0;
			if($icnt > 0){
				$iwk = $rcnt*100/$icnt;
			}
			printf("<td class=\"bd view\" align=\"center\">%d件(%d%%)</td>\n", $rcnt, $iwk);
		}
		print("</tr><tr>\n");
		print("<td class=\"bd caption\">障害数</td>\n");
		for($j=0;$j<$cnum;$j++){
			printf("<td class=\"bd view\" align=\"center\">%d件</td>\n", $wary[$j]["bcnt"]);
		}
	}
	$i++;
}
if($i%$cnum > 0){
	print("</tr><tr>\n");
	print("<td class=\"bd caption\">消化項目数</td>\n");
	for($j=0;$j<$i%$cnum;$j++){
		$rcnt = $wary[$j]["rcnt"];
		$par = 0;	// change V0.3.4 項目が無くて障害だけの時にDivison by zeroになる問題の修正
		if($icnt > 0){
			$par = $rcnt*100/$icnt;
		}
		printf("<td class=\"bd view\" align=\"center\">%d件(%d%%)</td>\n", $rcnt, $par);
	}
	print("</tr><tr>\n");
	print("<td class=\"bd caption\">障害数</td>\n");
	for($j=0;$j<$i%$cnum;$j++){
		printf("<td class=\"bd view\" align=\"center\">%d件</td>\n", $wary[$j]["bcnt"]);
	}
}
print("</tr>\n");
?>
<!-- 実績なし -->
<?php else: ?>
</p>
</td></tr>
<tr><td>
<p class="error">まだ実績はありません。</p>
</td></tr>
<?php endif; ?>
</table>
</td></tr>

</table>
</body>
</html>
<?php
  page_close();
?>

