<?php
/*
*	$id:ti_en_round_ctrl_act.php (c)A.Ida 2017/3/10 15:37:31
*	テスト項目運用システム - ラウンド完了実行部
*/
include("ti_prepend.inc");
page_open(array("sess"=>"Ti_Session",
		"auth"=>"Ti_Auth",
		"perm"=>"Ti_Perm"));
$perm->check("leader");
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<link rel="STYLESHEET" href="tistyle.css" type="TEXT/CSS">
<title>TI-System - ラウンド完了実行</title>
</head>

<body class="act">
<div align="center">
<?php
$req = new ti_request();
$act = $req->getReqCheck("act");
$pid = $req->getReqCheck("pid");
$nr = $req->getReqCheck("nr");
$syear = $req->getReq("syear", -1);
$smonth = $req->getReq("smonth", -1);
$sday = $req->getReq("sday", -1);

$db = new DB_Ti;

if($act == "en"){
// 完了
	$estr = "";
	$db->query("BEGIN");
	$sSql = sprintf("UPDATE tproj SET nround = %d WHERE ", $nr);
	$sSql .= sprintf("npid = %d", $pid);
	$res = $db->query($sSql);
	if($res){
		if(($syear > 0) && ($smonth > 0) && ($sday > 0)){
		// 実施予定日変更
			$sSql  = sprintf("UPDATE titem SET dplan = to_date('%04d/%02d/%02d', 'YYYY/MM/DD')", $syear, $smonth, $sday);
			$sSql .= sprintf(" WHERE npid = %d", $pid);
			$res = $db->query($sSql);
			if($res == FALSE){
				$estr = "ラウンド完了処理は成功しましたが、実施予定日変更に失敗しました。";
			}
		}
	}
	if($res){
		$db->query("END");
		print("<h3>ラウンド完了処理を実施しました。</h3>\n");
	}else{
		$db->query("ROLLBACK");
		printf("<p class=\"error\">ラウンド完了処理が失敗しました。%s</p>\n", $estr);
		printf("<p class=\"dber\">%s</p>\n", $db->Error);
	}
}else{
// 取消
	$nr -= 2;
	$sSql = sprintf("UPDATE tproj SET nround = %d WHERE ", $nr);
	$sSql .= sprintf("npid = %d", $pid);
	$db->query("BEGIN");
	$res = $db->query($sSql);
	if($res){
		// 状況確認
		$sSql = "SELECT count(*) AS cnt FROM tresult ";
		$sSql .= sprintf("WHERE npid = %d AND nround > %d", $pid, $nr+1);
		$db->query($sSql);
		$db->next_record();
		if($db->f("cnt") > 0){
			print("<p class=\"error\">このプロジェクトは既に新しいラウンドで実績があります。ラウンド完了の取消はできません。</p>\n");
			$res = false;
		}
	}
	if($res){
		$db->query("END");
		print("<h3>ラウンド完了取消処理を実施しました。</h3>");
	}else{
		$db->query("ROLLBACK");
		print("<p class=\"error\">ラウンド完了取消処理が失敗しました。</p>\n");
		printf("<p class=\"dber\">%s</p>\n", $db->Error);
	}
}
?>
</div>
</body>
</html>
<?php
  page_close();
?>

