<?php
/*
*	$id:ti_ins_proj_ctrl_act.php (c)A.Ida 2017/3/10 15:37:30
*	テスト項目運用システム - プロジェクト作成（実行部）
*/
include("ti_prepend.inc");
require_once("ti_ckMemb.inc");
page_open(array("sess"=>"Ti_Session",
		"auth"=>"Ti_Auth",
		"perm"=>"Ti_Perm"));
$perm->check("leader");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<link rel="STYLESHEET" href="tistyle.css" type="TEXT/CSS">
<title>TI-System - INS PROJ 実行</title>
</head>

<body class="act">
<div align="center">
<?php
$req = new ti_request();
$upid = $req->getReqCheck("upid");
$pname = $req->getReqCheck("pname");
$rpid = $req->getReq("rpid", -1);
$rpkind = $req->getReq("rpkind", 1);
$g_cids = $req->getSess("g_cids", "");
$req->is_ary_cnt($g_cids, true);
$proxy = $req->getReq("proxy", "");

$db = new DB_Ti;
$db->Halt_On_Error = "no";
$get = new ti_get($db);

$db->query("BEGIN");
$sSql = sprintf("SELECT nlvl FROM tproj WHERE npid = %d", $upid);
$db->query($sSql);
$db->next_record();
$lvl = $db->f("nlvl") + 1;
if($lvl > 9){
	$ret = false;
}else{
	$sSql  = "INSERT INTO tproj (npid, nlvl, nupid, cpname, cid, dmake) VALUES ";
	$sSql .= sprintf("(nextval('spid'), %d, %d, '%s', '%s', 'NOW')", $lvl, $upid, a($pname), $auth->auth["uname"]); 
	$ret = $db->query($sSql);
	$i = 0;
}
if($ret){
	// 作業メンバ追加
	$pid = $get->getSeqCur("spid");
	$i = 0;
	while (isset($g_cids[$i])){
		$sSql = sprintf("INSERT INTO tpmember VALUES (%d, '%s')", $pid, $g_cids[$i]);
		$ret = $db->query($sSql);
		if($ret == false){
			break;
		}
		$i++;
	}
}
if($ret && ($rpid > 0)){
	// 分類コピー
	$sSql  = "INSERT INTO tclass ";
	$sSql .= sprintf("(SELECT %d, ncid, norder, nlvl, nucid, cclass FROM tclass WHERE npid = %d)", $pid, $rpid);	// add norder v0.2
	$ret = $db->query($sSql);
	if($ret && ($rpkind > 1)){
		// 項目コピー
		$sSql  = "INSERT INTO titem ";
		$sSql .= sprintf("(SELECT %d, niid, ncid, norder, cope, cexp, cid, cid2, nimp, ndif, dplan, cmemo FROM titem WHERE npid = %d)", $pid, $rpid); 
		$ret = $db->query($sSql);
		if($ret){
			// メンバ外担当者の置換
			if(strlen($proxy) > 0){
				$ckM = new ti_ckMemb($db, $g_cids);
				$cnt = $ckM->chgMembs($pid, $proxy);
				if ($cnt > 0){
					print("<p class='warn'>\n");
					printf("%d件の担当を指定のメンバに変更しました。\n", $cnt);
					print("</p>\n");
				}else{
					print("<p class='warn'>\n");
					print("メンバの変更処理に失敗した可能性があります。作成されてプロジェクトにメンバ以外の担当者が含まれていないか確認してください。<br>\n");
					print("</p>\n");
					$url = $sess->url("ti_mak_item.php?dmy=0");
					$url .= sprintf("&pid=%d",$pid);
					printf("<a href='%s' target='_parent'><b>【編集画面へ】</b></a>\n",$url);
				}
			}
		}
	}
}
if($ret){
	print("<h3>登録が完了しました。<BR>");
	printf("プロジェクト番号は %04d です。</h3>", $pid);
	$db->query("END");
}else{
	if($lvl > 9){
		print("<p class=\"error\">階層が深過ぎます。これ以上は作成できません。</p>\n");
	}else{
		print("<p class=\"error\">登録が失敗しました。</p>\n");
		print("<p class=\"dber\">\n");
		if ($db->isDupeError()){
			print("同一プロジェクトが既に登録されています。\n");
		}
		print($db->Error);
		print("\n</p>\n");
	}
	$db->query("ROLLBACK");
}
?>
</div>
</body>
</html>
<?php
  page_close();
?>

