/*
*	$id:ti_lstCtrl.js (c)A.Ida 2017/3/10 15:37:30
* プロジェクト一覧内のマウスフォーカス処理用
*/
/* クラス変更共通部 */
function chgClass(elm, clsName){
	if(elm){
		elm.setAttribute("className", clsName);	// for IE
		elm.setAttribute("class", clsName);		// for Other
	}
};
function chgOutMouse(fncname, row){
	var elm = document.getElementById("r" + row);
	if(elm){
		var fnc = fncname + "(" + row + ");"
		elm.setAttribute("onMouseOut", new Function(fnc), 0);	// for IE
		elm.setAttribute("onMouseOut", fnc);					// for Other
	}
};
		
/* 一覧マウス行制御 */
function ovrColor(row){
	var elm = document.getElementById("r" + row);
	chgClass(elm, "over");
};
/* pid-row 形の対処 */
function getrow(row){
	if(isNaN(row)){
		if(row.search("-") >= 0){
			var str = row.split("-");
			row = str[str.length - 1];
		}
	}
	return row;
};
function outColor(row){
	var elm = document.getElementById("r" + row);
	row = getrow(row);
	if(row%2 == 0){
		chgClass(elm, "even");
	}else{
		chgClass(elm, "odd");
	}
};
function curColor(row){
	var elm = document.getElementById("r" + row);
	chgClass(elm, "cur");
};
function getMaxElms(cForm){
	var num = 0;
	if(cForm.elements){
		num = cForm.elements.length;
	}
	return num;
};
/* 選択メニュー背景画像制御 */
function btnCtrl(id, max, clsName){
	var elm;
	for(var i=1; i<=max; i++){
		elm = document.getElementById("b" + i);
		if(i == id){
			chgClass(elm, clsName + "_on");
		}else{
			chgClass(elm, clsName);
		}
	}
};
/* chek有無確認 */
function chkck(cForm){
	var max = getMaxElms(cForm);
	var bck = false;
	for(var j=0;j<max;j++){
		if(cForm.elements[j].type == 'checkbox'){
			if(cForm.elements[j].checked){
				bck = true;
				break;
			}
		}
	}
	return bck;
};
/* checkbox選択反転 */
function chktgl(cForm){
	var max = getMaxElms(cForm);
	for(var j=0;j<max;j++){
		if(cForm.elements[j].type == 'checkbox'){
			if(cForm.elements[j].checked){
				cForm.elements[j].checked = false;
			}else{
				cForm.elements[j].checked = true;
			}
		}
	}
};
/* 選択解除 */
function chkclr(cForm){
	var max = getMaxElms(cForm);
	for(var j=0;j<max;j++){
		switch(cForm.elements[j].type){
		case 'checkbox':
		case 'radio':
			cForm.elements[j].checked = false;
			break;
		default:
			break;
		}
	}
};
