<?php
/*
*	$id:ti_run_item_view_act.php (c)A.Ida 2017/3/10 15:37:30
*	テスト項目運用システム - 実施一覧実行部
*/
include("ti_prepend.inc");
page_open(array("sess"=>"Ti_Session",
		"auth"=>"Ti_Auth",
		"perm"=>"Ti_Perm"));
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<link rel="STYLESHEET" href="tistyle.css" type="TEXT/CSS">
<title>TI-System - RUN VIEW ACT</title>
</head>

<body class="help">
<?php
$req = new ti_request();
$g_pid = $req->getSessCheck("g_pid");
$g_nr = $req->getSessCheck("g_nr");
$examins = $req->getReq("examins", null);
$dels = $req->getReq("dels", null);

$db = new DB_Ti(true);
$db->Halt_On_Error = "no";
?>
<form name="frmRunItem" method="POST" action="<?php $sess->purl("ti_run_item_view.php"); ?>">
<div align="center">
<?php
$db->query("BEGIN");

$ret = true;
// 削除チェックされた項目の削除
$del_num = count($dels);
if($del_num > 0){
	// IN句の作成
	$swk = "";
	for($i=0; $i<$del_num; $i++){
		if($i != 0){
			$swk .= ",";
		}
		$swk .= $dels[$i];
	}
	// 削除
	$sSql = "DELETE FROM tresult WHERE ";
	$sSql .= sprintf("npid = %d AND nround = %d ", $g_pid, $g_nr);
	$sSql .= sprintf("AND niid IN (%s)",$swk);
	$ret = $db->query($sSql);
	$del_num = $db->affected_rows();
}

// 済チェックされた項目の追加
$cnt = count($examins);
$ins_num = 0;
for($i=0; $i<$cnt; $i++){
	// 存在チェック（重複エラーが発生するとトランザクションが切れるため）
	$sSql = "SELECT *  FROM tresult WHERE ";
	$sSql .= sprintf("npid = %d AND niid = %d AND nround = %d", $g_pid, $examins[$i], $g_nr);
	$db->query($sSql);
	if($db->num_rows() == 0){
		$sSql  = "INSERT INTO tresult VALUES";
		$sSql .= sprintf("(%d, %d, %d, '%s', 'NOW')", $g_pid, $examins[$i], $g_nr, $auth->auth["uname"]);
		$ret = $db->query($sSql);
		if($ret){
			$ins_num++;
		}else{
			break;
		}
	}
}
if($ret){
	print("<h2>保存しました。</h2>\n");
	print("<table border='0'>\n");
	printf("<tr><td align='right'>新規に実施済に登録された項目数：</td><td><b>%d</b></td></tr>\n", $ins_num);
	if($del_num > 0){
		printf("<tr><td align='right'>実施済情報を削除された項目数：</td><td><b>%d</b></td></tr>\n", $del_num);
	}
	print("</table>\n<br>\n");
	$db->query("END");
}else{
	print("<p class=\"error\">保存に失敗しました</p>");
	printf("<p class=\"dber\">%s</p>", $db->Error);
	printf("<p class=\"dber\">%s</p>", $sSql);
	$db->query("ROLLBACK");
}
print("<input type=\"submit\" value=\" 確認 \">\n");
?>
</div>
</form>
</body>
</html>
<?php
  page_close();
?>

