<?php
/*
*	$id:ti_up_bug_view_act.php (c)A.Ida 2017/3/10 15:37:31
*	テスト項目運用システム - 障害票実行部
*/
include("ti_prepend.inc");
page_open(array("sess"=>"Ti_Session",
		"auth"=>"Ti_Auth",
		"perm"=>"Ti_Perm"));
require_once("ti_mail.inc");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<link rel="STYLESHEET" href="tistyle.css" type="TEXT/CSS">
<title>TI-System - 障害票登録</title>
</head>

<body class="act" onload="document.frmBackBug.back.focus();">

<div align="center">
<?php
$db = new DB_Ti(true);
$req = new ti_request();
$gb_pid = $req->getSessCheck("gb_pid");
$bid = $req->getReq("bid", -1);
$gb_iid = $req->getSess("gb_iid", -1);
$gb_nr = $req->getSess("gb_nr", 0);
// 発行
$title = $req->getReqCheck("title");
$mark = $req->getCBReq("mark", "title", 0, 0);
$dissue = $req->getReqCheck("dissue");
$id_b = $req->getReqCheck("id_b");
$pheno = $req->getReqCheck("pheno", true);
$proc = $req->getReqCheck("proc", true);
$simp = $req->getReqCheck("simp");
$sid_p = $req->getReqCheck("sid_p");
$term_y = $req->getReqCheck("term_y");
$term_m = $req->getReqCheck("term_m");
$term_d = $req->getReqCheck("term_d");
// 回答
$sid_a = $req->getReq("sid_a", $auth->auth["uname"]);
$now = new ti_now($db);
$dans = $req->getReq("dans", $now->toStr());
$cause = $req->getReq("cause", "");
$cope = $req->getReq("cope", "");
$skind = $req->getReq("skind", 4);
$src = $req->getReq("src", "");
$rs = $req->getReq("rs", 0);
$re = $req->getReq("re", 0);
// 確認
$sid_c = $req->getReq("sid_c", "");
$conf_y = $req->getReq("term_y", $now->y);
$conf_m = $req->getReq("term_m", $now->m);
$conf_d = $req->getReq("term_d", $now->d);
$note = $req->getReq("note", "");

$mail_kind = 1;
$db->Halt_On_Error = "no";
$addmsg = "";
$tos = "";

$db->query("BEGIN");
// 障害番号の連続性を確保するためシーケンスは使えない。このため、
// テーブルロックで対処
$iid = $gb_iid;	// add V0.4
$db->query("LOCK TABLE tbug IN SHARE ROW EXCLUSIVE MODE");
if($bid > 0){
// 更新 ----
	// 現在の値取得 V0.3.2a
	$sSql = sprintf("SELECT * FROM tbug WHERE npid = %d AND nbid = %d", $gb_pid, $bid);
	$db->query($sSql);
	if($db->next_record()){
		$iid = $db->f("niid");	// g_iid -> iid V0.4
		$gb_nr = $db->f("nround") - 1;	// insert時++されるので
	}
	// 事前削除（tans, tbmark, trevは参照整合で削除）
	$sSql = sprintf("DELETE FROM tbug WHERE npid = %d AND nbid = %d", $gb_pid, $bid);
	$ret = $db->query($sSql);
	$act = 0;	// 更新;
}else{
// 新規 ----
	// 障害番号確定
	$sSql = sprintf("SELECT coalesce(MAX(nbid),0) AS bid_x FROM tbug WHERE npid = %d", $gb_pid);
	$ret = $db->query($sSql);
	$db->next_record();
	$bid = $db->f("bid_x") + 1;
	$act = 1;	// 新規登録;
	// 現在のround取得（暫定処置） add V0.5.1
	if($ret){
		$sSql = sprintf("SELECT COALESCE(nround,0) AS nr FROM tproj WHERE npid = %d", $gb_pid);
		$ret = $db->query($sSql);
		$db->next_record();
		$gb_nr = $db->f("nr");
	}
}
if($ret){
	// 発行情報
	$term_s = sprintf("%s/%s/%s", $term_y, $term_m, $term_d);
	$sSql  = "INSERT INTO tbug VALUES(";
	$sSql .= sprintf("%d, %d, %d, %d, '%s', '%s', to_ndate('%s'), '%s', '%s', %d, to_ndate('%s'), '%s', '%s')", $gb_pid, $bid, $iid, $gb_nr+1, a($title), $id_b, $dissue, a($pheno), a($proc), $simp, $term_s, $sid_p, a($note)); // g_iid -> iid V0.4
	$ret = $db->query($sSql);
	if($ret && strlen(trim($cause))){
	// 回答・確認情報（原因が書かれてある場合のみ）
		$mail_kind = 2;
		if(strlen($sid_c)){
		// 確認済み
			// 未実施項目確認
			$sSql  = "SELECT count(*) AS cnt FROM titemref I";
			$sSql .= " LEFT JOIN tresult R ON I.npid = R.npid AND I.niid = R.niid";
			$sSql .= sprintf(" WHERE I.npid_o = %d AND nid_o = %d AND R.nround IS NULL", $gb_pid, $bid);
			$db->query($sSql);
			$db->next_record();
			if($db->f("cnt") > 0){
				$addmsg .= "追加テスト項目に未実施の項目があるので「確認者」は【未確認】にリセットされました。<br>\n";
			}
			// 未回答相談確認
			$sSql  = "SELECT count(*) AS cnt FROM vconvers";
			$sSql .= sprintf(" WHERE npid = %d AND nbid = %d AND cid_a IS NOT NULL AND nans IS NULL", $gb_pid, $bid);
			$db->query($sSql);
			$db->next_record();
			if($db->f("cnt") > 0){
				$addmsg .= "この障害票に関する未回答の相談があるので「確認者」は【未確認】にリセットされました。<br>\n";
			}
			if(strlen($addmsg) > 0){
				$sid_c = "null";
			}else{
				$sid_c = "'".$sid_c."'";
				$mail_kind = 3;
			}
			$conf_s = sprintf("to_ndate('%s/%s/%s')", $conf_y, $conf_m, $conf_d);
		}else{
		// 未確認
			$sid_c = "null";
			$conf_s = "null";
		}
		$sSql  = "INSERT INTO tans VALUES(";
		$sSql .= sprintf("%d, %d, '%s', to_ndate('%s'), '%s', '%s', %d, '%s', %s, %s)", $gb_pid, $bid, $sid_a, $dans, a($cause), a($cope), $skind, a($src), $sid_c, $conf_s);
		$ret = $db->query($sSql);
		if($ret){
			// リビジョン情報
			if(($rs != 0) || ($re != 0)){
				// 追加
				$sSql = sprintf("INSERT INTO trev (npid, nbid, nadd, nrs, nre) VALUES (%d, %d, 1, %d, %d)", $gb_pid, $bid, $_REQUEST["rs"], $_REQUEST["re"]);
				$ret = $db->query($sSql);
				if($ret){
					if($db->affected_rows() == 0){
						$res = FALSE;
					}
				}
			}
		}
	}
}

// マーク反映（削除は参照整合により処理済み） add V0.3.4
if($ret){
	if($mark == 1){
		$sSql = sprintf("INSERT INTO tbmark VALUES('%s', %d, %d)", $auth->auth["uname"], $gb_pid, $bid);
		$db->query($sSql);
	}
}
$act_str = "";
switch($act){
case 1:
	$act_str = "新規登録";
	break;
default:
	$act_str = "更新";
	break;
}
if($ret){
	printf("<h3>%sが完了しました。<BR>", $act_str);
	printf("障害票番号は %04d-%04d です。</h3>\n", $gb_pid, $bid);
	if(strlen($addmsg) > 0){
		printf("<br><p class='warn'>%s</p>\n", $addmsg);
	}
	$db->query("END");
	// [戻る]で再現するための情報保存
	$_SESSION["gb_bid"] = $bid;
	if ($act == 1){ $_SESSION["gb_mod"] = "new"; }
	// メール送信確認 append V0.4
	$mail = new ti_mail($gb_pid, $mail_kind, $bid);
	$tos = $mail->toTos();
	$para = sprintf("&pid=%d&kind=%d&id=%d&act=%d", $gb_pid, $mail_kind, $bid, $act);
	if(strlen($tos) > 0){
		$maxadd = $mail->getMaxAdd();
	}
}else{
	printf("<p class=\"error\">%sが失敗しました。</p>\n", $act_str);
	printf("<p class=\"dber\">%s</p>\n", $db->Error);
	$db->query("ROLLBACK");
}
?>
<br>
<form name="frmBackBug" target="bug_view" method="POST" action="<?php $sess->purl("ti_up_bug_view.php"); ?>">
<input type="hidden" name="param" value="8">
<input type="hidden" name="act" value="<?php print($act); ?>">
<input type="submit" name="back" value="戻る">
</form>
<SCRIPT Language="JavaScript">
// 保存ボタン無効化 add v0.2
parent.bug_ctrl.document.frmUpBug.save.disabled = true;
</SCRIPT>
<?php if(strlen($tos) > 0): ?>
<SCRIPT Language="JavaScript">
<!--
msg = "次の人に障害票をメール送信します。よろしいですか？\n";
<?php if(strlen($addmsg) > 0): ?>
msg = msg + "注）【未確認】にリセットされましたので、「回答」として送信されます。\n";
<?php endif; ?>
<?php if($maxadd > 0): ?>
msg = msg + "注）既に" + "<?php print($maxadd); ?>" + "回送信されています。\n";
<?php endif; ?>
msg = msg + "<?php print($tos); ?>";
ret = confirm(msg);
if(ret){
	window.open('<?php $sess->purl("ti_mailsend_act.php?dmy=0"); print($para); ?>', '_self');
}
// -->
</SCRIPT>
<?php endif; ?>
</div>
</body>
</html>
<?php
  page_close();
?>

