<?php
/*
*	$id:ti_up_proj_ctrl_del.php (c)A.Ida 2017/3/10 15:37:30
*	テスト項目運用システム - プロジェクト削除実行部
*/
include("ti_prepend.inc");
page_open(array("sess"=>"Ti_Session",
		"auth"=>"Ti_Auth",
		"perm"=>"Ti_Perm"));
$perm->check("leader");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<link rel="STYLESHEET" href="tistyle.css" type="TEXT/CSS">
<title>TI-System - プロジェクト削除実行</title>
</head>

<body class="act">
<div align="center">
<?php
$req = new ti_request();
$pid = $req->getReqCheck("pid");
$db = new DB_Ti;

// 添付資料削除 append V0.3
$path = sprintf("%s/%d", $c_attach, $pid);
$bdel = FALSE;
if(is_dir($path)){
	// 個々のファイル削除
	$sSql = "SELECT cfname FROM tattach ";
	$sSql .= sprintf("WHERE npid = %d AND cfname is NOT NULL", $pid);
	$db->query($sSql);
	$errfnum = 0;
	while($db->next_record()){
		$fpath = $path . "/" . $db->f("cfname");
		$res = unlink($fpath);
		if($res == FALSE){
			$errfnum++;
		}
		$bdel = TRUE;
	}
	// ディレクトリ削除
	$res = rmdir($path);
	if($errfnum > 0){
		$warnstr = sprintf("削除できない添付資料が%dファイルありました。<br>\n", $errfnum);
	}
	if($res == FALSE){
		$warnstr .= "添付資料ディレクトリの削除に失敗しました。\n";
	}
	if(isset($warnstr)){
		printf("<p clasee=\"error\">添付資料の削除に失敗しました。<br>\n以下のディレクトリを確認して手動で削除してください。<br>%s<br><br>\n", $path);
		print($warnstr);
		print("</p>\n");
	}else{
		if($bdel){
			print("<h3>添付資料を削除しました。</h3>\n");
		}else{
			print("<h3>添付資料はありませんでした。</h3>\n");
		}
	}
}else{
	print("<h3>添付資料はありませんでした。</h3>\n");
}

// ＤＢ削除（by DELETE CASCADE）
$sSql = sprintf("DELETE FROM tproj WHERE npid = %d", $pid);
$db->query($sSql);	// tpmember等はdelete cascade整合で削除される
if($db->affected_rows()){
	print("<h3>プロジェクトを削除しました。</h3>\n");
}else{
	print("<p class=\"error\">プロジェクトを削除できませんでした。</p>\n");
	printf("<p class=\"dber\">%s</p>\n", $db->Error);
}
?>
</div>
</body>
</html>
<?php
  page_close();
?>

