<?php
/*
*	$id:ti_upload_act.php (c)A.Ida 2017/3/10 15:37:31
*	テスト項目運用システム - アップロード（実行部）
*/
include("ti_prepend.inc");
//include("jcode.phps");
page_open(array("sess"=>"Ti_Session",
		"auth"=>"Ti_Auth",
		"perm"=>"Ti_Perm"));
require_once("ti_atfuncs.inc");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<link rel="STYLESHEET" href="tistyle.css" type="TEXT/CSS">
<title>ti-system アップロード実行</title>
</head>

<body class="act">
<div align="center">
<?php
$req = new ti_request();
$g_atpid = $req->getSessCheck("g_atpid");
$g_atkind = $req->getSessCheck("g_atkind");
$g_atiid = $req->getSess("g_atiid", -1);
$upcmnt = $req->getReq("upcmnt", "");
$ovwr = $req->getReq("ovwr", "non");

$atf = new ti_atfuncs();
$db = new DB_Ti;
$cnv = new ti_jconv;

if(!isset($ovwr)){
	$ovwr = "no";
}

$errstr = "";
$res = TRUE;
if(isset($_FILES['upfl']['tmp_name'])){
	$fname = $_FILES['upfl']['name'];
	$fname_s = $atf->get_pathfname($fname);
	$path = sprintf("%s/%d/%s", $c_attach, $g_atpid, $fname_s);	// to dist Path
	$tmppath = $_FILES['upfl']['tmp_name'];
}else{
	$errstr = "アップロードファイル情報が取得できません。PHPのバージョンが古い可能性があります。";
	$res = FALSE;
}

if($res){
	// 既存ファイル確認
	if(file_exists($path)){
		$bUpdate = TRUE;
	}else{
		$bUpdate = FALSE;
	}
	if(($bUpdate == FALSE) || ($ovwr == "ov")){
		if($bUpdate){
			if($auth->auth["uname"] != "admin"){
				// ファイル所有者確認
				$sSql = "SELECT cid FROM tattach WHERE ";
				$sSql .= sprintf("npid = %d AND cfname = '%s'", $g_atpid, $fname);
				$db->query($sSql);
				if($db->next_record()){
					if($db->f("cid") != $auth->auth["uname"]){
						$errstr = sprintf("同名ファイルは%sさんのものなので上書きできません。", $db->f("cid"));
						$res = FALSE;
					}
				}
			}
		}
		if($res){
			// アップロードファイルか
			if(strlen($tmppath) == 0){
				$errstr = "作業ファイル名を取得できません。作業ファイルを作成できる環境であるか確認してください。<br>";
				$res = false;
			}else{
				$res = is_uploaded_file($tmppath);
			}
			if($res){
				if($_FILES['upfl']['size'] == 0){
					$errstr .= "ファイルサイズが０バイトです。<br>";
					$res = FALSE;
				}
			}
			if($res){
				// 保存先ディレクトリの作成
				$folder = sprintf("%s/%d", $c_attach, $g_atpid);
				if(is_dir($folder) == false){
					$res = mkdir($folder, 0700);
				}
				if($res){
					// 作業フォルダから移動
					if(strpos(PHP_OS,"WIN",0) === 0){
						$path = mb_convert_encoding($path, "SJIS", "AUTO");
					}
					$res = move_uploaded_file($tmppath, $path);
					if($res == FALSE){
						$errstr = "ファイルのコピーに失敗しました。";
					}
				}else{
					$errstr = sprintf("デレクトリ(%s)を作成できません。", $folder);
				}
			}else{
				$errstr .= "アップロードファイルとして不正です。<br>\n";
				$errstr .= "<table border=0>\n";
				$errstr .= sprintf("<tr><td align=right>ファイル名：</td><td>%s</td></tr>\n", $_FILES['upfl']['name']);
				$errstr .= sprintf("<tr><td align=right>作業ファイル：</td><td>%s</td></tr>\n", $_FILES['upfl']['tmp_name']);
				$errstr .= sprintf("<tr><td align=right>ファイルサイズ：</td><td>%s</td></tr>\n", $_FILES['upfl']['size']);
				$errstr .= sprintf("<tr><td align=right>最大ファイルサイズ(php.ini)：</td><td>%s</td></tr>\n", ini_get("upload_max_filesize"));
				$errstr .= sprintf("<tr><td align=right>最大ファイルサイズ(script)：</td><td>%s</td></tr>\n", $_REQUEST["MAX_FILE_SIZE"]);
				$errstr .= "</tabble>\n";
			}
		}
	}else{
		$errstr = "同名ファイルが既に登録されています。";
		$res = FALSE;
	}
}
if($res){
//	$cmnt = mb_convert_encoding($upcmnt, "EUC-JP", "EUC-JP,SJIS,JIS,UTF-8");
	$cmnt = $cnv->to_base($upcmnt);
	if($bUpdate){
		if(strlen($cmnt) > 0){
			// コメントを更新
			$sSql = sprintf("UPDATE tattach SET ccmnt = '%s' ", $cmnt);
			$sSql .= sprintf("WHERE npid = %d AND ckind = 'C' AND niid = 0 AND cfname = '%s'", $g_atpid, $fname);
			$db->query($sSql);
		}
		print("<h3>ファイルを更新しました。</h3>");
	}else{
		// DBに登録
		$db->query("BEGIN");
		$db->query("LOCK TABLE tattach IN SHARE ROW EXCLUSIVE MODE");
		// nadd決定
		$sSql = "SELECT COALESCE(MAX(nadd),0) AS maxadd FROM tattach WHERE ";
		$sSql .= sprintf("npid = %d AND ckind = 'C' AND niid = 0", $g_atpid);
		$db->query($sSql);
		$db->next_record();
		$nadd = $db->f("maxadd");
		$nadd++;
		// nattach取得
		$db->query("SELECT nextval('satid') AS atid");
		$db->next_record();
		$atid = $db->f("atid");
		// 登録
		$sSql = "INSERT INTO tattach ";
		$sSql .= "(NATTACH, NPID, CKIND, NIID, NADD, CFNAME, CCMNT, CID)  ";	// nattach_s は NULL 
		$sSql .= sprintf("VALUES (%d, %d, 'C', 0, %d, '%s', '%s', '%s')", $atid, $g_atpid, $nadd, $fname, $cmnt, $auth->auth["uname"]);
		$res = $db->query($sSql);
		if($res){
			// 障害票の場合は選択処理まで自動で行う
			if(($g_atkind == "A") || ($g_atkind == "B")){
				// nadd決定
				$sSql = "SELECT COALESCE(MAX(nadd),0) AS maxadd FROM tattach WHERE ";
				$sSql .= sprintf("npid = %d AND ckind = '%s' AND niid = %d", $g_atpid, $g_atkind, $g_atiid);
				$db->query($sSql);
				$db->next_record();
				$nadd = $db->f("maxadd");
				$nadd++;
				// nattach取得
				$db->query("SELECT nextval('satid') AS atid");
				$db->next_record();
				$atid2 = $db->f("atid");
				// リンク作成
				$sSql = "INSERT INTO tattach ";
				$sSql .= "(NATTACH, NPID, CKIND, NIID, NADD, NATTACH_S) ";
				$sSql .= sprintf("VALUES (%d, %d, '%s', %d, %d, %d)", $atid2, $g_atpid, $g_atkind, $g_atiid, $nadd, $atid);
				$res = $db->query($sSql);
			}
		}
		if($res){
			$db->query("COMMIT");
			print("<h3>登録しました。</h3>\n");
		}else{
			$db->query("ROLLBACK");
			$errstr = "ＤＢへの登録に失敗しました。";
			$dberr = $db->Error;
		}
	}
}
if($res == FALSE){
	printf("<p class=\"error\">登録に失敗しました。<br>%s</p>\n", $errstr);
	if(isset($dberr)){
		printf("<p class=\"dber\">%s</p>\n", $dberr);
	}
}
?>
</div>
</body>
</html>
<?php
  page_close();
?>

